MODULE Dragon_Hunter;
 <* M2EXTENSIONS + *> <* STORAGE + *> <* NOOPTIMIZE + *> <* WOFF + *>
  FROM IO IMPORT RdChar, WrChar, WrStr, RdStr, WrLn, RdKey, RdLn, RdCard, WrCard, RdInt, WrInt, RdReal, WrReal;
  FROM RealMath IMPORT sqrt, exp, sin, cos, tan, arcsin, arccos, arctan, power, round, pi;
  FROM Lib IMPORT Delay;

  FROM Windows IMPORT VK_UP, VK_DOWN, VK_LEFT, VK_RIGHT, VK_ESCAPE,VK_F1, VK_F2, VK_F3, VK_F4, VK_F5, VK_CONTROL, VK_SPACE, VK_SHIFT, SYSTEMTIME, GetLocalTime;
  FROM Wimdows IMPORT 	Window, UpdateWindow, TextBox, SetBuffering, ClearScreen, RgbColor, Line, Rectangle, Disc, Circle, SetFont, Text, TextCard, KeyDown, OnMouseLeft,
                        StopOnMouseLeft, LoadBitmap, DestroyBitmap, DrawBitmap, DrawMaskBitmap,InvertBitmap, SetPixel, getpixel, NegPolygon;
			
(*  FROM StandardSound IMPORT SoundEventEn, InitSound, PlaySoundEvent; *)


TYPE Punt = RECORD       (* Een punt in de ruimte *)
		x,y,z:REAL;
	    END;
	
     Vlak = RECORD       (* Een vlak in de ruimte van de vorm Ax+By+Cz+D=0 *)
     		A,B,C,D:REAL;
	    END;
	
     VPunt = RECORD       (* Een punt in het vlak, om gebruikt te worden voor het tekenen *)
		x,y:INTEGER;
	     END;
	
     Axis = (X,Y,Z); (* Naam van een as, gebruikt om het oproepen van bepaalde procedures te vereenvoudigen *)


     Color = RECORD       (* Een Kleur in rood,groen,blauw *)
		r,g,b:CARDINAL;
	     END;
	
     Direction = (Right,Up,Left,Down);	(* Vier richtingen, kunnen meerdere uiteenlopende functies hebben. *)
	
     SAP = POINTER TO ARRAY OF CARDINAL; (* Sprite_Array_Pointer. Dit is een pointer naar een array bevattende een afbeelding van verschillende groottes voor 3D-Weergave. *)

     PAP = POINTER TO ARRAY OF Punt; (* Pointer_Array_of_Points. Dit is een pointer naar een array van punten. *)

     PTAPAP = POINTER TO ARRAY OF PAP; (* Pointer_To_Array_of_PAP. Dit is een pointer naar een array van PAP's *)

     Meubelpoot = RECORD pcoor: PAP; pdepth: REAL; END;
     Stoelpoot = RECORD scoor: ARRAY[0..9] OF Punt; sdepth: REAL; END;         (* Hier worden aparte records voor gemaakt om deze te kunnen sorteren om te kunnen bepalen welke poot e.a. *)
     Spietsrecord = RECORD spcoor: ARRAY[0..5] OF Punt; spdepth: REAL; END;    (* Eerst moet worden getekend voor het 3D-zicht.  *)

     SpriteNames = (S_zombie,S_I_zombie,S_ghost,S_mummy,S_I_mummy,S_troll,S_I_troll,  S_tree,S_vaas,  S_pistool,S_uzi,S_shotgun,S_bazooka,  S_pistool_mod,S_uzi_mod,S_shotgun_mod,S_bazooka_mod,S_sleutel,S_healthbox,  S_Lhand,S_Rhand,S_maan,S_draak,S_I_draak);  (* Namen van alle afbeeldingen *)

     WeaponNames = (W_vuist,W_pistool,W_shotgun,W_uzi,W_bazooka);

     MonsterNames = (Tutorial_Zombie, Groene_Zombie, Rode_Zombie, Mummy, Troll);

     LType = ARRAY[0..7] OF RECORD lightno:CARDINAL; lightint:REAL; END;
	
     ObjKind=(nothing,camera,MainFloor, monster,grondzombie,tutorial,spietsen,valbal,valpijlen,healthbox, wall,tile,blok,schuifdeur, tafel,kruk,stoel,deco, ammo,kogel,explosie,wapenitem,sleutel,finish,lamp, maan,weer,tower,towertop,draak,vuurbal,bommetje); (* Alle soorten voorwerpen bepalen, nothing op de eerste plaats laten ! *)

     Object = RECORD (* Object met allerlei eigenschappen *)
	pos:Punt;    (* Positie in de ruimte *)
	depth:REAL;  (* Bepaalt de weergave-volgorde *)
	mycol:Color; (* Bepaalt de kleur van een voorwerp *)
	bbx1,bby1,bbz1,bbx2,bby2,bbz2: REAL; (* cordinaten (balk) van de "bounding box" *)
		
	 CASE kind:ObjKind OF (* Naam van het soort voorwerp *)
	
		 camera: dir,zdir,zspeed: REAL; (* Kijkrichting in radialen, (horizontaal,verticaal) volgens de goniometrische cirkel (maar dan met -y door de genverteerde y-as) *)
		         posprevious: Punt; (* Punt dat de voorgaande positie bevat van het object, nodig voor collisie-detectie. *)
			 solid: BOOLEAN; (* Bepaalt of een object al dan niet in aanmerking komt voor collisie *)
			 weaponcarrying: WeaponNames; (* Welk wapen gedragen wordt *)
			 timerweapondelay: CARDINAL; (* Timer voor het afvuren van kogels*)
                         health: INTEGER; (*  Health in punten gaande van 0 tot 1000 *)
                         timer_vuistslag, pos_vuistslag : CARDINAL ; (* bepaalt welke afbeelding van de vuist getekend moet worden e.d. *)
			 aan_het_slaan : BOOLEAN ; (* controleert of de beweging van de vuist nog actief is *)
                         placed_direction : Direction; (* In welke richting de camera kijken moet bij het begin *)
			
		|monster: monster_damaged, monster_moved, monster_gotshot:BOOLEAN;     (* monster geraakt? - om hem te laten flikkeren ; check of hij bewogen heeft ; check of hij beschoten is *)
                          monster_xspeed,monster_yspeed:REAL; monster_health:INTEGER;   (* huidige snelheid (x & y); zijn hp *)
                          monster_posprevious:Punt; monster_kind: MonsterNames;         (* voorgaande positie (collisie) ; welk monster is het ? *)
                |grondzombie: grond_timer:CARDINAL;
                |spietsen: spiets_array: ARRAY[0..4] OF Spietsrecord;   (* 4 Puntenrecords voor 4 piramiden. *)
		|MainFloor: veraf:BOOLEAN;		
		|wall: wall_direction: Direction; wall_height: REAL;    (* Naar welke richting de muur gericht is. *)
                       wall_LA: LType; maxnolt:CARDINAL;   (* Array met de lichtinformatie, no_of_lights waarmee moetworden rekening gehouden. *)
		|tile: ;
                |blok: blok_array:ARRAY[0..9] OF Punt;
                |valbal: valbal_array: PTAPAP; valbal_timer,valbal_maxtimer,valbal_delay: CARDINAL;
                         valbal_richting: Direction; valbal_beginpos: Punt; valbal_lastz,valbal_zspeed: REAL;
                |valpijlen: valpijlen_timer: CARDINAL; valpijlen_aant_schieten,valpijlen_kant: BOOLEAN;        (* kant: TRUE = x-richting, FALSE = y-richting. *)
                            valpijlen_coor: ARRAY[0..6] OF REAL;
		|kogel: wapen: WeaponNames; kxspeed,kyspeed,kzspeed,kgspeed: REAL; kdamage: CARDINAL;          (* Van welk, wapen de kogel komt, zijn snelheden, damage,... *)
		|wapenitem: wapen_type: [W_pistool..W_bazooka]; wapen_sprite: [S_pistool_mod..S_bazooka_mod];  (* Wapen dat kan worden opgeraapt. *)
                |ammo: ammo_type: [W_pistool..W_bazooka]; ammo_array : ARRAY[0..9] OF Punt; ammo_size: [1..3]; (* Munitie die kan worden opgeraapt. *)
		|tafel: tafel_blad:ARRAY[0..9] OF Punt; tafel_poten: ARRAY[0..4] OF Meubelpoot;                (* Tafel bestaande uit een balk en 4 cilinders. *)
		|kruk: kruk_blad1,kruk_blad2: PAP; kruk_poten: ARRAY[0..3] OF Meubelpoot;                      (* Kruk bestaande uit 4 cilinders. *)
                |stoel: stoel_deel: ARRAY[0..6] OF Stoelpoot;                                                  (* Stoel bestaande uit 6 balken. *)
                |deco: deco_sprite: [S_tree..S_vaas]; deco_sprite_no,deco_sprite_subimg: CARDINAL;             (* Verzamelnaam voor alle (al dan niet solid) objecten met een afbeelding (bv. een boom,...)*)
                |sleutel: ;                                                                                    (* Sleutel om deuren mee te openen. *)
		|schuifdeur: schuifdeur_touched : BOOLEAN; pos_schuifdeur: CARDINAL;                           (* Schuifdeur die open schuift. *)
                |maan: ;                                                                                       (* De maan (en sterren) als decoratie. *)
                |healthbox: healthbox_size: BOOLEAN;                                                           (* Geeft health bij. FALSE = klein, TRUE = groot.*)
                |tower: tower_array: PAP;                                                                      (* De grote toren die je kan zien vanuit de verte. *)
                |towertop: towertop_array1,towertop_array2,towertop_array3: PAP; cadeau_timer: CARDINAL;       (* De top van de toren voor het eindgevecht. *)
                |explosie: explosie_kleur_no: [0..3]; explosie_timer: CARDINAL; explosie_straal: REAL;         (* Een explosie. *)
                |weer: bliksem_timer:CARDINAL; aant_bliksemen:BOOLEAN;                                         (* Het weer op het einde: zorgt voor regen en bliksem. *)
                |tutorial: tut_timer:CARDINAL;                                                                 (* Object dat de tutorial monitort. *)
                |finish: level_done:BOOLEAN;                                                                   (* Een onzichtbare finishlijn, voor overgang naar een volgend level. *)
                |lamp: kapot,lamp_aan:BOOLEAN; lamp_timer,mijnlampno:CARDINAL; lampbol_array: PTAPAP;          (* Lampen: zorgen voor lichteffecten ! Als ze 'kapot' zijn, flikkeren ze. *)
                |draak: begin_gevecht,aant_aanvallen,draak_damaged,put_munition: BOOLEAN; (* De eindbaas "Bailor" *)
                        draak_health :INTEGER; draak_afbeelding:[0..11]; draak_hoek :REAL; aanval_modus,draak_timer:CARDINAL;
                |vuurbal: vxspeed,vyspeed,vzspeed:REAL;                                                        (* Vuurbal door de draak uitgespuwd *)
                |bommetje: bxspeed,byspeed,bzspeed:REAL;
		|nothing: ;                                                                                    (* Niets, een leeg object, dient om fouten te vermijden. *)
	
	 END;
	      END;
	
CONST SCREEN_WIDTH = 640; SCREEN_HEIGHT = SCREEN_WIDTH*3/4;	(* Hoogte en Breedte van het scherm (Basisresolutie is 640x480) *)
      MAX_FOV = 700.0; (* Maximum Field of View: Verst mogelijke afstand die gezien kan worden. (voorwerpen die zich verder van de limiet bevinden zijn onzichtbaar) *)
      GRAVITY = 0.2;   (* Sterkte Zwaartekracht *)

		
VAR ZP:ARRAY[1..4] OF Punt; 	(* Vier zichtpunten van het zichtvlak *)
    HZAFS,VZAFS,CVAFS: REAL; 	(* Horizontale Afstand (ZP[1]-ZP[2]) , Verticale Afstand (ZP[1]-ZP[3]) en Camera-ZVlak Afstand *)
    ZVLAK: Vlak; 		(* Het Zichtvlak *)
    ZN,BPUNT :Punt; 	(* normaalvector op het zichtvlak *) (* Punt met een vaste waarde, nodig voor projectieberekeningen *)

    OBJ:ARRAY[0..300] OF Object; (* De hoofdarray als lijst van alle aanwezige objecten *)

    NOO:CARDINAL;              (* "Number Of Objects" = aantal objecten bestaande op een zeker moment *)
    current_level:CARDINAL;       (* Huidig level waar de camera zich bevindt *)
    level_begin:BOOLEAN;          (* Indien het level pas is begonnen of niet *)
    cam_pos_obj:CARDINAL;         (* Plaats van de camera in OBJ. Noodzakelijk voor berekeningen omtrent weergave *)
    SPRITELIB,MASKLIB,XSA,YSA: ARRAY SpriteNames,[0..3] OF SAP; (* Adressen sprites en masks, x-waarden, y-waarden ; Tweede variabele zijn de subimages. *)

    NOL:ARRAY[0..6] OF CARDINAL; (* "Number Of Lights, analoog met NOL *)
    LIGHTARR: ARRAY[0..32] OF RECORD    (* Array met al de lampen *)
                               lpos: Punt; on:BOOLEAN;
                              END;
    Lighteffects:BOOLEAN; (* Lichteffecten aan of uit ? *)

    time1,time2: SYSTEMTIME;  (* Tijdsmetingen voor de "smart delay" *)
    mydelay : CARDINAL;  (* Bepaling Lengte Delay *)
    general_timer: [0..60]; (* Timerwaarde van het spel, cyclus gaande van 0 tot 60 zich heralende elke seconde, gebruikt voor periodische dingen in het spel. *)

    weaponposessing: ARRAY[W_pistool..W_bazooka] OF BOOLEAN; (* Lijst van welke wapens in bezit zijn en welke niet *)
    no_of_bullets: ARRAY[W_pistool..W_bazooka] OF CARDINAL;  (* Hoeveel van welke kogels de speler er heeft *)
    no_of_sleutels: CARDINAL; (* Aantal Sleutels *)

    SaveGameArray: ARRAY[0..10] OF CARDINAL; (* Arrays met allerlei waarden voor het opslaan van het spel *)
    SaveGameArrayB: ARRAY[W_pistool..W_bazooka] OF BOOLEAN;
    situatie,SPR1,SPR2: CARDINAL; (* Voor de tutorial en voor de introductie *)
    notquitted,parameter,net_game_over: BOOLEAN; (* Indien gekozen werd voor "quit" of niet, parameter om actie uit te voeren, check of het net game over was. *)


(* semi-constanten *)
    weapondelays: ARRAY WeaponNames OF CARDINAL; (* Duur tussen twee kogels *)
    bullets_in_new_weapon: ARRAY[W_pistool..W_bazooka] OF CARDINAL; (* munitie in een nieuw wapen *)
    bullets_in_mun_box: ARRAY[1..3],[W_pistool..W_bazooka] OF CARDINAL; (* aantal kogels in munitiedoos (grootte 1,2 of 3) *)
    level_limitsB,level_limitsE: ARRAY[X..Y],[0..6] OF REAL; (* grenzen van de levels (Begin , Einde ) *)
    sterren_array: ARRAY[0..31] OF Punt; (* Positie van de sterren aan de hemel *)
    mountains_array: ARRAY[0..5] OF ARRAY[0..7] OF INTEGER;
    rain_array: ARRAY[1..250] OF Punt;
    LED: ARRAY[0..6] OF BOOLEAN; (* Light Effect Data: is er licht in een kamer of niet ? *)
    monster_data: ARRAY MonsterNames OF RECORD
                                         Msight,Mwalkspeed: REAL;
                                         Mpower,Mmaxhp: INTEGER;
                                         Msprite, Minvsprite: SpriteNames;
                                         Msubimg: CARDINAL;
                                        END;


(* Geeft een Random Cardinal tussen 0 en n. Een aantal variabelen moeten onveranderd blijven, en worden dus in een lokale module gestopt. *)
MODULE Localmod;
 IMPORT time1,Color,SetFont,RgbColor,Text,NOL;  EXPORT random, set_message, show_message;
 VAR gSeed,timer,messg_font:CARDINAL; messg_content: ARRAY[0..127] OF CHAR; messg_color:Color;

	PROCEDURE random(n: CARDINAL): CARDINAL;
	 VAR factor: REAL;
	BEGIN
	    factor := (FLOAT(n) + 0.99999) / FLOAT(1012);
	    gSeed := (gSeed * 351 + time1.wMilliseconds) MOD 1013;
	        RETURN TRUNC(FLOAT(gSeed) * factor);
	END random;


        (* Tekst weergeven als een bericht in het spel.
           Messg = het bericht, nsteps = aantal stappen van de duur van het bericht (in 25 ms), font = fonttype, col = kleur *)

	PROCEDURE set_message(M:ARRAY OF CHAR; nsteps,font: CARDINAL; col:Color);
        VAR i:CARDINAL;
	BEGIN
         timer := nsteps; messg_content:=""; messg_color:=col; messg_font:=font; FOR i:=0 TO LENGTH(M) DO messg_content[i] := M[i]; END;
	END set_message;

        PROCEDURE show_message;
	BEGIN
         IF timer#0 THEN SetFont(messg_font,RgbColor(messg_color.r,messg_color.g,messg_color.b)); Text(messg_content,2,2); timer:=timer-1; END;
	END show_message;

BEGIN
 gSeed:=0; timer:=0;
END Localmod;


(* Bepaalde objecten hebben pointers als variabelen. Deze procedure zorgt ervoor dat deze worden ge'disposed'
   g: geef 0 in voor alle (resterende objecten), anders n getal voor n specifiek object bij zijn verwijdering. *)
PROCEDURE dispose_obj_vars(g:CARDINAL);
VAR i,min,max,j:CARDINAL;
BEGIN

 IF g = 0 THEN min := 1; max := NOO;
 ELSE min := g; max:= g;
 END;

 FOR i:=min TO max DO
  WITH OBJ[i] DO
   CASE kind OF
    |tafel: FOR j:=1 TO 4 DO DISPOSE(tafel_poten[j].pcoor); END;
    |kruk: FOR j:=1 TO 3 DO DISPOSE(kruk_poten[j].pcoor); END; DISPOSE(kruk_blad1); DISPOSE(kruk_blad2);
    |valbal: FOR j:=0 TO HIGH(valbal_array^) DO DISPOSE(valbal_array^[j]); END; DISPOSE(valbal_array);
    |tower: DISPOSE(tower_array);
   ELSE ;
   END;
  END;
 END;

END dispose_obj_vars;


(* Deze functie slaat/laadt het spel (TRUE = opslaan, FALSE = laden) )*)
PROCEDURE save_and_load(N:BOOLEAN);
BEGIN

  IF N THEN
    (* SaveGameArray[0] := current_level; *)
    SaveGameArray[1] := OBJ[cam_pos_obj].health;

    SaveGameArrayB[W_pistool] := weaponposessing[W_pistool];
    SaveGameArrayB[W_shotgun] := weaponposessing[W_shotgun];
    SaveGameArrayB[W_uzi] := weaponposessing[W_uzi];
    SaveGameArrayB[W_bazooka] := weaponposessing[W_bazooka];

    SaveGameArray[2] := no_of_bullets[W_pistool];
    SaveGameArray[3] := no_of_bullets[W_shotgun];
    SaveGameArray[4] := no_of_bullets[W_uzi];
    SaveGameArray[5] := no_of_bullets[W_bazooka];

    SaveGameArray[6] := no_of_sleutels;

    (* ... *)

  ELSE

   (* current_level := SaveGameArray[0]; *)
   OBJ[cam_pos_obj].health := SaveGameArray[1];
   IF OBJ[cam_pos_obj].health < 250 THEN OBJ[cam_pos_obj].health := 250 END;

   weaponposessing[W_pistool] := SaveGameArrayB[W_pistool];
   weaponposessing[W_shotgun] := SaveGameArrayB[W_shotgun];
   weaponposessing[W_uzi]     := SaveGameArrayB[W_uzi];
   weaponposessing[W_bazooka] := SaveGameArrayB[W_bazooka];

   no_of_bullets[W_pistool] := SaveGameArray[2];
   IF (no_of_bullets[W_pistool] < 24) AND weaponposessing[W_pistool] THEN no_of_bullets[W_pistool] := 24 END;
   no_of_bullets[W_shotgun] := SaveGameArray[3];
   no_of_bullets[W_uzi] := SaveGameArray[4];
   no_of_bullets[W_bazooka] := SaveGameArray[5];

   no_of_sleutels := SaveGameArray[6];

  END;

END save_and_load;	

(*===================================================================*)
(* D3DFUNC : Functies voor het manipuleren van de Euclidische Ruimte.*)
(*===================================================================*)

(* Punt maken van 3 cordinaten *)
PROCEDURE MPT(X,Y,Z:REAL):Punt;
VAR pt: Punt;
BEGIN

 WITH pt DO
  x:=X;
  y:=Y;
  z:=Z;
 END;

 RETURN pt;

END MPT;

(* VPunt maken van 2 cordinaten *)
PROCEDURE MVPT(X,Y:INTEGER):VPunt;
VAR pt: VPunt;
BEGIN

 WITH pt DO
  x:=X;
  y:=Y;
 END;

 RETURN pt;
END MVPT;

(* Houdt de waarde van een hoek steeds tussen 0 en 2*pi om berekeningen te vereenvoudigen en precisiefouten te vermijden. *)
PROCEDURE beperk_hoek(x:REAL):REAL;
BEGIN

 IF x>2.0*pi THEN RETURN x-2.0*pi;
 ELSIF x<0.0 THEN RETURN x+2.0*pi;
 ELSE RETURN x; END;

END beperk_hoek;

(* Bepaalt of een hoek zich tussen twee andere hoeken bevindt, tegenklokwijszin. *)
PROCEDURE tussen_hoek(h,min,max:REAL):BOOLEAN;
BEGIN
  min:=beperk_hoek(min); max:=beperk_hoek(max);
 IF min<max THEN
  IF (h>=min) AND (h<=max) THEN RETURN TRUE; ELSE RETURN FALSE; END;
 ELSE
  IF (h>=min) OR (h<=max) THEN RETURN TRUE; ELSE RETURN FALSE; END;
 END;

END tussen_hoek;

(* Kwadraat *)
PROCEDURE sqr(x:REAL):REAL;
BEGIN
  RETURN x*x;
END sqr;

(* Absolute Waarde *)
PROCEDURE abs(x:REAL):REAL;
BEGIN
  IF x<0.0 THEN RETURN -x ELSE RETURN x END;
END abs;


(* rotatie om een as *)
PROCEDURE rot_axis(VAR vect: Punt; ax: Axis; am: REAL);
VAR a: REAL;
BEGIN


 IF ax=X THEN

      a:=vect.y*cos(am)-vect.z*sin(am);
 vect.z:=vect.y*sin(am)+vect.z*cos(am);
 vect.y:=a;

 ELSIF ax=Y THEN

      a:=vect.z*cos(am)-vect.x*sin(am);
 vect.x:=vect.z*sin(am)+vect.x*cos(am);
 vect.z:=a;

 ELSIF ax=Z THEN

      a:=vect.x*cos(am)-vect.y*sin(am);
 vect.y:=vect.x*sin(am)+vect.y*cos(am);
 vect.x:=a;

 END;

END rot_axis;

(* rotatie van vect om point volgens een as*)
PROCEDURE rot_point(VAR vect:Punt; point: Punt; ax: Axis; am: REAL);
BEGIN

 WITH vect DO
  x:=x-point.x;
  y:=y-point.y;
  z:=z-point.z;
 END;

 rot_axis(vect,ax,am);

 WITH vect DO
  x:=x+point.x;
  y:=y+point.y;
  z:=z+point.z;
 END;

END rot_point;

(* homothetie met de oorsprong*)
PROCEDURE scale_o(VAR vect: Punt; am: REAL);
BEGIN

 WITH vect DO
 	x:=x*am;
	y:=y*am;
	z:=z*am;
 END;

END scale_o;

(* homothetie om een punt*)
PROCEDURE scale_point(VAR vect: Punt; point: Punt; am: REAL);
BEGIN

 WITH vect DO
 	x:=x-point.x; x:=x*am; x:=x+point.x;
	y:=y-point.y; y:=y*am; y:=y+point.y;
	z:=z-point.z; z:=z*am; z:=z+point.z;
 END;

END scale_point;

(* vgl van het vlak [Ax+By+Cz+D=0] adhv 3 punten *)
PROCEDURE ber_vlak_3pt(pt1,pt2,pt3: Punt):Vlak;
VAR vl: Vlak;
BEGIN

  vl.A := (pt1.y-pt2.y)*(pt1.z-pt3.z)-(pt1.z-pt2.z)*(pt1.y-pt3.y);
  vl.B := (pt1.z-pt2.z)*(pt1.x-pt3.x)-(pt1.x-pt2.x)*(pt1.z-pt3.z);
  vl.C := (pt1.x-pt2.x)*(pt1.y-pt3.y)-(pt1.y-pt2.y)*(pt1.x-pt3.x);
  vl.D := -vl.A*pt1.x-vl.B*pt1.y-vl.C*pt1.z;

 RETURN vl;
END ber_vlak_3pt;


(* Deze procedure projecteert een punt op het zichtvlak (van de vorm Ax+By+Cz+D=0) van de camera (CAM)
   Dit is gewoon het snijpunt van de rechte gevormd door de twee punten en een vlak. *)
PROCEDURE main_proj(pt,cam: Punt; vl: Vlak):Punt;
VAR n:REAL;
BEGIN

  n:=vl.A*(cam.x-pt.x)+vl.B*(cam.y-pt.y)+vl.C*(cam.z-pt.z);

  IF n=0.0 THEN RETURN BPUNT; (* Het kan gebeuren dat de rechte evenwijdig is met het vlak. In dat geval wordt een punt teruggegeven dat nooit binnen het zichtvlak kan liggen *)
  ELSE
  n:=(vl.D+vl.A*pt.x+vl.B*pt.y+vl.C*pt.z)/(-abs(n));   (* zonder de absolute waarde ontstaan er vreemde fenomenen wanneer een veelhoek zich deels voor en deels achter de camera bevindt. *)
   RETURN MPT(pt.x+(cam.x-pt.x)*n,pt.y+(cam.y-pt.y)*n,pt.z+(cam.z-pt.z)*n )
  END;

END main_proj;


(* Afstand Punt - Punt *)
PROCEDURE afs_punt_punt(pt1,pt2: Punt):REAL;

BEGIN

  RETURN sqrt( sqr(pt2.x-pt1.x)+sqr(pt2.y-pt1.y)+sqr(pt2.z-pt1.z) )

END afs_punt_punt;

(* Afstand Punt (pt0) - Rechte (beschreven door pt1 en pt2) *)
PROCEDURE afs_punt_rechte(pt0,pt1,pt2: Punt):REAL;

BEGIN

  RETURN sqrt( sqr( pt0.y*(pt2.z-pt1.z)+pt1.y*(pt0.z-pt2.z)+pt2.y*(pt1.z-pt0.z) ) + sqr( pt0.x*(pt1.z-pt2.z)+pt1.x*(pt2.z-pt0.z)+pt2.x*(pt0.z-pt1.z) ) + sqr( pt0.x*(pt2.y-pt1.y)+pt1.x*(pt0.y-pt2.y)+pt2.x*(pt1.y-pt0.y) ) ) / sqrt( sqr(pt2.x-pt1.x)+sqr(pt2.y-pt1.y)+sqr(pt2.z-pt1.z) );

END afs_punt_rechte;

(* Afstand Punt - Vlak *)
PROCEDURE afs_punt_vlak(pt: Punt; vl: Vlak):REAL;

BEGIN

  RETURN abs(vl.A*pt.x+vl.B*pt.y+vl.C*pt.z+vl.D)/sqrt(sqr(vl.A)+sqr(vl.B)+sqr(vl.C))

END afs_punt_vlak;

(* Scalair Vermenigvuldiging van een vector met een constante *)
PROCEDURE scal_verm(p:Punt;c:REAL):Punt;
BEGIN

  RETURN MPT(p.x*c,p.y*c,p.z*c);

END scal_verm;

(* Scalair Product *)
PROCEDURE scal_prod(a,b:Punt):REAL;
BEGIN

  RETURN (a.x*b.x+a.y*b.y+a.z*b.z);

END scal_prod;

(* Vectorieel Product *)
PROCEDURE vect_prod(a,b:Punt):Punt;
BEGIN

  RETURN MPT(a.y*b.z-a.z*b.y,a.z*b.x-a.x*b.z,a.x*b.y-a.y*b.x);

END vect_prod;

(* Vectoriele Som *)
PROCEDURE vect_som(a,b:Punt):Punt;
BEGIN

  RETURN MPT(a.x+b.x,a.y+b.y,a.z+b.z);

END vect_som;

(* Omgekeerde van een vector *)
PROCEDURE vect_neg(a:Punt):Punt;
BEGIN

 RETURN MPT(-a.x,-a.y,-a.z);

END vect_neg;

(* Norm van een vector *)
PROCEDURE norm(a:Punt):REAL;
BEGIN

 RETURN sqrt(scal_prod(a,a));

END norm;

(* Bepaalt de normaalvector op het zichtvlak *)
PROCEDURE bepaal_normaal;
BEGIN

 ZN:=vect_prod(vect_som(ZP[2],vect_neg(ZP[1])),vect_som(ZP[3],vect_neg(ZP[1])));
 ZN:=scal_verm(ZN,1.0/norm(ZN));

END bepaal_normaal;

(* Een punt (M) tussen twee punten (A & B) bepalen met als factor (f) de verhouding van lengte AM tot MB (bv: 1 voor het midden) *)
PROCEDURE punt_midden(a,b:Punt;f:REAL):Punt;
BEGIN
 RETURN MPT((f*a.x+b.x)/(f+1.0),(f*a.y+b.y)/(f+1.0),(f*a.z+b.z)/(f+1.0));
END punt_midden;

(* bepaalt de richting van punt1 naar punt2 *)
PROCEDURE point_direction(x1,y1,x2,y2:REAL):REAL;
BEGIN

 IF y1>y2 THEN
  IF x1<x2 THEN RETURN (arctan((y1-y2)/(x2-x1)));
  ELSIF x1>x2 THEN RETURN (pi+arctan((y1-y2)/(x2-x1)));
  ELSE RETURN (pi/2.0);
  END;
 ELSIF y1<y2 THEN
  IF x1<x2 THEN RETURN (2.0*pi-arctan((y2-y1)/(x2-x1)));
  ELSIF x1>x2 THEN RETURN (pi+arctan((y2-y1)/(x1-x2)));
  ELSE RETURN (3.0*pi/2.0);
  END;
 ELSE
  IF x1<=x2 THEN RETURN 0.0;
  ELSE RETURN pi;
  END;
 END;
END point_direction;
(*==================================================================*)
(* D3DWGV : Functies om de speelomgeving te weergeven op het scherm.*)
(*==================================================================*)

(* Kleur maken van rood,groen en blauw *)
PROCEDURE MRGB(R,G,B:CARDINAL):Color;
VAR col: Color;
BEGIN

 WITH col DO
  r:=R;
  g:=B;    (* Vreemd genoeg worden groen en blauw in Wimdows omgewisseld. Ik doe dit hier dus ook.*)
  b:=G;
 END;

 RETURN col;

END MRGB;


(* Punt tekenen met een bepaalde kleur in het vlak *)
PROCEDURE NPlot(pt:VPunt;col:Color);
BEGIN

 SetPixel(pt.x,pt.y,RgbColor(col.r,col.g,col.b));

END NPlot;

(* Mixt een kleur met de achtergrond in verhouding 50-50, en tekent die. *)
PROCEDURE blend_color(x,y:CARDINAL;col:Color);
VAR mcl,R,G,B: CARDINAL;
BEGIN

mcl := getpixel(x,y); R:=mcl MOD 256; B:=(mcl/100H) MOD 256; G:=(mcl/10000H) MOD 256;
SetPixel(x,y,RgbColor((R+col.r)/2,(B+col.b)/2,(G+col.g)/2));

END blend_color;

(* converteert een real naar een integer maar beperkt deze indien het te groot wordt *)
PROCEDURE convert_RtoI(x:REAL):INTEGER;
BEGIN
 IF x>2.1E9 THEN RETURN 2140000000;
 ELSIF x<-2.1E9 THEN RETURN -2140000000;
 ELSE RETURN VAL(INTEGER,x); END;
END convert_RtoI;

(* Detecteert een punt op het Zichtvlak en geeft ze terug als een punt in het Vlak*)
PROCEDURE proj_coord(s:Punt):VPunt;

VAR pt:Punt; ept:VPunt;
    HL,HR,VU,VD:REAL;

BEGIN
pt:=main_proj(s,OBJ[cam_pos_obj].pos,ZVLAK);



 IF pt.x=BPUNT.x THEN
  RETURN MVPT(-10000,-10000); (* zie main_proj *)
 END;

 HL := afs_punt_rechte(pt,ZP[1],ZP[3]);
 HR := afs_punt_rechte(pt,ZP[2],ZP[4]);
 VU := afs_punt_rechte(pt,ZP[1],ZP[2]);
 VD := afs_punt_rechte(pt,ZP[3],ZP[4]);

IF HL<HR THEN
 ept.x := convert_RtoI((1.0-HR/HZAFS)*FLOAT(SCREEN_WIDTH));
ELSE
 ept.x := convert_RtoI((HL/HZAFS)*FLOAT(SCREEN_WIDTH));
END;

IF VU<VD THEN
 ept.y := convert_RtoI((1.0-VD/VZAFS)*FLOAT(SCREEN_HEIGHT));
ELSE
 ept.y := convert_RtoI((VU/VZAFS)*FLOAT(SCREEN_HEIGHT));
END;

RETURN ept;

END proj_coord;


(* Tekent een driehoek, rekening houdend met de mogelijkheid van negatieve cordinaten *)
PROCEDURE draw_triangle(a,b,c:VPunt;col:Color;full:CARDINAL);
VAR xA,yA:ARRAY[0..3] OF INTEGER;
BEGIN

 IF ( ((a.x>=0) OR (b.x>=0) OR (c.x>=0)) AND ((a.y>=0) OR (b.y>=0) OR (c.y>=0)) AND ((a.x<=SCREEN_WIDTH) OR (b.x<=SCREEN_WIDTH) OR (c.x<=SCREEN_WIDTH)) AND ((a.y<=SCREEN_HEIGHT) OR (b.y<=SCREEN_HEIGHT) OR (c.y<=SCREEN_HEIGHT)) ) THEN

   xA[0]:=a.x; yA[0]:=a.y;
   xA[1]:=b.x; yA[1]:=b.y;
   xA[2]:=c.x; yA[2]:=c.y;
   xA[3]:=xA[0]; yA[3]:=yA[0];

  IF full=0 THEN (* 0: Rand , 1:Gevuld , 2:Gevuld met Donkere Rand *)
  NegPolygon(3,xA,yA,RgbColor(col.r,col.g,col.b),FALSE);
  ELSE
  NegPolygon(3,xA,yA,RgbColor(col.r,col.g,col.b),TRUE);
   IF full=2 THEN NegPolygon(3,xA,yA,RgbColor(col.r*3/4,col.g*3/4,col.b*3/4),FALSE) END;
  END;

 END;

END draw_triangle;


(* Geeft een driehoek weer uit de ruimte *)
PROCEDURE draw_poly3(a,b,c:Punt; col:Color; full:CARDINAL; doubleside:BOOLEAN);
VAR d,e,f:VPunt;  av,bv,cv:Punt;
BEGIN

  av := vect_som(a,vect_neg(OBJ[cam_pos_obj].pos));
  bv := vect_som(b,vect_neg(OBJ[cam_pos_obj].pos));  (* Vermijden dat de procedure tweemaal wordt opgeroepen *)
  cv := vect_som(c,vect_neg(OBJ[cam_pos_obj].pos));

   (* Controleert of de figuur binnen het gezichtsveld ligt, anders moet deze niet worden getekend. *)
 IF ( (scal_prod(ZN,av)/(norm(av))) <= -0.4) OR ( (scal_prod(ZN,bv)/(norm(bv))) <= -0.4) OR ( (scal_prod(ZN,cv)/(norm(cv))) <= -0.4) THEN
   d:=proj_coord(a); e:=proj_coord(b); f:=proj_coord(c);
  (* Deze voorwaarde controleert indien de driehoek met zijn achterkant naar de camera gericht is.
     In dat geval moet de driehoek niet worden getekend, want hij is toch niet zichtbaar, dus dit
     bespaart rekentijd. Dit wordt genegeerd als "doubleside" TRUE is.*)
  IF ( ((FLOAT(e.x)-FLOAT(d.x))*(FLOAT(f.y)-FLOAT(d.y))-(FLOAT(e.y)-FLOAT(d.y))*(FLOAT(f.x)-FLOAT(d.x)))>0.00 ) OR doubleside THEN
    draw_triangle(d,e,f,col,full);
  END;
 END;

END draw_poly3;

(* Tekent serien driehoeken via een array van punten. *)
PROCEDURE smart_seq3(A:ARRAY OF Punt; type,full:CARDINAL; col:Color; doubleside:BOOLEAN);
VAR i:CARDINAL;
BEGIN
 CASE type OF

  0: FOR i:=0 TO (HIGH(A)-2)/3 DO draw_poly3(A[3*i],A[3*i+1],A[3*i+2],col,full,doubleside) END;|
    (* Tekent opeenvolgend driehoeken achtereen in groepen van 3 punten *)

  1: FOR i:=0 TO (HIGH(A)-2) DO draw_poly3(A[i],A[i+1],A[i+2],col,full,doubleside) END;|
    (* Tekent driehoeken met elke volgende driehoek bestaande uit de twee laatste punten van de voorgaande *)

  2: FOR i:=0 TO (HIGH(A)-2) DO draw_poly3(A[0],A[i+1],A[i+2],col,full,doubleside) END;
    (* Tekent opeenvolgend driehoeken met een gemeenschappelijk beginpunt *)
  END;
END smart_seq3;


(* Tekent een vierhoek, rekening houdend met de mogelijkheid van negatieve cordinaten *)
PROCEDURE draw_quadrangle(a,b,c,d:VPunt;col:Color;full:CARDINAL);
VAR xA,yA:ARRAY[0..4] OF INTEGER;
BEGIN

 IF ( ((a.x>=0) OR (b.x>=0) OR (c.x>=0) OR (d.x>=0)) AND ((a.y>=0) OR (b.y>=0) OR (c.y>=0) OR (d.y>=0)) AND ((a.x<=SCREEN_WIDTH) OR (b.x<=SCREEN_WIDTH) OR (c.x<=SCREEN_WIDTH) OR (d.x<=SCREEN_WIDTH)) AND ((a.y<=SCREEN_HEIGHT) OR (b.y<=SCREEN_HEIGHT) OR (c.y<=SCREEN_HEIGHT) OR (d.y<=SCREEN_HEIGHT)) ) THEN

   xA[0]:=a.x; yA[0]:=a.y;
   xA[1]:=b.x; yA[1]:=b.y;
   xA[2]:=c.x; yA[2]:=c.y;
   xA[3]:=d.x; yA[3]:=d.y;
   xA[4]:=xA[0]; yA[4]:=yA[0];

  IF full=0 THEN (* 0: Rand , 1:Gevuld , 2:Gevuld met Donkere Rand *)
  NegPolygon(4,xA,yA,RgbColor(col.r,col.g,col.b),FALSE);
  ELSE
  NegPolygon(4,xA,yA,RgbColor(col.r,col.g,col.b),TRUE);
   IF full=2 THEN NegPolygon(4,xA,yA,RgbColor(col.r*3/4,col.g*3/4,col.b*3/4),FALSE) END;
  END;

 END;

END draw_quadrangle;


(* Geeft een vierhoek weer uit de ruimte *)
PROCEDURE draw_poly4(a,b,c,d:Punt; col:Color; full:CARDINAL; doubleside:BOOLEAN);
VAR e,f,g,h:VPunt;  av,bv,cv,dv:Punt;
BEGIN

  av := vect_som(a,vect_neg(OBJ[cam_pos_obj].pos));                       (* OBJ[cam_pos_obj].pos *)
  bv := vect_som(b,vect_neg(OBJ[cam_pos_obj].pos));  (* Vermijden dat de procedure tweemaal wordt opgeroepen *)
  cv := vect_som(c,vect_neg(OBJ[cam_pos_obj].pos));
  dv := vect_som(d,vect_neg(OBJ[cam_pos_obj].pos));

  (* Controleert of de figuur binnen het gezichtsveld ligt, anders moet deze niet worden getekend. *)
IF ( (scal_prod(ZN,av)/norm(av)) <= -0.4) OR ( (scal_prod(ZN,bv)/norm(bv)) <= -0.4) OR ( (scal_prod(ZN,cv)/norm(cv)) <= -0.4) OR ( (scal_prod(ZN,dv)/norm(dv)) <= -0.4) THEN
   e:=proj_coord(a); f:=proj_coord(b); g:=proj_coord(c); h:=proj_coord(d);
  (* Deze voorwaarde controleert indien de vierhoek met zijn achterkant naar de camera gericht is.
     In dat geval moet de driehoek niet worden getekend, want hij is toch niet zichtbaar, dus dit
     bespaart rekentijd. Dit wordt genegeerd als "doubleside" TRUE is.*)
  IF (( (FLOAT(f.x)-FLOAT(e.x))*(FLOAT(g.y)-FLOAT(e.y))-(FLOAT(f.y)-FLOAT(e.y))*(FLOAT(g.x)-FLOAT(e.x)) )>0.0 ) OR doubleside THEN
    draw_quadrangle(e,f,h,g,col,full);
  END;
END;

END draw_poly4;

(* Tekent serien vierhoeken via een array van punten. *)
PROCEDURE smart_seq4(A:ARRAY OF Punt; type,full:CARDINAL; col:Color; doubleside:BOOLEAN);
VAR i:CARDINAL;
BEGIN
 CASE type OF

  0: FOR i:=0 TO (HIGH(A)-3)/4 DO draw_poly4(A[4*i],A[4*i+1],A[4*i+2],A[4*i+3],col,full,doubleside) END;|
    (* Tekent opeenvolgend vierhoeken achtereen in groepen van 4 punten *)

  1: FOR i:=0 TO (HIGH(A)-3)/2 DO draw_poly4(A[2*i],A[2*i+1],A[2*i+2],A[2*i+3],col,full,doubleside) END;|
    (* Tekent vierhoeken met elke volgende vierhoek bestaande uit de twee laatste punten van de voorgaande *)
  END;
END smart_seq4;


(* Tekent een cirkel of schijf, met evt. negatieve cordinaten. *)
PROCEDURE draw_disc(a:VPunt;r:CARDINAL;col:Color;full:CARDINAL);
BEGIN

 IF ( (a.x+VAL(INTEGER,r)>=0) AND (a.y+VAL(INTEGER,r)>=0) AND (a.x-VAL(INTEGER,r)<=SCREEN_WIDTH) AND (a.y-VAL(INTEGER,r)<=SCREEN_HEIGHT) ) THEN

  IF full=0 THEN (* 0: Rand , 1:Gevuld , 2:Gevuld met Donkere Rand *)
  Circle(a.x,a.y,r,RgbColor(col.r,col.g,col.b));
  ELSE
  Disc(a.x,a.y,r,RgbColor(col.r,col.g,col.b));
   IF full=2 THEN Circle(a.x,a.y,r,RgbColor(col.r*3/4,col.g*3/4,col.b*3/4)); END;
  END;

 END;

END draw_disc;

(* Tekent een bal (als gevulde cirkel) in de ruimte *)
PROCEDURE draw_ball(pt:Punt;r,depth:REAL;col:Color;full:CARDINAL);
VAR v: Punt; N: REAL;
BEGIN

 v := vect_som(pt,vect_neg(OBJ[cam_pos_obj].pos)); N := norm(v); (* Vermijden dat de procedure tweemaal wordt opgeroepen *)
 IF (depth>=1.0) AND (N>0.0) AND ( (scal_prod(ZN,v)/norm(v)) <= -0.3) THEN
  draw_disc(proj_coord(pt),TRUNC(r*FLOAT(SCREEN_WIDTH)/32.0/depth),col,full);
 END;

END draw_ball;

(* Tekent een lijnstuk, met evt. negatieve cordinaten. *)
PROCEDURE draw_line_plane(a,b:VPunt;col:Color);
BEGIN

 IF ( ((a.x>=0) OR (b.x>=0)) AND ((a.y>=0) OR (b.y>=0)) AND ((a.x<=SCREEN_WIDTH) OR (b.x<=SCREEN_WIDTH)) AND ((a.y<=SCREEN_HEIGHT) OR (b.y<=SCREEN_HEIGHT)) ) THEN

  Line(a.x,a.y,b.x,b.y,RgbColor(col.r,col.g,col.b));

 END;

END draw_line_plane;

(* Tekent een lijnstuk in de ruimte *)
PROCEDURE draw_line(a,b:Punt;col:Color);
BEGIN

  draw_line_plane(proj_coord(a),proj_coord(b),col);

END draw_line;

(* Plaatst de zichtpunten (afhankelijk van de positie van de camera, een object waarvan de positie C in OBJ[n] moet
   voor worden ingegeven), berekent HZAFS, VZAFS, CVAFS en ZVLAK. *)
PROCEDURE place_campoints(D:Direction):REAL;
VAR t:REAL;
BEGIN
  CASE D OF
    Right: ZP[1]:=MPT(OBJ[cam_pos_obj].pos.x+64.0,OBJ[cam_pos_obj].pos.y-48.0,OBJ[cam_pos_obj].pos.z+36.0);
           ZP[2]:=MPT(OBJ[cam_pos_obj].pos.x+64.0,OBJ[cam_pos_obj].pos.y+48.0,OBJ[cam_pos_obj].pos.z+36.0);
           ZP[3]:=MPT(OBJ[cam_pos_obj].pos.x+64.0,OBJ[cam_pos_obj].pos.y-48.0,OBJ[cam_pos_obj].pos.z-36.0); t:=0.0;
   |Up:    ZP[1]:=MPT(OBJ[cam_pos_obj].pos.x-48.0,OBJ[cam_pos_obj].pos.y-64.0,OBJ[cam_pos_obj].pos.z+36.0);
           ZP[2]:=MPT(OBJ[cam_pos_obj].pos.x+48.0,OBJ[cam_pos_obj].pos.y-64.0,OBJ[cam_pos_obj].pos.z+36.0);
           ZP[3]:=MPT(OBJ[cam_pos_obj].pos.x-48.0,OBJ[cam_pos_obj].pos.y-64.0,OBJ[cam_pos_obj].pos.z-36.0); t:=pi/2;
   |Left:  ZP[1]:=MPT(OBJ[cam_pos_obj].pos.x-64.0,OBJ[cam_pos_obj].pos.y+48.0,OBJ[cam_pos_obj].pos.z+36.0);
           ZP[2]:=MPT(OBJ[cam_pos_obj].pos.x-64.0,OBJ[cam_pos_obj].pos.y-48.0,OBJ[cam_pos_obj].pos.z+36.0);
           ZP[3]:=MPT(OBJ[cam_pos_obj].pos.x-64.0,OBJ[cam_pos_obj].pos.y+48.0,OBJ[cam_pos_obj].pos.z-36.0); t:=pi;
   |Down:  ZP[1]:=MPT(OBJ[cam_pos_obj].pos.x+48.0,OBJ[cam_pos_obj].pos.y+64.0,OBJ[cam_pos_obj].pos.z+36.0);
           ZP[2]:=MPT(OBJ[cam_pos_obj].pos.x-48.0,OBJ[cam_pos_obj].pos.y+64.0,OBJ[cam_pos_obj].pos.z+36.0);
           ZP[3]:=MPT(OBJ[cam_pos_obj].pos.x+48.0,OBJ[cam_pos_obj].pos.y+64.0,OBJ[cam_pos_obj].pos.z-36.0); t:=3*pi/2;
  END;

  ZP[4] := vect_som(ZP[2], vect_som(ZP[3],vect_neg(ZP[1])) );
  bepaal_normaal;
  ZVLAK:=ber_vlak_3pt(ZP[1],ZP[2],ZP[3]);
  HZAFS:=afs_punt_punt(ZP[1],ZP[2]);
  VZAFS:=afs_punt_punt(ZP[1],ZP[3]);
  CVAFS:=afs_punt_vlak(OBJ[cam_pos_obj].pos,ZVLAK);
  RETURN t;

END place_campoints;

PROCEDURE draw_mountains(xdev:REAL;y:INTEGER;no:CARDINAL);
VAR xA,yA:ARRAY[0..7] OF INTEGER; VAR x:INTEGER; i:CARDINAL;
BEGIN

IF tussen_hoek(OBJ[cam_pos_obj].dir,xdev-pi/2,xdev+pi/2) THEN

 x:=VAL(INTEGER,SCREEN_WIDTH*(sin(OBJ[cam_pos_obj].dir-xdev)+0.5));

 FOR i:=0 TO 7 DO
  xA[i]:=mountains_array[2*no][i]+x;
  yA[i]:=mountains_array[2*no+1][i]+y;
 END;

 NegPolygon(7,xA,yA,RgbColor(89,135,149),TRUE);

END;

END draw_mountains;

(*=========================================*)
(* MODELLEN : 3D-modellen voor spelgebruik *)
(*=========================================*)

(* Berkent de kubus, z voor lengte zijde. *)
PROCEDURE calc_mod_cuboid(VAR Arr:ARRAY OF Punt; pt:Punt; wx,wy,wz:REAL);
BEGIN

 Arr[0]:=MPT(pt.x-wx/2.0,pt.y+wy/2.0,pt.z-wz/2.0); Arr[1]:=MPT(pt.x-wx/2.0,pt.y+wy/2.0,pt.z+wz/2.0);
 Arr[2]:=MPT(pt.x+wx/2.0,pt.y+wy/2.0,pt.z-wz/2.0); Arr[3]:=MPT(pt.x+wx/2.0,pt.y+wy/2.0,pt.z+wz/2.0);
 Arr[4]:=MPT(pt.x+wx/2.0,pt.y-wy/2.0,pt.z-wz/2.0); Arr[5]:=MPT(pt.x+wx/2.0,pt.y-wy/2.0,pt.z+wz/2.0);
 Arr[6]:=MPT(pt.x-wx/2.0,pt.y-wy/2.0,pt.z-wz/2.0); Arr[7]:=MPT(pt.x-wx/2.0,pt.y-wy/2.0,pt.z+wz/2.0);
 Arr[8]:=Arr[0]; Arr[9]:=Arr[1];

END calc_mod_cuboid;


(* Tekent een kubus. Punt opgeven voor centrum. *)
PROCEDURE draw_mod_cuboid(Arr:ARRAY OF Punt;col:Color);
BEGIN

 draw_poly4(Arr[3],Arr[1],Arr[5],Arr[7],col,1,FALSE);
 smart_seq4(Arr,1,2,col,FALSE);

END draw_mod_cuboid;



(* Berekent de kegel. Punt opgeven voor midden grondvlak, z voor lengte vierkant grondvlak, h voor hoogte. *)
PROCEDURE calc_mod_pyramid(VAR Arr:ARRAY OF Punt; pt:Punt; z,h:REAL);
BEGIN

 Arr[0]:=MPT(pt.x,pt.y,pt.z+h);
 Arr[1]:=MPT(pt.x+z/2,pt.y+z/2,pt.z);
 Arr[2]:=MPT(pt.x-z/2,pt.y+z/2,pt.z);
 Arr[3]:=MPT(pt.x-z/2,pt.y-z/2,pt.z);
 Arr[4]:=MPT(pt.x+z/2,pt.y-z/2,pt.z);
 Arr[5]:=Arr[1];

END calc_mod_pyramid;


(* Tekent een kegel. Punt opgeven voor midden grondvlak, z voor lengte vierkant grondvlak, h voor hoogte. *)
PROCEDURE draw_mod_pyramid(Arr:ARRAY OF Punt;col:Color);
BEGIN

 smart_seq3(Arr,2,2,col,FALSE);

END draw_mod_pyramid;

(* Berekent de cilinder. Punt opgeven voor midden grondvlak, r voor de straal, n voor het aantal zijvlakken, h voor hoogte.
   Als deksel TRUE is, krijgt de cilinder een deksel. Begin moet TRUE zijn wanneer het de eerste maal gebruikt wordt, daarna niet meer. *)
PROCEDURE calc_mod_cylinder(VAR Arr,Arr2:PAP; pt:Punt;r,h:REAL;n:CARDINAL;deksel,begin:BOOLEAN);
VAR i:CARDINAL;
BEGIN

 IF begin THEN NEW(Arr,2*n+2); END;

 FOR i:=0 TO n DO
  Arr^[2*i]:=MPT(pt.x+r*cos(FLOAT(2*i)*pi/FLOAT(n)),pt.y-r*sin(FLOAT(2*i)*pi/FLOAT(n)),pt.z);
  Arr^[2*i+1]:=MPT(pt.x+r*cos(FLOAT(2*i)*pi/FLOAT(n)),pt.y-r*sin(FLOAT(2*i)*pi/FLOAT(n)),pt.z+h);
 END;

 IF deksel THEN

   IF begin THEN NEW(Arr2,n+2); END;
   Arr2^[0]:=MPT(pt.x,pt.y,pt.z+h);

   FOR i:=0 TO n DO
     Arr2^[i+1]:=Arr^[2*(n-i)+1];
   END;

 END;

END calc_mod_cylinder;

(* Tekent een cilinder. *)
PROCEDURE draw_mod_cylinder(Arr,Arr2:PAP; col:Color;deksel:BOOLEAN);
BEGIN

 IF deksel THEN smart_seq3(Arr2^,2,1,col,FALSE); END;
 smart_seq4(Arr^,1,2,col,FALSE);

END draw_mod_cylinder;


(* Berekent de bol. Punt opgeven voor midden grondvlak, r voor de straal, n voor de horizontale resolutie (3 of meer), h voor de verticale (1 of meer).
   Begin moet TRUE zijn wanneer het de eerste maal gebruikt wordt, daarna niet meer. *)
PROCEDURE calc_mod_sphere(VAR Arr:PTAPAP; pt:Punt;r:REAL;n,h:CARDINAL;begin:BOOLEAN);
VAR i,j:CARDINAL;
BEGIN

 IF begin THEN
  NEW(Arr,h+1); NEW(Arr^[0],2); FOR i:=1 TO h DO NEW(Arr^[i],n+1); END;
 END;

 Arr^[0]^[0]:=MPT(pt.x,pt.y,pt.z+r);
 Arr^[0]^[1]:=MPT(pt.x,pt.y,pt.z-r);

 FOR i:=1 TO h DO
  FOR j:=0 TO n DO
   Arr^[i]^[j]:=MPT( pt.x+sin(FLOAT(i)*pi/FLOAT(h+1))*r*cos(FLOAT(2*j)*pi/FLOAT(n)), pt.y-sin(FLOAT(i)*pi/FLOAT(h+1))*r*sin(FLOAT(2*j)*pi/FLOAT(n)), pt.z+r*cos(pi*FLOAT(i)/FLOAT(h+1)) );
  END;
 END;

END calc_mod_sphere;

(* Tekent een bol *)
PROCEDURE draw_mod_sphere(Arr:PTAPAP; col:Color);
VAR i,j,n,h:CARDINAL;
BEGIN

  h:=HIGH(Arr^);
  n:=HIGH(Arr^[1]^)+1;

  FOR i:=0 TO n-2 DO
   draw_poly3(Arr^[0]^[0],Arr^[1]^[i+1],Arr^[1]^[i],col,2,FALSE);
   draw_poly3(Arr^[0]^[1],Arr^[h]^[i],Arr^[h]^[i+1],col,2,FALSE);
  END;

  FOR i:=1 TO h-1 DO
   FOR j:=0 TO n-2 DO
    draw_poly4(Arr^[i+1]^[j],Arr^[i]^[j],Arr^[i+1]^[j+1],Arr^[i]^[j+1],col,2,FALSE);
   END;
  END;

END draw_mod_sphere;


(*=============================================*)
(* MEDIA : Gebruik van afbeeldingen en geluid. *)
(*=============================================*)

(* Genereert afbeeldingen van verschillende grootte van n sprite.
   Ingeven: naam sprite, naam .bmp, naam mask .bmp, breedte, hoogte, stappen, met of zonder mask, minimumgrootte, maximumgrootte. *)
PROCEDURE generate_sprites(name:SpriteNames; subimg:CARDINAL; mask:BOOLEAN; file,file_mask: ARRAY OF CHAR; w,h,s:CARDINAL; min,max:REAL);
VAR i:CARDINAL; stepsize,t:REAL;
BEGIN
  IF s=1 THEN
    NEW(SPRITELIB[name,subimg],1); NEW(XSA[name,subimg],1); NEW(YSA[name,subimg],1); SPRITELIB[name,subimg]^[0]:=LoadBitmap(file,w,h);
    XSA[name,subimg]^[0]:=w; YSA[name,subimg]^[0]:=h;
    IF mask THEN NEW(MASKLIB[name,subimg],1); MASKLIB[name,subimg]^[0]:=LoadBitmap(file_mask,w,h); END;
  ELSE
    NEW(SPRITELIB[name,subimg],s); NEW(XSA[name,subimg],s); NEW(YSA[name,subimg],s);stepsize:=(max-min)/FLOAT(s-1);
    FOR i:=0 TO s-1 DO
     t:=min+stepsize*FLOAT(i);
      SPRITELIB[name,subimg]^[i]:=LoadBitmap(file,TRUNC(FLOAT(w*SCREEN_WIDTH)*t/640.0),TRUNC(FLOAT(h*SCREEN_HEIGHT)*t/480.0));
      XSA[name,subimg]^[i]:=TRUNC(FLOAT(w*SCREEN_WIDTH)*t/640.0); YSA[name,subimg]^[i]:=TRUNC(FLOAT(h*SCREEN_HEIGHT)*t/480.0);
    END;

    IF mask THEN
	NEW(MASKLIB[name,subimg],s);
	FOR i:=0 TO s-1 DO
	  t:=min+stepsize*FLOAT(i);
  	  MASKLIB[name,subimg]^[i]:=LoadBitmap(file_mask,TRUNC(FLOAT(w*SCREEN_WIDTH)*t/640.0),TRUNC(FLOAT(h*SCREEN_HEIGHT)*t/480.0));
	END;
    END;

  END;

END generate_sprites;

(* Verwijderd de sprites, wist de pointers en maakt zo het geheugen weer vrij. (s=aantal groottes) *)
PROCEDURE delete_sprites(name:SpriteNames; subimg:CARDINAL; mask:BOOLEAN);
VAR i:CARDINAL;
BEGIN
  FOR i:=0 TO HIGH(SPRITELIB[name,subimg]^) DO DestroyBitmap(SPRITELIB[name,subimg]^[i]); END;
  DISPOSE(SPRITELIB[name,subimg]); DISPOSE(XSA[name,subimg]); DISPOSE(YSA[name,subimg]);

  IF mask THEN
   	FOR i:=0 TO HIGH(MASKLIB[name,subimg]^) DO DestroyBitmap(MASKLIB[name,subimg]^[i]); END;
  	DISPOSE(MASKLIB[name,subimg]);
  END

END delete_sprites;

(* Initialiseert/Verwijdert sprites volgens het level. TRUE=laden, FALSE=verwijderen. *)
PROCEDURE sprite_data(N:BOOLEAN;level:CARDINAL);
VAR i:CARDINAL;
BEGIN
 IF N THEN
   CASE level OF
    1: generate_sprites(S_zombie,2,TRUE,"images\Zombie2.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
        generate_sprites(S_I_zombie,0,TRUE,"images\Zombie.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_zombie,0]^) DO InvertBitmap(SPRITELIB[S_I_zombie,0]^[i]); END;
       generate_sprites(S_zombie,3,TRUE,"images\Zombie_Grond.bmp","images\Zombie_Grond_mask.bmp",48,35, 28, 0.25,7.0);
       generate_sprites(S_Lhand,0,TRUE,"images\Lhand1_spr.bmp","images\Lhand1_msk.bmp",160,84, 1, 0.0,0.0);
       generate_sprites(S_Lhand,1,TRUE,"images\Lhand2_spr.bmp","images\Lhand2_msk.bmp",214,104, 1, 0.0,0.0);
       generate_sprites(S_Lhand,2,TRUE,"images\Lhand3_spr.bmp","images\Lhand3_msk.bmp",296,152, 1, 0.0,0.0);
       generate_sprites(S_Rhand,0,TRUE,"images\Rhand_spr.bmp","images\Rhand_msk.bmp",230,92, 1, 0.0,0.0);
       generate_sprites(S_pistool,0,TRUE,"images\Pistool_spr.bmp","images\Pistool_msk.bmp",113,171, 1, 0.0, 0.0);
       generate_sprites(S_pistool_mod,0,TRUE,"images\Pistool_mod.bmp","images\Pistool_mod_msk.bmp",120,80, 28, 0.06,5.0);
       generate_sprites(S_sleutel,0,TRUE,"images\Sleutel_spr.bmp","images\Sleutel_msk.bmp",40,38, 22, 0.2,8.0);
       generate_sprites(S_tree,0,TRUE,"images\Tree1.bmp","images\Tree1_msk.bmp",256,256, 32, 0.25,7.0);
       generate_sprites(S_tree,1,TRUE,"images\Tree2.bmp","images\Tree2_msk.bmp",256,256, 32, 0.25,7.0);
       generate_sprites(S_maan,0,TRUE,"images\Moon_spr.bmp","images\Moon_msk.bmp",361,334, 28, 0.2, 7.0);
       generate_sprites(S_healthbox,0,TRUE,"images\Healthbox1_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);


   |2: generate_sprites(S_zombie,0,TRUE,"images\Zombie.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
       generate_sprites(S_zombie,1,TRUE,"images\Zombie3.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
        generate_sprites(S_I_zombie,0,TRUE,"images\Zombie.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_zombie,0]^) DO InvertBitmap(SPRITELIB[S_I_zombie,0]^[i]); END;
       generate_sprites(S_Lhand,0,TRUE,"images\Lhand1_spr.bmp","images\Lhand1_msk.bmp",160,84, 1, 0.0,0.0);
       generate_sprites(S_Lhand,1,TRUE,"images\Lhand2_spr.bmp","images\Lhand2_msk.bmp",214,104, 1, 0.0,0.0);
       generate_sprites(S_Lhand,2,TRUE,"images\Lhand3_spr.bmp","images\Lhand3_msk.bmp",296,152, 1, 0.0,0.0);
       generate_sprites(S_Rhand,0,TRUE,"images\Rhand_spr.bmp","images\Rhand_msk.bmp",230,92, 1, 0.0,0.0);
       generate_sprites(S_pistool,0,TRUE,"images\Pistool_spr.bmp","images\Pistool_msk.bmp",113,171, 1, 0.0, 0.0);
       generate_sprites(S_shotgun,0,TRUE,"images\Shotgun_spr.bmp","images\Shotgun_msk.bmp",233,217, 1, 0.0,0.0);
       generate_sprites(S_shotgun_mod,0,TRUE,"images\Shotgun_mod.bmp","images\Shotgun_mod_msk.bmp",352,75, 28, 0.06,5.0);
       generate_sprites(S_tree,0,TRUE,"images\Tree1.bmp","images\Tree1_msk.bmp",256,256, 32, 0.25,7.0);
       generate_sprites(S_tree,1,TRUE,"images\Tree2.bmp","images\Tree2_msk.bmp",256,256, 32, 0.25,7.0);
       generate_sprites(S_tree,2,TRUE,"images\Tree3.bmp","images\Tree3_msk.bmp",256,256, 32, 0.25,7.0);
       generate_sprites(S_maan,0,TRUE,"images\Moon_spr.bmp","images\Moon_msk.bmp",361,334, 28, 0.2, 7.0);
       generate_sprites(S_healthbox,0,TRUE,"images\Healthbox1_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);
       generate_sprites(S_healthbox,1,TRUE,"images\Healthbox2_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);


   |3: generate_sprites(S_zombie,0,TRUE,"images\Zombie.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
       generate_sprites(S_zombie,1,TRUE,"images\Zombie3.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
        generate_sprites(S_I_zombie,0,TRUE,"images\Zombie.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_zombie,0]^) DO InvertBitmap(SPRITELIB[S_I_zombie,0]^[i]); END;
       generate_sprites(S_mummy,0,TRUE,"images\Mummie.bmp","images\Mummie_msk.bmp",56,88, 28, 0.25,7.0);
        generate_sprites(S_I_mummy,0,TRUE,"images\Mummie.bmp","images\Mummie_msk.bmp",56,88, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_mummy,0]^) DO InvertBitmap(SPRITELIB[S_I_mummy,0]^[i]); END;
       generate_sprites(S_Lhand,0,TRUE,"images\Lhand1_spr.bmp","images\Lhand1_msk.bmp",160,84, 1, 0.0,0.0);
       generate_sprites(S_Lhand,1,TRUE,"images\Lhand2_spr.bmp","images\Lhand2_msk.bmp",214,104, 1, 0.0,0.0);
       generate_sprites(S_Lhand,2,TRUE,"images\Lhand3_spr.bmp","images\Lhand3_msk.bmp",296,152, 1, 0.0,0.0);
       generate_sprites(S_Rhand,0,TRUE,"images\Rhand_spr.bmp","images\Rhand_msk.bmp",230,92, 1, 0.0,0.0);
       generate_sprites(S_pistool,0,TRUE,"images\Pistool_spr.bmp","images\Pistool_msk.bmp",113,171, 1, 0.0, 0.0);
       generate_sprites(S_uzi,0,TRUE,"images\Uzi_spr.bmp","images\Uzi_msk.bmp",168,251, 1, 0.0,0.0);
       generate_sprites(S_uzi_mod,0,TRUE,"images\Uzi_mod.bmp","images\Uzi_mod_msk.bmp",222,108, 28, 0.06,5.0);
       generate_sprites(S_shotgun,0,TRUE,"images\Shotgun_spr.bmp","images\Shotgun_msk.bmp",233,217, 1, 0.0,0.0);
       generate_sprites(S_sleutel,0,TRUE,"images\Sleutel_spr.bmp","images\Sleutel_msk.bmp",40,38, 22, 0.2,8.0);
       generate_sprites(S_healthbox,0,TRUE,"images\Healthbox1_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);
       generate_sprites(S_healthbox,1,TRUE,"images\Healthbox2_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);
       generate_sprites(S_bazooka,0,TRUE,"images\Bazooka_spr.bmp","images\Bazooka_msk.bmp",241,236, 1, 0.0,0.0);
       generate_sprites(S_bazooka_mod,0,TRUE,"images\Bazooka_mod.bmp","images\Bazooka_mod_msk.bmp",263,116, 28, 0.06,5.0);


    |4: generate_sprites(S_zombie,0,TRUE,"images\Zombie.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
       generate_sprites(S_zombie,1,TRUE,"images\Zombie3.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
        generate_sprites(S_I_zombie,0,TRUE,"images\Zombie.bmp","images\Zombie_mask.bmp",54,80, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_zombie,0]^) DO InvertBitmap(SPRITELIB[S_I_zombie,0]^[i]); END;
       generate_sprites(S_mummy,0,TRUE,"images\Mummie.bmp","images\Mummie_msk.bmp",56,88, 28, 0.25,7.0);
        generate_sprites(S_I_mummy,0,TRUE,"images\Mummie.bmp","images\Mummie_msk.bmp",56,88, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_mummy,0]^) DO InvertBitmap(SPRITELIB[S_I_mummy,0]^[i]); END;
       generate_sprites(S_troll,0,TRUE,"images\Troll_spr.bmp","images\Troll_msk.bmp",156,160, 28, 0.25,7.0);
        generate_sprites(S_I_troll,0,TRUE,"images\Troll_spr.bmp","images\Troll_msk.bmp",156,160, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_troll,0]^) DO InvertBitmap(SPRITELIB[S_I_troll,0]^[i]); END;
       generate_sprites(S_Lhand,0,TRUE,"images\Lhand1_spr.bmp","images\Lhand1_msk.bmp",160,84, 1, 0.0,0.0);
       generate_sprites(S_Lhand,1,TRUE,"images\Lhand2_spr.bmp","images\Lhand2_msk.bmp",214,104, 1, 0.0,0.0);
       generate_sprites(S_Lhand,2,TRUE,"images\Lhand3_spr.bmp","images\Lhand3_msk.bmp",296,152, 1, 0.0,0.0);
       generate_sprites(S_Rhand,0,TRUE,"images\Rhand_spr.bmp","images\Rhand_msk.bmp",230,92, 1, 0.0,0.0);
       generate_sprites(S_pistool,0,TRUE,"images\Pistool_spr.bmp","images\Pistool_msk.bmp",113,171, 1, 0.0, 0.0);
       generate_sprites(S_uzi,0,TRUE,"images\Uzi_spr.bmp","images\Uzi_msk.bmp",168,251, 1, 0.0, 0.0);
       generate_sprites(S_bazooka,0,TRUE,"images\Bazooka_spr.bmp","images\Bazooka_msk.bmp",241,236, 1, 0.0,0.0);
       generate_sprites(S_shotgun,0,TRUE,"images\Shotgun_spr.bmp","images\Shotgun_msk.bmp",233,217, 1, 0.0,0.0);
       generate_sprites(S_sleutel,0,TRUE,"images\Sleutel_spr.bmp","images\Sleutel_msk.bmp",40,38, 22, 0.2,8.0);
       generate_sprites(S_healthbox,0,TRUE,"images\Healthbox1_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);
       generate_sprites(S_healthbox,1,TRUE,"images\Healthbox2_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);


   |5: generate_sprites(S_Lhand,0,TRUE,"images\Lhand1_spr.bmp","images\Lhand1_msk.bmp",160,84, 1, 0.0,0.0);
       generate_sprites(S_Lhand,1,TRUE,"images\Lhand2_spr.bmp","images\Lhand2_msk.bmp",214,104, 1, 0.0,0.0);
       generate_sprites(S_Lhand,2,TRUE,"images\Lhand3_spr.bmp","images\Lhand3_msk.bmp",296,152, 1, 0.0,0.0);
       generate_sprites(S_Rhand,0,TRUE,"images\Rhand_spr.bmp","images\Rhand_msk.bmp",230,92, 1, 0.0,0.0);
       generate_sprites(S_pistool,0,TRUE,"images\Pistool_spr.bmp","images\Pistool_msk.bmp",113,171, 1, 0.0, 0.0);
       generate_sprites(S_uzi,0,TRUE,"images\Uzi_spr.bmp","images\Uzi_msk.bmp",168,251, 1, 0.0,0.0);
       generate_sprites(S_bazooka,0,TRUE,"images\Bazooka_spr.bmp","images\Bazooka_msk.bmp",241,236, 1, 0.0,0.0);
       generate_sprites(S_shotgun,0,TRUE,"images\Shotgun_spr.bmp","images\Shotgun_msk.bmp",233,217, 1, 0.0,0.0);
       generate_sprites(S_maan,0,TRUE,"images\Moon_spr.bmp","images\Moon_msk.bmp",100,100, 1, 0.0, 0.0);
       generate_sprites(S_healthbox,0,TRUE,"images\Healthbox1_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);
       generate_sprites(S_healthbox,1,TRUE,"images\Healthbox2_spr.bmp","images\Healthbox_msk.bmp",50,50, 22, 0.2,8.0);
       generate_sprites(S_draak,0,TRUE,"images\draak1_spr.bmp","images\draak1_msk.bmp",254,154, 28, 0.25,7.0);
        generate_sprites(S_I_draak,0,TRUE,"images\draak1_spr.bmp","images\draak1_msk.bmp",254,154, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_draak,0]^) DO InvertBitmap(SPRITELIB[S_I_draak,0]^[i]); END;
       generate_sprites(S_draak,1,TRUE,"images\draak2_spr.bmp","images\draak2_msk.bmp",228,158, 28, 0.25,7.0);
        generate_sprites(S_I_draak,1,TRUE,"images\draak2_spr.bmp","images\draak2_msk.bmp",228,158, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_draak,1]^) DO InvertBitmap(SPRITELIB[S_I_draak,1]^[i]); END;
       generate_sprites(S_draak,2,TRUE,"images\draak3_spr.bmp","images\draak3_msk.bmp",240,154, 28, 0.25,7.0);
        generate_sprites(S_I_draak,2,TRUE,"images\draak3_spr.bmp","images\draak3_msk.bmp",240,154, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_draak,2]^) DO InvertBitmap(SPRITELIB[S_I_draak,2]^[i]); END;
       generate_sprites(S_draak,3,TRUE,"images\draak4_spr.bmp","images\draak4_msk.bmp",228,160, 28, 0.25,7.0);
        generate_sprites(S_I_draak,3,TRUE,"images\draak4_spr.bmp","images\draak4_msk.bmp",228,160, 28, 0.25,7.0);
        FOR i:=0 TO HIGH(SPRITELIB[S_I_draak,3]^) DO InvertBitmap(SPRITELIB[S_I_draak,3]^[i]); END;
   END;
 ELSE
   CASE level OF

    1: delete_sprites(S_zombie,2,TRUE);
       delete_sprites(S_zombie,3,TRUE);
       delete_sprites(S_I_zombie,0,TRUE);
       delete_sprites(S_Lhand,0,TRUE);
       delete_sprites(S_Lhand,1,TRUE);
       delete_sprites(S_Lhand,2,TRUE);
       delete_sprites(S_Rhand,0,TRUE);
       delete_sprites(S_pistool,0,TRUE);
       delete_sprites(S_pistool_mod,0,TRUE);
       delete_sprites(S_tree,0,TRUE);
       delete_sprites(S_tree,1,TRUE);
       delete_sprites(S_sleutel,0,TRUE);
       delete_sprites(S_maan,0,TRUE);
       delete_sprites(S_healthbox,0,TRUE);

   |2: delete_sprites(S_zombie,0,TRUE);
       delete_sprites(S_zombie,1,TRUE);
       delete_sprites(S_I_zombie,0,TRUE);
       delete_sprites(S_Lhand,0,TRUE);
       delete_sprites(S_Lhand,1,TRUE);
       delete_sprites(S_Lhand,2,TRUE);
       delete_sprites(S_Rhand,0,TRUE);
       delete_sprites(S_pistool,0,TRUE);
       delete_sprites(S_shotgun,0,TRUE);
       delete_sprites(S_shotgun_mod,0,TRUE);
       delete_sprites(S_tree,0,TRUE);
       delete_sprites(S_tree,1,TRUE);
       delete_sprites(S_tree,2,TRUE);
       delete_sprites(S_maan,0,TRUE);
       delete_sprites(S_healthbox,0,TRUE);
       delete_sprites(S_healthbox,1,TRUE);

   |3: delete_sprites(S_zombie,0,TRUE);
       delete_sprites(S_zombie,1,TRUE);
       delete_sprites(S_I_zombie,0,TRUE);
       delete_sprites(S_mummy,0,TRUE);
       delete_sprites(S_I_mummy,0,TRUE);
       delete_sprites(S_Lhand,0,TRUE);
       delete_sprites(S_Lhand,1,TRUE);
       delete_sprites(S_Lhand,2,TRUE);
       delete_sprites(S_Rhand,0,TRUE);
       delete_sprites(S_pistool,0,TRUE);
       delete_sprites(S_uzi,0,TRUE);
       delete_sprites(S_shotgun,0,TRUE);
       delete_sprites(S_uzi_mod,0,TRUE);
       delete_sprites(S_sleutel,0,TRUE);
       delete_sprites(S_healthbox,0,TRUE);
       delete_sprites(S_healthbox,1,TRUE);

   |4: delete_sprites(S_zombie,0,TRUE);
       delete_sprites(S_zombie,1,TRUE);
       delete_sprites(S_I_zombie,0,TRUE);
       delete_sprites(S_mummy,0,TRUE);
       delete_sprites(S_I_mummy,0,TRUE);
       delete_sprites(S_troll,0,TRUE);
       delete_sprites(S_I_troll,0,TRUE);
       delete_sprites(S_Lhand,0,TRUE);
       delete_sprites(S_Lhand,1,TRUE);
       delete_sprites(S_Lhand,2,TRUE);
       delete_sprites(S_Rhand,0,TRUE);
       delete_sprites(S_pistool,0,TRUE);
       delete_sprites(S_uzi,0,TRUE);
       delete_sprites(S_shotgun,0,TRUE);
       delete_sprites(S_sleutel,0,TRUE);
       delete_sprites(S_healthbox,0,TRUE);
       delete_sprites(S_healthbox,1,TRUE);


   |5: delete_sprites(S_Lhand,0,TRUE);
       delete_sprites(S_Lhand,1,TRUE);
       delete_sprites(S_Lhand,2,TRUE);
       delete_sprites(S_Rhand,0,TRUE);
       delete_sprites(S_pistool,0,TRUE);
       delete_sprites(S_uzi,0,TRUE);
       delete_sprites(S_bazooka,0,TRUE);
       delete_sprites(S_shotgun,0,TRUE);
       delete_sprites(S_maan,0,TRUE);
       delete_sprites(S_healthbox,0,TRUE);
       delete_sprites(S_healthbox,1,TRUE);
       delete_sprites(S_draak,0,TRUE);
       delete_sprites(S_draak,1,TRUE);
       delete_sprites(S_draak,2,TRUE);
       delete_sprites(S_draak,3,TRUE);
       delete_sprites(S_I_draak,0,TRUE);
       delete_sprites(S_I_draak,1,TRUE);
       delete_sprites(S_I_draak,2,TRUE);
       delete_sprites(S_I_draak,3,TRUE);

   END;
 END;
END sprite_data;

(* Tekent een sprite met een gekozen grootte, in het midden *)
PROCEDURE draw_sprite(name:SpriteNames; subimg:CARDINAL; mask:BOOLEAN; depth:REAL; snh:CARDINAL(* nummer van de sprite op depth 100 *); pt:Punt);
VAR pp:VPunt; v:Punt; size:CARDINAL;
BEGIN

v := vect_som(pt,vect_neg(OBJ[cam_pos_obj].pos));  (* Vermijden dat de procedure tweemaal wordt opgeroepen *)

 IF ( (scal_prod(ZN,v)/norm(v)) <= -0.3) AND (depth>0.01) THEN
  pp:=proj_coord(pt); size:=TRUNC(FLOAT(snh*100)/depth(*+0.5?*)); IF size>HIGH(SPRITELIB[name,subimg]^)-1 THEN size:=HIGH(SPRITELIB[name,subimg]^)-1; END;
  IF mask THEN DrawMaskBitmap(SPRITELIB[name,subimg]^[size],MASKLIB[name,subimg]^[size],pp.x-VAL(INTEGER,XSA[name,subimg]^[size])/2,pp.y-VAL(INTEGER,YSA[name,subimg]^[size])/2);
  ELSE DrawBitmap(SPRITELIB[name,subimg]^[size],pp.x-VAL(INTEGER,XSA[name,subimg]^[size])/2,pp.y-VAL(INTEGER,YSA[name,subimg]^[size])/2); END;
 END;

END draw_sprite;

(* Tekent de healthbar. N: TRUE voor jou healthbar, FALSE voor die van de BOSS. *)
PROCEDURE draw_healthbar(hp:INTEGER;N:BOOLEAN);
VAR col:Color;
BEGIN
 IF N THEN
  IF hp>500 THEN col := MRGB(TRUNC(FLOAT(1000-hp)/500.0*255.0),255,0);
  ELSE col := MRGB(255,TRUNC(FLOAT(hp)/500.0*255.0),0); END;

  Rectangle(16,SCREEN_HEIGHT-132,24,SCREEN_HEIGHT-32-hp/10,RgbColor(0,0,0),TRUE);
  Rectangle(16,SCREEN_HEIGHT-32-hp/10,24,SCREEN_HEIGHT-32,RgbColor(col.r,col.g,col.b),TRUE);

  IF (hp>200) OR ((general_timer MOD 6) > 2) THEN
   Rectangle(16,SCREEN_HEIGHT-132,24,SCREEN_HEIGHT-32,RgbColor(200,200,200),FALSE);
  ELSE
   Rectangle(16,SCREEN_HEIGHT-132,24,SCREEN_HEIGHT-32,RgbColor(255,255,255),FALSE);
  END;
 ELSE
  IF hp>750 THEN col := MRGB(255,0,TRUNC(FLOAT(1500-hp)/750.0*255.0));
  ELSE col := MRGB(TRUNC(FLOAT(hp)/750.0*255.0),0,255); END;

  Rectangle(4,SCREEN_HEIGHT-132,12,SCREEN_HEIGHT-32-hp/15,RgbColor(0,0,0),TRUE);
  Rectangle(4,SCREEN_HEIGHT-32-hp/15,12,SCREEN_HEIGHT-32,RgbColor(col.r,col.g,col.b),TRUE);

  IF (hp>300) OR ((general_timer MOD 6) > 2) THEN
   Rectangle(4,SCREEN_HEIGHT-132,12,SCREEN_HEIGHT-32,RgbColor(200,200,200),FALSE);
  ELSE
   Rectangle(4,SCREEN_HEIGHT-132,12,SCREEN_HEIGHT-32,RgbColor(255,255,0),FALSE);
  END;
 END;

END draw_healthbar;

(* Wat er gebeuren moet bij "game over" *)
PROCEDURE game_over_ctrl;
VAR i,j:CARDINAL;
BEGIN

 FOR i:=1 TO SCREEN_WIDTH DO
  FOR j:=1 TO SCREEN_HEIGHT DO
   blend_color(i,j,MRGB(192,0,0));
  END;
 END;
 UpdateWindow; Delay(1200);
 i:=LoadBitmap("images\Game_over_spr.bmp",222,240); j:=LoadBitmap("images\Game_over_msk.bmp",222,240);
 DrawMaskBitmap(i,j,SCREEN_WIDTH/2-111,SCREEN_HEIGHT/2-120);
 UpdateWindow; Delay(5000);
 DestroyBitmap(i); DestroyBitmap(j);
 net_game_over:=TRUE;
 save_and_load(FALSE);
 level_begin := TRUE;
 situatie:=0;

END game_over_ctrl;

(* Wat er gebeuren moet wanneer een level wordt beindigd *)
PROCEDURE mission_done_ctrl;
VAR i,j:CARDINAL;
BEGIN

 FOR i:=1 TO SCREEN_WIDTH DO
  FOR j:=1 TO SCREEN_HEIGHT DO
   blend_color(i,j,MRGB(0,0,0));
  END;
 END;
 UpdateWindow; Delay(500);
 i:=LoadBitmap("images\Mission_spr.bmp",388,105);
 DrawBitmap(i,SCREEN_WIDTH/2-194,SCREEN_HEIGHT/2-53);
 UpdateWindow; Delay(5000); DestroyBitmap(i);
 sprite_data(FALSE,current_level); dispose_obj_vars(0);
 save_and_load(TRUE);
 current_level:=current_level+1;
 level_begin:=TRUE;

END mission_done_ctrl;

(* Initialiseert alle geluiden. PlaySoundEvent gebruiken om een geluid af te spelen. *)

(*
PROCEDURE ini_sound;
BEGIN
 IF InitSound(TRUE) THEN
   WrStr("Geluid werkt op deze computer"); WrLn;
 ELSE
   WrStr("Geluid werkt niet op deze computer..."); WrLn;
 END;
END ini_sound;
*)

(* Afstanden en richting tot lampen berekenen *)
PROCEDURE set_wall_lights(VAR WA:LType; pos:Punt; VAR max:CARDINAL; walld: Direction);
VAR i,j:CARDINAL; r:REAL; v:Punt;
BEGIN
i:=1;j:=0; max:=0;
 WHILE (i<=NOL[current_level]) AND (j<8) DO
  r:=afs_punt_punt(LIGHTARR[i].lpos,pos);
  IF r<500.0 THEN WA[j].lightno:=i; WA[j].lightint:=1.0/r; v:=vect_som(LIGHTARR[i].lpos,vect_neg(pos));
   CASE walld OF
     Left: r:=scal_prod(MPT(-1.0,0.0,0.0),v)/norm(v);
    |Right:r:=scal_prod(MPT(1.0,0.0,0.0),v)/norm(v);
    |Up:r:=scal_prod(MPT(0.0,1.0,0.0),v)/norm(v);
    |Down:r:=scal_prod(MPT(0.0,-1.0,0.0),v)/norm(v);
   END;
  IF r<0.0 THEN r:=0.0; END; WA[j].lightint:=WA[j].lightint*r; max:=j; j:=j+1;
  END;
  i:=i+1;
 END;
END set_wall_lights;

(* Kleurintensiteit veranderen. R:factor, max: maximum *)
PROCEDURE color_intensity(col:Color;R,max:REAL):Color;
BEGIN
 IF R>max THEN R:=max END;
 RETURN MRGB(TRUNC(FLOAT(col.r)*R),TRUNC(FLOAT(col.b)*R),TRUNC(FLOAT(col.g)*R));
END color_intensity;

(* kleur bepalen die moet worden getekend *)
PROCEDURE calc_lighted_color(col:Color; WA:LType; max:CARDINAL; dpt:REAL):Color;
VAR i:CARDINAL; t:REAL;
BEGIN
 IF NOT Lighteffects THEN RETURN col; END;
  t:=0.25;
  FOR i:=0 TO max DO
   IF LIGHTARR[WA[i].lightno].on THEN t:=t+WA[i].lightint*80.0 END;
  END;
  IF dpt>2.0 THEN t:=t+20.0/dpt ELSE t:=t+2.0; END;
  RETURN color_intensity(col,t,1.25);
END calc_lighted_color;

(*================================================================*)
(* INFO : Allerhande tekst gebruikt ter informatie van de speler. *)
(*================================================================*)

PROCEDURE message_new_weapon(n:WeaponNames);
BEGIN
 CASE n OF
   W_pistool: set_message("Je hebt een pistool gevonden. Druk op F2 om het te gebruiken.",80,1,MRGB(32,255,32));
  |W_uzi:     set_message("Je hebt een uzi gevonden. Druk op F3 om het te gebruiken.",80,1,MRGB(32,255,32));
  |W_shotgun: set_message("Je hebt een shotgun gevonden. Druk op F4 om het te gebruiken.",80,1,MRGB(32,255,32));
  |W_bazooka: set_message("Je hebt een bazooka gevonden! Druk op F5 om het te gebruiken.",80,1,MRGB(32,255,32));
  ELSE ;
 END;
END message_new_weapon;

PROCEDURE message_found_bullets(n:WeaponNames);
BEGIN
 CASE n OF
   W_pistool: set_message("Je hebt 9mm-kogels voor pistolen gevonden.",60,1,MRGB(220,220,255));
  |W_uzi:     set_message("Je hebt .22 LR-kogels voor een uzi gevonden.",60,1,MRGB(220,220,255));
  |W_shotgun: set_message("Je hebt .45ACP-kogels voor shotguns gevonden.",60,1,MRGB(220,220,255));
  |W_bazooka: set_message("Je hebt missile(s) gevonden voor bazooka's.",60,1,MRGB(220,220,255));
  ELSE ;
 END;
END message_found_bullets;

(*===========================================================================================*)
(* OBJCONTROL : Functies om met "objecten" te werken, een speciaal record eigen aan dit spel.*)
(*===========================================================================================*)

PROCEDURE Sort(MinQuick: CARDINAL); (* Sorteert alle objecten volgens hun "depth" waarde *)
    PROCEDURE Swap(i,j: CARDINAL);
       VAR t : Object;
       BEGIN
           t := OBJ[i]; OBJ[i] := OBJ[j]; OBJ[j] := t
       END Swap;

    PROCEDURE InsSort(n:CARDINAL); (* OBJ[0] is een sentinel *)
       VAR
           x : Object;
           i,j : CARDINAL;
       BEGIN
           FOR i := 2 TO n DO
               x := OBJ[i];
               OBJ[0] := x;  (* sentinel *)
               j := i;
               WHILE x.depth < OBJ[j-1].depth DO
                   OBJ[j] := OBJ[j-1];
                   j := j-1
               END;
               OBJ[j] := x;
           END;
       END InsSort;

    PROCEDURE QuickSort(L,H:CARDINAL);
       VAR
           Pivot : REAL;
           i,j:    CARDINAL;
    BEGIN
        i := L; j := H; Pivot := OBJ[(L+H) DIV 2].depth;
        REPEAT
            WHILE OBJ[i].depth < Pivot DO INC(i) END;
            WHILE OBJ[j].depth > Pivot DO DEC(j) END;
            IF i <= j THEN
                Swap(i,j);
                INC (i); DEC(j)
            END;
        UNTIL i > j;
        IF j-L > MinQuick THEN QuickSort(L,j) END;
        IF H-i > MinQuick THEN QuickSort(i,H) END;
    END QuickSort;
BEGIN
    QuickSort(1,NOO);
    InsSort(NOO);
END Sort;

PROCEDURE set_depth(n:CARDINAL); (* Verfrist de depth-waarde van een object *)
BEGIN
 OBJ[n].depth := afs_punt_punt(OBJ[n].pos,OBJ[cam_pos_obj].pos);
END set_depth;


(* Controleert voor een object of deze al dan niet een "collision" ondergaat, en geeft dat terug als varabele
   s: object waarvoor het gecontroleerd wordt, k: kind van het andere object (nothing ingeven voor alle solid objecten)
   nonsolid: TRUE om alle objecten in rekening te houden, FALSE voor enkel de "solids"
   type=FALSE: Indien de positie van het object zich binnen de bb bevindt, wordt het TRUE.
   type=TRUE: ndien de bb'en van de twee objecten overlappen, wordt het TRUE.
   d3d: Of er al dan niet rekening moet worden gehouden met de Z-cordinaten
   x geeft de waarde van met welk object er evt. een collisie wordt ondergaan. Wordt 0 wanneer er geen collisie is.*)

PROCEDURE check_collision(s:CARDINAL;k:ObjKind;d3d,type,nonsolid:BOOLEAN; VAR x: CARDINAL):BOOLEAN;
VAR i:CARDINAL;
BEGIN

IF d3d THEN

 IF type THEN

  FOR i:=1 TO NOO DO
   WITH OBJ[i] DO
    IF ((solid=TRUE) OR nonsolid) AND ( (k=nothing) OR (k=kind) ) AND (s#i) AND
    ( ((OBJ[s].bbx1>=bbx1) AND (OBJ[s].bbx1<=bbx2)) OR ((OBJ[s].bbx2>=bbx1) AND (OBJ[s].bbx2<=bbx2)) OR ((bbx1>=OBJ[s].bbx1) AND (bbx1<=OBJ[s].bbx2)) OR ((bbx2>=OBJ[s].bbx1) AND (bbx2<=OBJ[s].bbx2)) ) AND
    ( ((OBJ[s].bby1>=bby1) AND (OBJ[s].bby1<=bby2)) OR ((OBJ[s].bby2>=bby1) AND (OBJ[s].bby2<=bby2)) OR ((bby1>=OBJ[s].bby1) AND (bby1<=OBJ[s].bby2)) OR ((bby2>=OBJ[s].bby1) AND (bby2<=OBJ[s].bby2)) ) AND
    ( ((OBJ[s].bbz1>=bbz1) AND (OBJ[s].bbz1<=bbz2)) OR ((OBJ[s].bbz2>=bbz1) AND (OBJ[s].bbz2<=bbz2)) OR ((bbz1>=OBJ[s].bbz1) AND (bbz1<=OBJ[s].bbz2)) OR ((bbz2>=OBJ[s].bbz1) AND (bbz2<=OBJ[s].bbz2)) ) THEN x:=i; RETURN TRUE; END;
   END;
  END;

 ELSE

  FOR i:=1 TO NOO DO
   WITH OBJ[i] DO
    IF ((solid=TRUE) OR nonsolid) AND ( (k=nothing) OR (k=kind) ) AND (OBJ[s].pos.x>=bbx1) AND (OBJ[s].pos.x<=bbx2) AND (OBJ[s].pos.y>=bby1) AND (OBJ[s].pos.y<=bby2) AND (OBJ[s].pos.z>=bbz1) AND (OBJ[s].pos.z<=bbz2) AND (s#i) THEN x:=i; RETURN TRUE; END;
   END;
  END;

 END;

ELSE

 IF type THEN

  FOR i:=1 TO NOO DO
   WITH OBJ[i] DO
    IF ((solid=TRUE) OR nonsolid) AND ( (k=nothing) OR (k=kind) ) AND (s#i) AND
    ( ((OBJ[s].bbx1>=bbx1) AND (OBJ[s].bbx1<=bbx2)) OR ((OBJ[s].bbx2>=bbx1) AND (OBJ[s].bbx2<=bbx2)) OR ((bbx1>=OBJ[s].bbx1) AND (bbx1<=OBJ[s].bbx2)) OR ((bbx2>=OBJ[s].bbx1) AND (bbx2<=OBJ[s].bbx2)) ) AND
    ( ((OBJ[s].bby1>=bby1) AND (OBJ[s].bby1<=bby2)) OR ((OBJ[s].bby2>=bby1) AND (OBJ[s].bby2<=bby2)) OR ((bby1>=OBJ[s].bby1) AND (bby1<=OBJ[s].bby2)) OR ((bby2>=OBJ[s].bby1) AND (bby2<=OBJ[s].bby2)) ) THEN x:=i; RETURN TRUE; END;
   END;
  END;

 ELSE

  FOR i:=1 TO NOO DO
   WITH OBJ[i] DO
    IF ((solid=TRUE) OR nonsolid) AND ( (k=nothing) OR (k=kind) ) AND (OBJ[s].pos.x>=bbx1) AND (OBJ[s].pos.x<=bbx2) AND (OBJ[s].pos.y>=bby1) AND (OBJ[s].pos.y<=bby2) AND (s#i) THEN x:=i; RETURN TRUE; END;
   END;
  END;

 END;

END;

 x := 0;
 RETURN FALSE;

END check_collision;


(* Bounding-Box (her)berekenen *)
PROCEDURE calc_bb(n:CARDINAL;x1,y1,z1,x2,y2,z2:REAL);
BEGIN
 OBJ[n].bbx1:=x1; OBJ[n].bby1:=y1; OBJ[n].bbz1:=z1; OBJ[n].bbx2:=x2; OBJ[n].bby2:=y2; OBJ[n].bbz2:=z2;
END calc_bb;

(* Object verwijderen, plaats in de tabel ingeven *)
PROCEDURE delete_object(n:CARDINAL);
BEGIN
  OBJ[n]:=OBJ[NOO]; NOO:=NOO-1;
END delete_object;


PROCEDURE in_fov(pt:Punt;hoek:REAL):BOOLEAN; (* Controleert of een bepaald object zich binnen het gezichtveld bevindt *)
   BEGIN
	IF ( (scal_prod(ZN,vect_som(pt,vect_neg(OBJ[cam_pos_obj].pos)))/norm(vect_som(pt,vect_neg(OBJ[cam_pos_obj].pos)))) <= -hoek) THEN
	RETURN TRUE; ELSE RETURN FALSE; END;
END in_fov;

(* De drie volgende "event"-procedures "beschrijven" wat elk object moet doen.
  (n) Welk object het voor moet gebeuren. 0 betekent alle objecten.

  Initialitation (wanneer het object verschijnt, aangemaakt wordt of bij het begin van het level) *)
PROCEDURE creation_event(n:CARDINAL);
VAR i,j,k,s:CARDINAL;
BEGIN

  IF n=0 THEN i:=1; j:=NOO; ELSE i:=n; j:=n; END;

  FOR k:=j TO i BY -1 DO
    WITH OBJ[k] DO
       CASE kind OF
	camera: zdir:=0.0;
		cam_pos_obj := 1;
		dir:=place_campoints(placed_direction);
		depth := -100.0; (* Vermits zijn depth negatief is, zal hij steeds op de eerste plaats in OBJ staan. *)
		solid := TRUE;
		timerweapondelay := 0;
                health := 1000;
                IF current_level=2 THEN set_message("Oh nee, ik ben de munitie vergeten ! Voorlopig dan maar met de vuisten...",120,1,MRGB(128,220,255)); END;

	|wall: solid := TRUE; IF Lighteffects THEN set_wall_lights(wall_LA,pos,maxnolt,wall_direction); END;
		CASE wall_direction OF
		 Left: calc_bb(k, pos.x-20.0, pos.y-32.0, pos.z-32.0, pos.x+20.0, pos.y+32.0, pos.z+32.0);
		|Right: calc_bb(k, pos.x-20.0, pos.y-32.0, pos.z-32.0, pos.x+20.0, pos.y+32.0, pos.z+32.0);
		|Up: calc_bb(k, pos.x-32.0, pos.y-20.0, pos.z-32.0, pos.x+32.0, pos.y+20.0, pos.z+32.0);
		|Down: calc_bb(k, pos.x-32.0, pos.y-20.0, pos.z-32.0, pos.x+32.0, pos.y+20.0, pos.z+32.0);
		END;
	|MainFloor: depth:=1.0E6; solid := FALSE;
	|tile: solid := FALSE;
	|monster: monster_damaged := FALSE; monster_health := monster_data[monster_kind].Mmaxhp; monster_xspeed := 0.0; monster_yspeed := 0.0; monster_gotshot := FALSE;
                  IF monster_kind#Troll THEN calc_bb(k, pos.x-10.0, pos.y-10.0, pos.z-24.0, pos.x+10.0, pos.y+10.0, pos.z+24.0); ELSE calc_bb(k, pos.x-16.0, pos.y-16.0, pos.z-24.0, pos.x+16.0, pos.y+16.0, pos.z+32.0); END;
        |grondzombie: solid:=TRUE; grond_timer:=60; calc_bb(k, pos.x-10.0, pos.y-10.0, pos.z-24.0, pos.x+10.0, pos.y+10.0, pos.z+24.0);
        |spietsen: FOR s:=0 TO 3 DO calc_mod_pyramid(spiets_array[s+1].spcoor,vect_som(pos,MPT((FLOAT((s MOD 2)*2)-1.0)*12.0,(FLOAT((s DIV 2)*2)-1.0)*12.0,0.0)),12.0,20.0); END;
                   solid := FALSE; calc_bb(k, pos.x-26.0, pos.y-26.0, pos.z, pos.x+26.0, pos.y+26.0, pos.z+20.0);
	|blok: calc_mod_cuboid(blok_array,pos,48.0,24.0,32.0); solid := TRUE; calc_bb(k, pos.x-30.0, pos.y-18.0, pos.z, pos.x+30.0, pos.y+18.0, pos.z+40.0);
	|tafel: calc_mod_cuboid(tafel_blad,pos,48.0,32.0,4.0); calc_bb(k, pos.x-24.0, pos.y-16.0, pos.z-2.0, pos.x+24.0, pos.y+16.0, pos.z+2.0); solid := TRUE;
		FOR s:=0 TO 3 DO calc_mod_cylinder(tafel_poten[s+1].pcoor,tafel_poten[s+1].pcoor,vect_som(pos,MPT((FLOAT((s MOD 2)*2)-1.0)*20.0,(FLOAT((s DIV 2)*2)-1.0)*12.0,-20.0)),3.0,18.0,6,FALSE,TRUE); END;
	|kruk: calc_mod_cylinder(kruk_blad1,kruk_blad2,pos,12.0,3.0,12,TRUE,TRUE); calc_bb(k, pos.x-12.0, pos.y-12.0, pos.z-3.0, pos.x+12.0, pos.y+12.0, pos.z+10.0); solid := TRUE;
               FOR s:=0 TO 2 DO calc_mod_cylinder(kruk_poten[s+1].pcoor,kruk_poten[s+1].pcoor,vect_som(pos,MPT(cos(FLOAT(2*s)/3.0*pi)*8.0,sin(FLOAT(2*s)/3.0*pi)*8.0,-10.0)),2.4,10.0,6,FALSE,TRUE); END;
        |stoel: calc_mod_cuboid(stoel_deel[6].scoor,vect_som(pos,MPT(0.0,-6.0,7.5)),14.0,2.0,12.0); calc_mod_cuboid(stoel_deel[5].scoor,vect_som(pos,MPT(0.0,0.0,0.75)),14.0,14.0,1.5);
                FOR s:=0 TO 3 DO calc_mod_cuboid(stoel_deel[s+1].scoor,vect_som(pos,MPT((FLOAT((s MOD 2)*2)-1.0)*6.0,(FLOAT((s DIV 2)*2)-1.0)*6.0,-6.0)),2.0,2.0,12.0); END;
                calc_bb(k, pos.x-7.0, pos.y-7.0, pos.z, pos.x+7.0, pos.y+7.0, pos.z+13.5); solid := TRUE;
	|kogel: CASE wapen OF  W_pistool:  kdamage := 30 ; kgspeed:=16.0; mycol:=MRGB(173,173,173);
	                      |W_shotgun: kdamage := 25 ;  kgspeed:=14.0; mycol:=MRGB(140,140,140);
			      |W_uzi: kdamage := 10 ; kgspeed:=20.0; mycol:=MRGB(180,170,150);
			      |W_bazooka: kdamage := 200; kgspeed:=10.0; mycol:=MRGB(130,180,130);
		END;	
                kxspeed:=kgspeed*cos(OBJ[cam_pos_obj].dir)*cos(OBJ[cam_pos_obj].zdir); kyspeed:=-kgspeed*sin(OBJ[cam_pos_obj].dir)*cos(OBJ[cam_pos_obj].zdir); kzspeed:=kgspeed*sin(OBJ[cam_pos_obj].zdir); set_depth(k);
        |wapenitem: solid := FALSE; CASE wapen_type OF
                                      W_pistool: wapen_sprite := S_pistool_mod;
                                     |W_uzi:     wapen_sprite := S_uzi_mod;
                                     |W_shotgun: wapen_sprite := S_shotgun_mod;
                                     |W_bazooka: wapen_sprite := S_bazooka_mod;
                                    END;
        |deco: solid := TRUE; (* bbx moet bij het plaatsen worden bepaald *)
        |ammo: calc_mod_cuboid(ammo_array,pos,12.0*FLOAT(ammo_size+1)*0.5,10.0*FLOAT(ammo_size+1)*0.5,6.0*FLOAT(ammo_size+1)*0.5); solid := FALSE;
	    CASE ammo_type OF
	         W_pistool: mycol:= MRGB(49,164,43);
	         |W_uzi: mycol := MRGB(250,0,0);
	         |W_shotgun: mycol := MRGB(240,240,0);
	         |W_bazooka: mycol := MRGB(0,0,250);
		ELSE ;
	    END;
	|schuifdeur: solid := TRUE;
		calc_bb(k, pos.x-64.0, pos.y-24.0, pos.z-32.0, pos.x+64.0, pos.y+24.0, pos.z+32.0);
		schuifdeur_touched := FALSE;  pos_schuifdeur := 128;
        |maan: depth := 2.0E6;
        |sleutel: solid := FALSE;
        |healthbox: solid := FALSE;
        |tower: calc_mod_cylinder(tower_array,tower_array,pos,384.0,1400.0,16,FALSE,TRUE); solid := FALSE;
        |explosie: explosie_kleur_no:=0; explosie_timer:=60;
        |valbal: solid := FALSE; valbal_beginpos:=pos; valbal_timer:=valbal_maxtimer; calc_mod_sphere(valbal_array,pos,24.0,8,8,TRUE); valbal_zspeed:=0.0;
        |valpijlen: solid := FALSE; valpijlen_timer:=75; valpijlen_aant_schieten := FALSE;  IF (valpijlen_timer>100) OR (valpijlen_timer=0) THEN valpijlen_timer:= 75; END;
        |towertop: calc_mod_cylinder(towertop_array1,towertop_array2,MPT(384.0,384.0,-256.0),384.0,256.0,16,TRUE,TRUE);
                   NEW(towertop_array3,2*HIGH(towertop_array2^));
                   FOR s:=1 TO HIGH(towertop_array2^) DO
                   towertop_array3^[2*s-1]:=towertop_array2^[s]; towertop_array2^[s]:=punt_midden(towertop_array2^[0],towertop_array2^[s],1.6); towertop_array3^[2*s-2]:=towertop_array2^[s];
                   END;

                   solid := FALSE; depth:=2.0E5;
        |weer: depth:=1.0E5; bliksem_timer:=250+random(100); aant_bliksemen:=FALSE;
               FOR s:=1 TO 250 DO rain_array[s]:=MPT(OBJ[cam_pos_obj].pos.x-320.0+FLOAT(random(640)),OBJ[cam_pos_obj].pos.y-320.0+FLOAT(random(640)),250.0+FLOAT(random(100))); END;
        |tutorial: depth:=-1.0E4; tut_timer:=80; situatie:=0; set_message("Welkom in de trainingsruimte.",60,1,MRGB(128,128,255)); calc_bb(k, pos.x-32.0, pos.y-32.0, pos.z, pos.x+32.0, pos.y+32.0, pos.z+32.0);
        |finish: solid := FALSE; depth:=-3.0E7; level_done:=FALSE;
        |lamp: solid := FALSE; lamp_aan:=TRUE; IF kapot THEN lamp_timer:=7+random(10); ELSE lamp_timer:=77; END;
               calc_mod_sphere(lampbol_array,pos,12.0,4,4,TRUE); mycol:=MRGB(200,200,60); LIGHTARR[mijnlampno].on:=TRUE;
        |draak: begin_gevecht:=FALSE; aant_aanvallen:=FALSE; draak_damaged:=FALSE; aanval_modus:=0; draak_health:=1500; depth:= 2.5E5; draak_afbeelding:=0; draak_hoek:=0.0; draak_timer:=200+random(50); put_munition:=TRUE;
        |vuurbal: mycol:=MRGB(200,150,50);
        |bommetje: mycol:=MRGB(50,70,180);
	|nothing: solid := FALSE;
       END;
      END;
     END;

END creation_event;


PROCEDURE continuous_event(n:CARDINAL); FORWARD;

(* Object aanmaken, "kind" ingeven, je krijgt de plaats in de tabel terug, bepalen of de "continuous command" moet worden uitgevoerd *)
PROCEDURE create_object(K:ObjKind;do_event0,do_event1:BOOLEAN):CARDINAL;
BEGIN
 NOO:=NOO+1; OBJ[NOO].kind:=K;
 IF do_event0 THEN creation_event(NOO); END;
 IF do_event1 THEN continuous_event(NOO); END;
 RETURN NOO;
END create_object;

(* Continuous (wat het het object de hele tijd doet (per cyclus) ) *)
PROCEDURE continuous_event(n:CARDINAL);
VAR i,j,k,s,ss:CARDINAL; R:REAL; pp:Punt; xrec1: Meubelpoot; xrec2: Stoelpoot; xrec3: Spietsrecord;
BEGIN

  IF n=0 THEN i:=1; j:=NOO; ELSE i:=n; j:=n; END;

  FOR k:=j TO i BY -1 DO
    WITH OBJ[k] DO
       CASE kind OF
	camera:	 IF (current_level#5) OR ( (sqr(pos.x-386.0)+sqr(pos.y-386.0))<1.6E5 ) THEN
                  IF KeyDown ( VK_SHIFT ) THEN
	
	                IF KeyDown( VK_UP ) AND (zdir<pi/7.0) THEN zdir := zdir+pi/100.0;
			  FOR s:=1 TO 4 DO rot_point(ZP[s],pos,X,-pi/100.0*sin(dir)); rot_point(ZP[s],pos,Y,-pi/100.0*cos(dir)); END;
	        	ELSIF KeyDown( VK_DOWN ) AND (zdir>-pi/7.0) THEN zdir := zdir-pi/100.0;
			  FOR s:=1 TO 4 DO rot_point(ZP[s],pos,X,+pi/100.0*sin(dir)); rot_point(ZP[s],pos,Y,+pi/100.0*cos(dir)); END;
			END;
			
	                IF KeyDown( VK_LEFT ) THEN posprevious:=pos; pos.x := pos.x+cos(dir+pi/2.0)*3.0; pos.y := pos.y-sin(dir+pi/2.0)*3.0;
			 FOR s:=1 TO 4 DO ZP[s].x := ZP[s].x+cos(dir+pi/2.0)*3.0; ZP[s].y := ZP[s].y-sin(dir+pi/2.0)*3.0; END;
			
	        	ELSIF KeyDown( VK_RIGHT ) THEN posprevious:=pos; pos.x := pos.x+cos(dir-pi/2.0)*3.0; pos.y := pos.y-sin(dir-pi/2.0)*3.0;
			 FOR s:=1 TO 4 DO ZP[s].x := ZP[s].x+cos(dir-pi/2.0)*3.0; ZP[s].y := ZP[s].y-sin(dir-pi/2.0)*3.0; END;
			END;
			
	            ELSE
			IF KeyDown( VK_UP ) THEN posprevious:=pos; pos.x := pos.x+cos(dir)*4.0; pos.y := pos.y-sin(dir)*4.0;
			 FOR s:=1 TO 4 DO ZP[s].x := ZP[s].x+cos(dir)*4.0; ZP[s].y := ZP[s].y-sin(dir)*4.0; END;
			
	        	ELSIF KeyDown( VK_DOWN ) THEN posprevious:=pos; pos.x := pos.x-cos(dir)*3.0; pos.y := pos.y+sin(dir)*3.0;
			 FOR s:=1 TO 4 DO ZP[s].x := ZP[s].x-cos(dir)*3.0; ZP[s].y := ZP[s].y+sin(dir)*3.0; END;
			END;
			
			IF KeyDown( VK_LEFT ) THEN dir := dir+pi/50.0; FOR s:=1 TO 4 DO rot_point(ZP[s],pos,Z,-pi/50.0); END; dir:=beperk_hoek(dir);
	        	ELSIF KeyDown( VK_RIGHT ) THEN dir := dir-pi/50.0; FOR s:=1 TO 4 DO rot_point(ZP[s],pos,Z,pi/50.0); END;  dir:=beperk_hoek(dir);
			END;
			
		    END;
		
		
		    IF KeyDown( VK_SPACE ) AND (pos.z=32.0) THEN zspeed:=4.1; pos.z:=pos.z+1.0E-5; END;	
		
			
		     IF pos.z>32.0 THEN
		     zspeed:=zspeed-GRAVITY; pos.z:=pos.z+zspeed; FOR s:=1 TO 4 DO ZP[s].z := ZP[s].z+zspeed;
		     END;
		
		     IF pos.z<32.0 THEN  FOR s:=1 TO 4 DO ZP[s].z := ZP[s].z+32.0-pos.z; END; pos.z:=32.0; END;
		    END;
		
		      calc_bb(k, pos.x-12.0, pos.y-12.0, pos.z-12.0, pos.x+12.0, pos.y+12.0, pos.z+12.0);
		    IF check_collision(k,nothing,FALSE,FALSE,FALSE,s) THEN
		
		     pp:=vect_som(posprevious,vect_neg(pos)); pp.z:=0.0;
		     pos.x:=posprevious.x; pos.y:=posprevious.y;
		      FOR s:=1 TO 4 DO ZP[s] := vect_som(ZP[s],pp); END;
		
		    END;
		 ELSE
                   zspeed:=zspeed-GRAVITY; pos.z:=pos.z+zspeed; FOR s:=1 TO 4 DO ZP[s].z := ZP[s].z+zspeed; END; IF pos.z<-128.0 THEN health:=0 END;
                 END;

		    IF timerweapondelay > 0 THEN timerweapondelay := timerweapondelay - 1; END;
		    IF aan_het_slaan THEN timer_vuistslag := timer_vuistslag + 1;
		        IF (timer_vuistslag < 2) OR (timer_vuistslag > 4) THEN pos_vuistslag := 1;
			ELSE pos_vuistslag := 2;
			END;
		     IF timer_vuistslag = 7 THEN timer_vuistslag :=0; aan_het_slaan := FALSE; pos_vuistslag := 0; END;
		    END;

		    IF KeyDown(VK_CONTROL) AND (timerweapondelay = 0) THEN
		      IF (weaponcarrying # W_vuist) THEN
                        IF (no_of_bullets[weaponcarrying]>0) THEN
		          IF weaponcarrying # W_shotgun THEN
		           s:=create_object(kogel,FALSE,FALSE); OBJ[s].pos:=pos; OBJ[s].wapen:=OBJ[cam_pos_obj].weaponcarrying; creation_event(s);
		          ELSE
		           FOR ss:=0 TO 1 DO
		            s:=create_object(kogel,FALSE,FALSE); OBJ[s].pos:=vect_som(pos,MPT((FLOAT(ss*3)-1.5)*sin(dir),(FLOAT(3*ss)-1.5)*cos(dir),0.0)); OBJ[s].wapen:=OBJ[cam_pos_obj].weaponcarrying; creation_event(s);
		           END;
                          END;
                        timerweapondelay:= weapondelays[weaponcarrying]; no_of_bullets[weaponcarrying]:=no_of_bullets[weaponcarrying]-1;
                        ELSE
                         set_message("Je kogels zijn op !",40,1,MRGB(255,32,32));
		        END;
		     ELSE
		      IF NOT aan_het_slaan THEN aan_het_slaan := TRUE; timerweapondelay := weapondelays[W_vuist]; END;		
		     END;
		    END;
		
                   IF timerweapondelay = 0 THEN
		    IF    KeyDown(VK_F1) THEN weaponcarrying := W_vuist ;
		    ELSIF KeyDown(VK_F2) AND weaponposessing[W_pistool] THEN weaponcarrying := W_pistool ;
		    ELSIF KeyDown(VK_F3) AND weaponposessing[W_uzi] THEN weaponcarrying := W_uzi ;
		    ELSIF KeyDown(VK_F4) AND weaponposessing[W_shotgun] THEN weaponcarrying := W_shotgun ;
		    ELSIF KeyDown(VK_F5) AND weaponposessing[W_bazooka] THEN weaponcarrying := W_bazooka ;
		    END;
                   END;

                    IF health>1000 THEN health := 1000; ELSIF health<0 THEN health:=0; END;
		    	ZVLAK:=ber_vlak_3pt(ZP[1],ZP[2],ZP[3]); cam_pos_obj:=k; bepaal_normaal;
   			
	|wall: set_depth(k);
	|MainFloor: ;
	|tile: set_depth(k); depth:=depth+1000.0;
	|monster: set_depth(k); s:=0; WHILE s<=NOO DO s:=s+1;
                                 IF (OBJ[s].kind=kogel) AND (OBJ[s].pos.x>=bbx1) AND (OBJ[s].pos.x<=bbx2) AND (OBJ[s].pos.y>=bby1) AND (OBJ[s].pos.y<=bby2) AND (OBJ[s].pos.z>=bbz1) AND (OBJ[s].pos.z<=bbz2) THEN
                                    monster_health:=monster_health-VAL(INTEGER,OBJ[s].kdamage); IF OBJ[s].wapen = W_bazooka THEN ss:=create_object(explosie,TRUE,FALSE); OBJ[ss].pos:=OBJ[s].pos; END; delete_object(s); monster_damaged := TRUE; monster_gotshot := TRUE;
                                 END;
                               END;

                               monster_posprevious:=pos;

                               IF (depth<=monster_data[monster_kind].Msight) OR monster_gotshot THEN R:=point_direction(pos.x,pos.y,OBJ[cam_pos_obj].pos.x,OBJ[cam_pos_obj].pos.y);
                                  pos.x := pos.x + monster_data[monster_kind].Mwalkspeed*cos(R); pos.y := pos.y - monster_data[monster_kind].Mwalkspeed*sin(R); monster_moved := TRUE;
                                  IF (OBJ[cam_pos_obj].timer_vuistslag = 3) AND (depth<40.0) AND in_fov(pos,0.7) THEN
                                   monster_health:=monster_health-25; monster_damaged := TRUE; monster_xspeed := - 8.0*cos(R); monster_yspeed := 8.0*sin(R);
                                  ELSIF depth<20.0 THEN OBJ[cam_pos_obj].health:=OBJ[cam_pos_obj].health-monster_data[monster_kind].Mpower;
                                  END;
                               END;

                               IF (monster_xspeed#0.0) AND (monster_yspeed#0.0) THEN
                                pos.x := pos.x + monster_xspeed; pos.y := pos.y + monster_yspeed; monster_moved := TRUE; monster_xspeed := monster_xspeed*0.95;
                                monster_yspeed := monster_yspeed*0.95; IF (monster_xspeed<0.1) AND (monster_yspeed<0.1) THEN monster_xspeed := 0.0; monster_yspeed := 0.0; END;
                               END;

                               IF monster_moved THEN
                                IF check_collision(k,nothing,FALSE,FALSE,FALSE,s) THEN pos := monster_posprevious; END; monster_moved := FALSE;
                                IF monster_kind#Troll THEN calc_bb(k, pos.x-10.0, pos.y-10.0, pos.z-24.0, pos.x+10.0, pos.y+10.0, pos.z+24.0);
                                ELSE calc_bb(k, pos.x-16.0, pos.y-16.0, pos.z-24.0, pos.x+16.0, pos.y+16.0, pos.z+32.0); END;
                               END;

                               IF monster_gotshot AND (depth>MAX_FOV+50.0) THEN monster_gotshot := FALSE END; solid := TRUE;
                               IF monster_health<=0 THEN
                                 IF monster_kind=Tutorial_Zombie THEN situatie:=situatie+1;
                                 ELSIF (current_level=3) AND (situatie#77) AND (monster_kind = Mummy) THEN s:=create_object(sleutel,FALSE,FALSE); OBJ[s].pos:=pos; creation_event(s); situatie:=77; END;
                                 delete_object(k);
                               END;
        |grondzombie: set_depth(k); grond_timer:=grond_timer-1;
                      IF grond_timer=0 THEN s:=create_object(monster,FALSE,FALSE); OBJ[s].monster_kind:=Tutorial_Zombie; OBJ[s].pos:=pos; OBJ[s].pos.z:=24.0; creation_event(s); delete_object(k); END;
        |spietsen: set_depth(k); depth:=depth-16; FOR s:= 1 TO 4 DO spiets_array[s].spdepth := afs_punt_punt(spiets_array[s].spcoor[0],OBJ[cam_pos_obj].pos) END;
		   FOR s := 2 TO 4 DO
                     xrec3 := spiets_array[s]; spiets_array[0] := xrec3; ss := s;
                   WHILE xrec3.spdepth > spiets_array[ss-1].spdepth DO
                     spiets_array[ss] := spiets_array[ss-1]; ss := ss-1;
                   END;
                   spiets_array[ss] := xrec3;
		  END;
                   IF (OBJ[cam_pos_obj].pos.x>=bbx1) AND (OBJ[cam_pos_obj].pos.x<=bbx2) AND (OBJ[cam_pos_obj].pos.y>=bby1) AND (OBJ[cam_pos_obj].pos.y<=bby2) AND (OBJ[cam_pos_obj].pos.z<=40.0) THEN
                    OBJ[cam_pos_obj].health:=OBJ[cam_pos_obj].health-70;
                  END;
	|blok: set_depth(k);
	|tafel: set_depth(k); FOR s:= 1 TO 4 DO tafel_poten[s].pdepth := afs_punt_punt(tafel_poten[s].pcoor^[0],OBJ[cam_pos_obj].pos); END;
		FOR s := 2 TO 4 DO
                 xrec1 := tafel_poten[s]; tafel_poten[0] := xrec1; ss := s;
                 WHILE xrec1.pdepth > tafel_poten[ss-1].pdepth DO
                   tafel_poten[ss] := tafel_poten[ss-1]; ss := ss-1;
                 END;
                 tafel_poten[ss] := xrec1;
		END;
	|kruk: set_depth(k); FOR s:= 1 TO 3 DO kruk_poten[s].pdepth := afs_punt_punt(kruk_poten[s].pcoor^[0],OBJ[cam_pos_obj].pos); END;
		FOR s := 2 TO 3 DO
                 xrec1 := kruk_poten[s]; kruk_poten[0] := xrec1; ss := s;
                 WHILE xrec1.pdepth > kruk_poten[ss-1].pdepth DO
                   kruk_poten[ss] := kruk_poten[ss-1]; ss := ss-1;
                 END;
                 kruk_poten[ss] := xrec1;
		END;
        |stoel: set_depth(k);  FOR s:= 1 TO 4 DO stoel_deel[s].sdepth := afs_punt_punt(stoel_deel[s].scoor[0],OBJ[cam_pos_obj].pos); END;
		FOR s := 2 TO 4 DO
                 xrec2 := stoel_deel[s]; stoel_deel[0] := xrec2; ss := s;
                 WHILE xrec2.sdepth > stoel_deel[ss-1].sdepth DO
                   stoel_deel[ss] := stoel_deel[ss-1]; ss := ss-1;
                 END;
                 stoel_deel[ss] := xrec2;
		END;
	|kogel: set_depth(k); depth:=depth-50.0; pos.x := pos.x + kxspeed ; pos.y := pos.y + kyspeed; pos.z := pos.z+kzspeed;
                IF (check_collision(k,nothing,TRUE,FALSE,FALSE,s) AND (OBJ[s].kind#monster) AND (OBJ[s].kind#camera)) OR (pos.z<0) OR (pos.x < level_limitsB[X,current_level]) OR (pos.y <level_limitsB[Y,current_level]) OR (pos.x > level_limitsE[X,current_level]) OR (pos.y > level_limitsE[Y,current_level]) THEN
                 IF wapen = W_bazooka THEN ss:=create_object(explosie,TRUE,FALSE); OBJ[ss].pos:=pos; END; delete_object(k);
                END;
        |wapenitem: set_depth(k);
                    IF depth<30.0 THEN
                      weaponposessing[wapen_type]:=TRUE; message_new_weapon(wapen_type); no_of_bullets[wapen_type]:=no_of_bullets[wapen_type]+bullets_in_new_weapon[wapen_type];
                      delete_object(k);
                    END;
        |deco: set_depth(k);
        |ammo: set_depth(k); FOR s:=0 TO 9 DO rot_point(ammo_array[s], pos, Z, 0.08); END;
                    IF depth<30.0 THEN
                      no_of_bullets[ammo_type]:=no_of_bullets[ammo_type]+bullets_in_mun_box[ammo_size,ammo_type]; message_found_bullets(ammo_type);
                      delete_object(k);
                    END;
        |sleutel: set_depth(k); IF depth<24.0 THEN no_of_sleutels := no_of_sleutels+1; set_message("Je hebt een sleutel gevonden !",80,1,MRGB(200,200,100)); delete_object(k); END;
        |healthbox: set_depth(k); IF depth<24.0 THEN IF healthbox_size THEN OBJ[cam_pos_obj].health := OBJ[cam_pos_obj].health + 500 ELSE OBJ[cam_pos_obj].health := OBJ[cam_pos_obj].health + 250 END; set_message("Je hebt een medikit gevonden !",80,1,MRGB(200,200,100)); delete_object(k); END;
        |schuifdeur: set_depth(k);
	            IF (NOT schuifdeur_touched) AND (OBJ[cam_pos_obj].pos.x>=bbx1) AND (OBJ[cam_pos_obj].pos.x<=bbx2) AND (OBJ[cam_pos_obj].pos.y>=bby1-10.0) AND (OBJ[cam_pos_obj].pos.y<=bby2+10.0) AND (no_of_sleutels>0) THEN
		      schuifdeur_touched := TRUE;  no_of_sleutels:=no_of_sleutels-1; IF situatie=13 THEN situatie:=14; END;
		    END;
		    IF schuifdeur_touched THEN pos_schuifdeur := pos_schuifdeur-2; calc_bb(k, pos.x-64.0, pos.y-24.0, pos.z-32.0, pos.x-64.0+FLOAT(pos_schuifdeur), pos.y+24.0, pos.z+32.0);
		    END;
		    IF pos_schuifdeur = 0 THEN delete_object(k);
		    END;
        |maan : pos:=vect_som(OBJ[cam_pos_obj].pos,MPT(1000.0,200.0,600.0));
        |tower: set_depth(k);
        |explosie: set_depth(k); IF explosie_kleur_no=3 THEN explosie_kleur_no:=0; mycol := MRGB(255,255,0);
                                 ELSE explosie_kleur_no:=explosie_kleur_no+1;
                                  IF explosie_kleur_no=2 THEN mycol := MRGB(255,0,0); ELSE mycol := MRGB(255,128,0); END;
                                 END;
                                 explosie_timer:=explosie_timer-1;
                                 IF explosie_timer>30 THEN explosie_straal := FLOAT((60-explosie_timer)**2); ELSE explosie_straal := FLOAT(explosie_timer**2); END;
                                 IF explosie_timer=0 THEN delete_object(k); END;

                                 IF depth < (explosie_straal/9) THEN OBJ[cam_pos_obj].health := OBJ[cam_pos_obj].health - 8; END;
                                 FOR s:=1 TO NOO DO
                                  IF (OBJ[s].kind=monster) AND (afs_punt_punt(OBJ[s].pos,OBJ[k].pos)<(explosie_straal/9)) THEN OBJ[s].monster_health := OBJ[s].monster_health - 6; OBJ[s].monster_gotshot:=TRUE; END;
                                 END;
        |valbal:IF valbal_delay=0 THEN
                 valbal_timer:=valbal_timer-1; IF valbal_timer=0 THEN valbal_timer:=valbal_maxtimer; pos:=valbal_beginpos; valbal_zspeed:=0.0; calc_mod_sphere(valbal_array,pos,32.0,8,8,FALSE); END;
                 valbal_lastz:=pos.z; valbal_zspeed:=valbal_zspeed+0.2;
                 IF pos.z>32.0 THEN pos.z:=pos.z-valbal_zspeed; IF pos.z<32.0 THEN pos.z:=32.0;  END; valbal_lastz:=valbal_lastz-pos.z;
                   FOR s:=0 TO 1 DO valbal_array^[0]^[s].z:=valbal_array^[0]^[s].z-valbal_lastz; END;
                   FOR s:=1 TO 8 DO
                    FOR ss:=0 TO 8 DO valbal_array^[s]^[ss].z:=valbal_array^[s]^[ss].z-valbal_lastz; END;
                   END;
                 END;
                 CASE valbal_richting OF
                  Left: pos.x := pos.x-5.0; FOR s:=0 TO 1 DO valbal_array^[0]^[s].x:=valbal_array^[0]^[s].x-5.0; rot_point(valbal_array^[0]^[s],pos,Y,-0.08); END;
                        FOR s:=1 TO 8 DO
                         FOR ss:=0 TO 8 DO
                          valbal_array^[s]^[ss].x:=valbal_array^[s]^[ss].x-5.0; rot_point(valbal_array^[s]^[ss],pos,Y,-0.08);
                         END;
                        END;
                  |Right: pos.x := pos.x+5.0; FOR s:=0 TO 1 DO valbal_array^[0]^[s].x:=valbal_array^[0]^[s].x+5.0; rot_point(valbal_array^[0]^[s],pos,Y,0.08); END;
                        FOR s:=1 TO 8 DO
                         FOR ss:=0 TO 8 DO
                          valbal_array^[s]^[ss].x:=valbal_array^[s]^[ss].x+5.0; rot_point(valbal_array^[s]^[ss],pos,Y,0.08);
                         END;
                        END;
                  |Up: pos.y := pos.y-5.0; FOR s:=0 TO 1 DO valbal_array^[0]^[s].y:=valbal_array^[0]^[s].y-5.0; rot_point(valbal_array^[0]^[s],pos,X,0.08); END;
                        FOR s:=1 TO 8 DO
                         FOR ss:=0 TO 8 DO
                          valbal_array^[s]^[ss].y:=valbal_array^[s]^[ss].y-5.0; rot_point(valbal_array^[s]^[ss],pos,X,0.08);
                         END;
                        END;
                  |Down: pos.y := pos.y+5.0; FOR s:=0 TO 1 DO valbal_array^[0]^[s].y:=valbal_array^[0]^[s].y+5.0; rot_point(valbal_array^[0]^[s],pos,X,-0.08); END;
                        FOR s:=1 TO 8 DO
                         FOR ss:=0 TO 8 DO
                          valbal_array^[s]^[ss].y:=valbal_array^[s]^[ss].y+5.0; rot_point(valbal_array^[s]^[ss],pos,X,-0.08);
                         END;
                        END;
                 END;
                 set_depth(k); IF depth<48.0 THEN OBJ[cam_pos_obj].health:=OBJ[cam_pos_obj].health-100; END;
                ELSE
                 valbal_delay:=valbal_delay-1;
                END;

        |valpijlen: set_depth(k); valpijlen_timer:=valpijlen_timer-1;
                    IF valpijlen_aant_schieten THEN
                      IF valpijlen_timer=0 THEN valpijlen_aant_schieten:=FALSE; valpijlen_timer:= 75;
                      ELSE
                       IF valpijlen_kant THEN
                        FOR s:=0 TO 2 DO valpijlen_coor[s]:=bby1+FLOAT(random(TRUNC(bby2-bby1))); END;
                       ELSE
                        FOR s:=0 TO 2 DO valpijlen_coor[s]:=bbx1+FLOAT(random(TRUNC(bbx2-bbx1))); END;
                       END;
                       FOR s:=3 TO 6 DO valpijlen_coor[s]:=bbz1+FLOAT(random(TRUNC(bbz2-bbz1))); END;
                      END;
                       IF (OBJ[cam_pos_obj].pos.x>=bbx1) AND (OBJ[cam_pos_obj].pos.x<=bbx2) AND (OBJ[cam_pos_obj].pos.y>=bby1) AND (OBJ[cam_pos_obj].pos.y<=bby2) THEN
                       OBJ[cam_pos_obj].health:=OBJ[cam_pos_obj].health-30;
                       END;
                    ELSE
                      IF valpijlen_timer=0 THEN valpijlen_aant_schieten:=TRUE; valpijlen_timer:= 25; END;
                    END;
        |weer: bliksem_timer:=bliksem_timer-1;
               IF bliksem_timer=0 THEN
                IF aant_bliksemen THEN
                bliksem_timer:=250+random(100); aant_bliksemen:=FALSE;
                ELSE
                bliksem_timer:=10; aant_bliksemen:=TRUE;
                END;
               END;
               FOR s:=1 TO 250 DO
               rain_array[s].z:=rain_array[s].z-9; IF ((rain_array[s].z<8.0) AND (sqr(rain_array[s].x-384.0)+sqr(rain_array[s].y-384.0)<147456.0)) OR (rain_array[s].z<-64.0) THEN rain_array[s]:=MPT(OBJ[cam_pos_obj].pos.x-320.0+FLOAT(random(640)),OBJ[cam_pos_obj].pos.y-320.0+FLOAT(random(640)),250.0+FLOAT(random(100))); END;
               END;
        |tutorial: IF tut_timer>0 THEN tut_timer:=tut_timer-1; END; set_depth(k); depth:=depth+1000.0;
                   CASE situatie OF
                     0: IF tut_timer=0 THEN set_message("Gebruik de pijltjestoetsen om rond te bewegen. Druk op spatie om te springen.",80,1,MRGB(128,128,255)); tut_timer:=80; situatie:=1; END;
                    |1: IF tut_timer=0 THEN set_message("Duw op SHIFT+links/rechts om zijlings te bewegen.",80,1,MRGB(128,128,255)); tut_timer:=80; situatie:=2; END;
                    |2: IF tut_timer=0 THEN set_message("Duw op SHIFT+boven/beneden om omhoog/omlaag te kijken. Probeer eens naar de maan te kijken.",80,1,MRGB(128,128,255)); tut_timer:=80; situatie:=3; END;
                    |3: IF tut_timer=0 THEN set_message("Gebruik CONTROL op te slaan. Ga op het blauwe vlakje staan om de training te beginnen. ",80,1,MRGB(128,128,255)); tut_timer:=80; situatie:=4; END;
                    |4: IF (tut_timer=0) AND (OBJ[cam_pos_obj].pos.x>=bbx1) AND (OBJ[cam_pos_obj].pos.x<=bbx2) AND (OBJ[cam_pos_obj].pos.y>=bby1) AND (OBJ[cam_pos_obj].pos.y<=bby2) THEN
                         s:=create_object(grondzombie,FALSE,FALSE); OBJ[s].pos:=MPT(200.0+FLOAT(random(200)),600.0+FLOAT(random(200)),12.0); creation_event(s);
                         set_message("Ziehier een typische zombie. Probeer hem neer te slaan zonder je te kwetsen.",80,1,MRGB(128,128,255)); situatie:=5; END;
                    |6: set_message("Goed zo ! Nu geven we je je wapen. Het staat in de hoek. Maak er goed gebruik van. ",100,1,MRGB(128,128,255)); tut_timer:=100; situatie:=7;
                        s:=create_object(wapenitem,FALSE,FALSE); OBJ[s].pos:=MPT(50.0,950.0,20.0); OBJ[s].wapen_type:=W_pistool; creation_event(s);
                    |7: IF tut_timer=0 THEN set_message("Kom dan terug op het blauwe vlakje staan. Schieten doe je ook met CONTROL.",60,1,MRGB(128,128,255)); tut_timer:=40; situatie:=8; END;
                    |8: IF (tut_timer=0) AND (OBJ[cam_pos_obj].pos.x>=bbx1) AND (OBJ[cam_pos_obj].pos.x<=bbx2) AND (OBJ[cam_pos_obj].pos.y>=bby1) AND (OBJ[cam_pos_obj].pos.y<=bby2) THEN
                         FOR ss:=0 TO 2 DO s:=create_object(grondzombie,FALSE,FALSE); OBJ[s].kind:=grondzombie; OBJ[s].pos:=MPT(200.0+100.0*FLOAT(ss),600.0+FLOAT(random(200)),12.0); creation_event(s); END;
                         set_message("Schiet de drie zombies neer. Succes !",60,1,MRGB(128,128,255)); situatie:=9; END;
                    |12: set_message("Goed gedaan ! Neem de sleutel om de rode deur te openen.",80,1,MRGB(128,128,255)); situatie:=13;
                         s:=create_object(sleutel,FALSE,FALSE); OBJ[s].pos:=MPT(560.0,700.0,32.0); creation_event(s);
                    |14: set_message("Dit doosje is een health-kit. Spring nog over de hindernissen en je bent gewonnen !",80,1,MRGB(128,128,255)); situatie:=15;
                   ELSE ;
                   END;
        |finish:IF (OBJ[cam_pos_obj].pos.x>=bbx1) AND (OBJ[cam_pos_obj].pos.x<=bbx2) AND (OBJ[cam_pos_obj].pos.y>=bby1) AND (OBJ[cam_pos_obj].pos.y<=bby2) THEN level_done:=TRUE; END;
        |towertop:;
        |lamp: set_depth(k); IF lamp_timer>0 THEN lamp_timer:=lamp_timer-1; END;
               IF kapot AND (lamp_timer=0) THEN
                IF lamp_aan THEN lamp_aan:=FALSE; mycol:=MRGB(100,100,30); LIGHTARR[mijnlampno].on:=FALSE; lamp_timer:=2+random(3);
                ELSE lamp_aan:=TRUE; mycol:=MRGB(200,200,60); LIGHTARR[mijnlampno].on:=TRUE; lamp_timer:=7+random(10); END;
               END;
        |draak: IF begin_gevecht THEN set_depth(k); draak_timer:=draak_timer-1;
                 IF aanval_modus<4 THEN
                   CASE aanval_modus OF
                     0: draak_hoek:=draak_hoek+0.03;
                    |1: draak_hoek:=draak_hoek+0.05;
                    |2: draak_hoek:=draak_hoek-0.03;
                    |3: draak_hoek:=draak_hoek-0.05;
                   END;
                   pos:=MPT(484*cos(draak_hoek)+384.0,484*sin(draak_hoek)+384,pos.z);
                   IF random(100)<1 THEN aanval_modus:=random(3); END;
                   IF draak_timer=0 THEN aanval_modus:=4+random(1); draak_timer:=80+random(20); END;
                 ELSE
                   CASE aanval_modus OF
                    4: IF (general_timer MOD 5 = 0) THEN pp:=vect_som(OBJ[cam_pos_obj].pos,vect_neg(pos)); pp:=scal_verm(pp,1.0/norm(pp));
                       s:=create_object(vuurbal,TRUE,FALSE); OBJ[s].pos:=pos; OBJ[s].vxspeed:=18*pp.x; OBJ[s].vyspeed:=18*pp.y; OBJ[s].vzspeed:=18*pp.z; END;
                   |5: IF (general_timer MOD 10 = 0) THEN pp:=vect_som(OBJ[cam_pos_obj].pos,vect_neg(pos)); pp:=scal_verm(pp,1.0/norm(pp));
                       s:=create_object(bommetje,TRUE,FALSE); OBJ[s].pos:=pos; OBJ[s].vxspeed:=(0.9+FLOAT(random(20))/100)*12*pp.x; OBJ[s].vyspeed:=(0.9+FLOAT(random(20))/100)*12*pp.y; OBJ[s].vzspeed:=(0.9+FLOAT(random(20))/100)*depth/500; END;
                   |6: IF draak_timer=1 THEN notquitted:=FALSE; TextBox( "Je hebt Bailor verslagen ! Belgi is gered.", "Gefeliciteerd !" ); END;
                   END;
                   IF draak_timer=0 THEN aanval_modus:=random(3); draak_timer:=200+random(50); END;
                 END;
                 s:=0; WHILE s<=NOO DO s:=s+1;
                         IF (OBJ[s].kind=kogel) AND (afs_punt_punt(OBJ[s].pos,pos)<80.0) THEN
                           draak_health:=draak_health-VAL(INTEGER,OBJ[s].kdamage); IF OBJ[s].wapen = W_bazooka THEN ss:=create_object(explosie,TRUE,FALSE); OBJ[ss].pos:=OBJ[s].pos; END; delete_object(s); draak_damaged := TRUE;
                         END;
                       END;
                ELSE
                 pos.z:=pos.z+4.0; IF pos.z>=150.0 THEN pos.z:=150.0; begin_gevecht:=TRUE; END;
                END;
                IF draak_afbeelding=11 THEN draak_afbeelding:=0 ELSE draak_afbeelding:=draak_afbeelding+1 END;
                IF draak_health<=0 THEN draak_health:=0; IF aanval_modus#6 THEN draak_timer:=40; aanval_modus:=6; END; END;
                IF (no_of_bullets[W_pistool]=0) AND put_munition THEN s:=create_object(ammo,FALSE,FALSE); OBJ[s].ammo_type := W_pistool; OBJ[s].ammo_size := 3; OBJ[s].pos:=MPT(384.0,384.0,24.0); creation_event(s); put_munition:=FALSE END;
                IF (no_of_bullets[W_pistool]>0) THEN put_munition:=TRUE; END;
        |vuurbal: pos.x := pos.x + vxspeed ; pos.y := pos.y + vyspeed; pos.z := pos.z+vzspeed; set_depth(k);
                IF check_collision(k,camera,TRUE,FALSE,FALSE,s) THEN OBJ[cam_pos_obj].health:=OBJ[cam_pos_obj].health-15;
                ELSIF (pos.z<0.0) OR (depth>1000.0) THEN delete_object(k); END;
        |bommetje: vzspeed:=vzspeed-0.2; pos.x := pos.x + vxspeed ; pos.y := pos.y + vyspeed; pos.z := pos.z+vzspeed; set_depth(k);
                IF (pos.z<0.0) THEN ss:=create_object(explosie,TRUE,FALSE); OBJ[ss].pos:=pos; delete_object(k); END;
	|nothing:;
       END;
      END;
     END;

END continuous_event;


(* Drawing (alles wat gerelateerd is aan weergave e.d.) *)
PROCEDURE drawing_event(n:CARDINAL);
VAR i,j,k,s:CARDINAL; vp: VPunt; pp: Punt;
BEGIN

IF n=0 THEN i:=1; j:=NOO; ELSE i:=n; j:=n; END;

   FOR k:=j TO i BY -1 DO
     WITH OBJ[k] DO
       CASE kind OF
         camera: IF weaponcarrying=W_vuist THEN
	             CASE pos_vuistslag OF
		          |0: DrawMaskBitmap(SPRITELIB[S_Lhand,0]^[0],MASKLIB[S_Lhand,0]^[0],130,396 ); DrawMaskBitmap(SPRITELIB[S_Rhand,0]^[0],MASKLIB[S_Rhand,0]^[0],310,388);
			  |1: DrawMaskBitmap(SPRITELIB[S_Lhand,1]^[0],MASKLIB[S_Lhand,1]^[0],130,376 ); DrawMaskBitmap(SPRITELIB[S_Rhand,0]^[0],MASKLIB[S_Rhand,0]^[0],310,408);
			  |2: DrawMaskBitmap(SPRITELIB[S_Lhand,2]^[0],MASKLIB[S_Lhand,2]^[0],130,328 ); DrawMaskBitmap(SPRITELIB[S_Rhand,0]^[0],MASKLIB[S_Rhand,0]^[0],310,428);
                     ELSE;
		     END;					
                ELSE  CASE weaponcarrying OF
	  		|W_pistool: DrawMaskBitmap(SPRITELIB[S_pistool,0]^[0],MASKLIB[S_pistool,0]^[0],427,309);
			  FOR s:=0 TO 10 DO blend_color(SCREEN_WIDTH/2,SCREEN_HEIGHT/2-5+s,MRGB(255,128,128)); END;
			  FOR s:=0 TO 10 DO  IF s#5 THEN blend_color(SCREEN_WIDTH/2-5+s,SCREEN_HEIGHT/2,MRGB(255,128,128)); END; END;
			|W_shotgun: DrawMaskBitmap(SPRITELIB[S_shotgun,0]^[0],MASKLIB[S_shotgun,0]^[0],407,263);
			  FOR s:=0 TO 8 DO blend_color(SCREEN_WIDTH/2-10+(s MOD 3),SCREEN_HEIGHT/2-1+(s DIV 3),MRGB(255,128,128)); END;
			  FOR s:=0 TO 8 DO blend_color(SCREEN_WIDTH/2+8+(s MOD 3),SCREEN_HEIGHT/2-1+(s DIV 3),MRGB(255,128,128)); END;
			|W_uzi: DrawMaskBitmap(SPRITELIB[S_uzi,0]^[0],MASKLIB[S_uzi,0]^[0],472,229);
			  FOR s:=0 TO 8 DO blend_color(SCREEN_WIDTH/2-4+s,SCREEN_HEIGHT/2-4+s,MRGB(255,128,128)); END;
			  FOR s:=0 TO 8 DO  IF s#4 THEN blend_color(SCREEN_WIDTH/2-4+s,SCREEN_HEIGHT/2+4-s,MRGB(255,128,128)); END; END;
			|W_bazooka: DrawMaskBitmap(SPRITELIB[S_bazooka,0]^[0],MASKLIB[S_bazooka,0]^[0],399,244);
			  FOR s:=0 TO 4 DO blend_color(SCREEN_WIDTH/2-2+s,SCREEN_HEIGHT/2-3,MRGB(255,128,128)); END;
			  FOR s:=0 TO 4 DO blend_color(SCREEN_WIDTH/2-2+s,SCREEN_HEIGHT/2+3,MRGB(255,128,128)); END;
			  FOR s:=0 TO 4 DO blend_color(SCREEN_WIDTH/2-3,SCREEN_HEIGHT/2-2+s,MRGB(255,128,128)); END;
			  FOR s:=0 TO 4 DO blend_color(SCREEN_WIDTH/2+3,SCREEN_HEIGHT/2-2+s,MRGB(255,128,128)); END;
                      ELSE;
                      END;
                      SetFont(1,RgbColor(192,192,255));  Text("Kogels:",SCREEN_WIDTH-96,SCREEN_HEIGHT-18);
                      TextCard(no_of_bullets[weaponcarrying],SCREEN_WIDTH-40,SCREEN_HEIGHT-18);
		END;
                IF no_of_sleutels>0 THEN SetFont(1,RgbColor(192,192,128)); TextCard(no_of_sleutels,12,SCREEN_HEIGHT-18); END;
                draw_healthbar(health,TRUE); IF health = 0 THEN game_over_ctrl; END;
					
        |wall:  IF (depth<=MAX_FOV) AND (depth>=1.0) THEN
		  CASE wall_direction OF
                     	 Left: draw_poly4(MPT(pos.x,pos.y+32.0,pos.z-32.0+wall_height),MPT(pos.x,pos.y+32.0,pos.z-32.0),MPT(pos.x,pos.y-32.0,pos.z-32.0+wall_height),MPT(pos.x,pos.y-32.0,pos.z-32.0),calc_lighted_color(mycol,wall_LA,maxnolt,depth),2,FALSE);
			|Right: draw_poly4(MPT(pos.x,pos.y+32.0,pos.z-32.0),MPT(pos.x,pos.y+32.0,pos.z-32.0+wall_height),MPT(pos.x,pos.y-32.0,pos.z-32.0),MPT(pos.x,pos.y-32.0,pos.z-32.0+wall_height),calc_lighted_color(mycol,wall_LA,maxnolt,depth),2,FALSE);
			|Up: draw_poly4(MPT(pos.x+32.0,pos.y,pos.z-32.0+wall_height),MPT(pos.x+32.0,pos.y,pos.z-32.0),MPT(pos.x-32.0,pos.y,pos.z-32.0+wall_height),MPT(pos.x-32.0,pos.y,pos.z-32.0),calc_lighted_color(mycol,wall_LA,maxnolt,depth),2,FALSE);
			|Down: draw_poly4(MPT(pos.x+32.0,pos.y,pos.z-32.0),MPT(pos.x+32.0,pos.y,pos.z-32.0+wall_height),MPT(pos.x-32.0,pos.y,pos.z-32.0),MPT(pos.x-32.0,pos.y,pos.z-32.0+wall_height),calc_lighted_color(mycol,wall_LA,maxnolt,depth),2,FALSE);
		  END;
		END;
	|MainFloor: IF veraf THEN s:=TRUNC( FLOAT(SCREEN_HEIGHT)*((OBJ[cam_pos_obj].zdir*420.0-32.0)/480.0+0.5) ); Rectangle(0,s,SCREEN_WIDTH,SCREEN_HEIGHT,RgbColor(mycol.r,mycol.g,mycol.b),TRUE);
                       draw_mountains(0.0,VAL(INTEGER,s),0); draw_mountains(1.7,VAL(INTEGER,s),1); draw_mountains(3.8,VAL(INTEGER,s),2);
                    ELSE Rectangle(0,TRUNC(FLOAT(SCREEN_HEIGHT)*((OBJ[cam_pos_obj].zdir*420.0+( OBJ[cam_pos_obj].pos.z/2)-32.0)/480.0+0.5)),SCREEN_WIDTH,SCREEN_HEIGHT,RgbColor(mycol.r,mycol.g,mycol.b),TRUE);
                    END;
	|tile: IF (depth<=MAX_FOV+1000.0) THEN draw_poly4(MPT(pos.x+32.0,pos.y-32.0,pos.z),MPT(pos.x+32.0,pos.y+32.0,pos.z),MPT(pos.x-32.0,pos.y-32.0,pos.z),MPT(pos.x-32.0,pos.y+32.0,pos.z),mycol,2,FALSE); END;
	|monster: IF (depth<MAX_FOV) AND (depth>=1.0) THEN IF monster_damaged THEN draw_sprite(monster_data[monster_kind].Minvsprite,0, TRUE, depth, 10, pos); monster_damaged:=FALSE; ELSE draw_sprite(monster_data[monster_kind].Msprite,monster_data[monster_kind].Msubimg, TRUE, depth, 10, pos); END; END;
        |grondzombie: IF (depth<MAX_FOV) AND (depth>=1.0) THEN draw_sprite(S_zombie,3, TRUE, depth, 10, pos); END;
        |spietsen:  IF (depth<=MAX_FOV) AND (depth>=1.0) THEN FOR s:=1 TO 4 DO draw_mod_pyramid(spiets_array[s].spcoor,mycol); END; END;
        |blok: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN draw_mod_cuboid(blok_array,mycol); END;
	|tafel: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN FOR s:=1 TO 4 DO draw_mod_cylinder(tafel_poten[s].pcoor,tafel_poten[s].pcoor,mycol,FALSE); END; draw_mod_cuboid(tafel_blad,mycol);  END;
	|kruk: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN FOR s:=1 TO 3 DO draw_mod_cylinder(kruk_poten[s].pcoor,kruk_poten[s].pcoor,mycol,FALSE); END; draw_mod_cylinder(kruk_blad1,kruk_blad2,mycol,TRUE); END;
        |stoel: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN FOR s:=1 TO 6 DO draw_mod_cuboid(stoel_deel[s].scoor,mycol); END; END;
	|kogel: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN draw_ball(pos,40.0,depth,mycol,2); END;
        |wapenitem: IF (depth<MAX_FOV) AND (depth>=1.0) THEN draw_sprite(wapen_sprite,0, TRUE, depth, 6, pos); END;
        |deco: IF (depth<MAX_FOV) AND (depth>=1.0) THEN draw_sprite(deco_sprite,deco_sprite_subimg, TRUE, depth, deco_sprite_no, pos); END;
        |ammo: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN draw_mod_cuboid(ammo_array,mycol); END;
        |sleutel: IF (depth<MAX_FOV) AND (depth>=1.0) THEN draw_sprite(S_sleutel,0, TRUE, depth, 8, pos); END;
        |healthbox: IF (depth<MAX_FOV) THEN IF healthbox_size THEN draw_sprite(S_healthbox,1, TRUE, depth, 8, pos); ELSE draw_sprite(S_healthbox,0, TRUE, depth, 8, pos); END;  END;
	|schuifdeur: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN
		       draw_poly4(MPT(pos.x-64.0+FLOAT(pos_schuifdeur),pos.y,pos.z+32.0),MPT(pos.x-64.0+FLOAT(pos_schuifdeur),pos.y,pos.z-32.0),MPT(pos.x-64.0,pos.y,pos.z+32.0),MPT(pos.x-64.0,pos.y,pos.z-32.0),mycol,2,FALSE);
		     END;
        |maan: IF in_fov(pos,0.4) THEN  vp:=proj_coord(pos); DrawMaskBitmap(SPRITELIB[S_maan,0]^[0],MASKLIB[S_maan,0]^[0],vp.x-50,vp.y-50); END;
               FOR s:=0 TO 31 DO pp:=vect_som(OBJ[cam_pos_obj].pos,sterren_array[s]); IF in_fov(pp,0.4) THEN NPlot(proj_coord(pp),MRGB(255,255,255)); END; END;
        |tower: draw_mod_cylinder(tower_array,tower_array,mycol,FALSE);
                 draw_poly4(MPT(pos.x,pos.y+384.0,pos.z+160.0),MPT(pos.x,pos.y+384.0,pos.z),MPT(pos.x-384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+120.0),MPT(pos.x-384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z),MRGB(0,0,0),1,FALSE);
                 draw_poly4(MPT(pos.x+384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+120.0),MPT(pos.x+384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z),MPT(pos.x,pos.y+384.0,pos.z+160.0),MPT(pos.x,pos.y+384.0,pos.z),MRGB(0,0,0),1,FALSE);

                 draw_poly4(MPT(pos.x+384.0*sin(pi/4),pos.y+384.0*cos(pi/4),pos.z+600.0),MPT(pos.x+384.0*sin(pi/4),pos.y+384.0*cos(pi/4),pos.z+540.0),MPT(pos.x+384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+600.0),MPT(pos.x+384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+540.0),MRGB(24,24,24),1,FALSE);
                 draw_poly4(MPT(pos.x+384.0*sin(pi/4),pos.y+384.0*cos(pi/4),pos.z+920.0),MPT(pos.x+384.0*sin(pi/4),pos.y+384.0*cos(pi/4),pos.z+860.0),MPT(pos.x+384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+920.0),MPT(pos.x+384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+860.0),MRGB(24,24,24),1,FALSE);
                 draw_poly4(MPT(pos.x-384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+600.0),MPT(pos.x-384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+540.0),MPT(pos.x-384.0*sin(pi/4),pos.y+384.0*cos(pi/4),pos.z+600.0),MPT(pos.x-384.0*sin(pi/4),pos.y+384.0*cos(pi/4),pos.z+540.0),MRGB(24,24,24),1,FALSE);
                 draw_poly4(MPT(pos.x-384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+920.0),MPT(pos.x-384.0*sin(pi/8),pos.y+384.0*cos(pi/8),pos.z+860.0),MPT(pos.x-384.0*sin(pi/4),pos.y+384.0*cos(pi/4),pos.z+920.0),MPT(pos.x-384.0*sin(pi/4),pos.y+384.0*cos(pi/4),pos.z+860.0),MRGB(24,24,24),1,FALSE);
        |explosie: IF (depth<=MAX_FOV+300.0) AND (depth>=1.0) THEN draw_ball(pos,explosie_straal,depth,mycol,2); END;
        |valbal: IF (depth<=MAX_FOV) AND in_fov(pos,0.4) AND (depth>=1.0) AND (valbal_delay=0) THEN draw_mod_sphere(valbal_array,mycol); END;
        |valpijlen: IF valpijlen_aant_schieten AND (depth<MAX_FOV) AND (depth>=1.0) THEN
                     IF valpijlen_kant THEN
                      FOR s:=0 TO 2 DO draw_line(MPT(bbx1,valpijlen_coor[s],valpijlen_coor[s+3]),MPT(bbx2,valpijlen_coor[s],valpijlen_coor[s+3]),MRGB(240,240,240)); END;
                     ELSE
                      FOR s:=0 TO 2 DO draw_line(MPT(valpijlen_coor[s],bby1,valpijlen_coor[s+3]),MPT(valpijlen_coor[s],bby2,valpijlen_coor[s+3]),MRGB(240,240,240)); END;
                     END;
                    END;
        |towertop: draw_mod_cylinder(towertop_array1,towertop_array2,mycol,TRUE); smart_seq4(towertop_array3^,1,2,mycol,FALSE);
                   draw_poly4(MPT(418.0,354.0,0.0),MPT(418.0,418.0,0.0),MPT(354.0,354.0,0.0),MPT(354.0,418.0,0.0),MRGB(60,60,60),2,FALSE);
                   draw_poly4(MPT(162.0,354.0,0.0),MPT(162.0,418.0,0.0),MPT(98.0,354.0,0.0) ,MPT(98.0,418.0,0.0),MRGB(60,60,60),2,FALSE);
                   draw_poly4(MPT(674.0,354.0,0.0),MPT(674.0,418.0,0.0),MPT(610.0,354.0,0.0),MPT(610.0,418.0,0.0),MRGB(60,60,60),2,FALSE);
                   draw_poly4(MPT(418.0,98.0,0.0),MPT(418.0,162.0,0.0),MPT(354.0,98.0,0.0) ,MPT(354.0,162.0,0.0),MRGB(60,60,60),2,FALSE);
                   draw_poly4(MPT(418.0,610.0,0.0),MPT(418.0,674.0,0.0),MPT(354.0,610.0,0.0),MPT(354.0,674.0,0.0),MRGB(60,60,60),2,FALSE);
        |weer: IF aant_bliksemen AND (bliksem_timer MOD 2 = 1) THEN Rectangle(0,0,SCREEN_WIDTH,SCREEN_HEIGHT,RgbColor(255,255,255),TRUE);
               ELSE FOR s:=1 TO 250 DO draw_line(rain_array[s],MPT(rain_array[s].x,rain_array[s].y,rain_array[s].z-8.0),MRGB(153,217,234)); END;  END;
        |tutorial: IF (depth<=MAX_FOV+1000.0) THEN draw_poly4(MPT(pos.x+32.0,pos.y-32.0,pos.z),MPT(pos.x+32.0,pos.y+32.0,pos.z),MPT(pos.x-32.0,pos.y-32.0,pos.z),MPT(pos.x-32.0,pos.y+32.0,pos.z),MRGB(0,0,220),2,FALSE); END;
        |finish: IF level_done THEN level_done:=FALSE; mission_done_ctrl; END;
        |lamp: IF (depth<=MAX_FOV) AND in_fov(pos,0.4) AND (depth>=1.0) THEN draw_line(MPT(pos.x,pos.y,pos.z+12.0),MPT(pos.x,pos.y,pos.z+32.0),MRGB(16,16,32)); draw_mod_sphere(lampbol_array,mycol);  END;
        |draak: IF aanval_modus<6 THEN  IF draak_damaged THEN draw_sprite(S_I_draak,draak_afbeelding DIV 3, TRUE, depth, 8, pos); draak_damaged:=FALSE; ELSE draw_sprite(S_draak,draak_afbeelding DIV 3, TRUE, depth, 10, pos); END; END; draw_healthbar(draak_health,FALSE);
        |vuurbal: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN draw_ball(pos,80.0,depth,mycol,2); END;
        |bommetje: IF (depth<=MAX_FOV) AND (depth>=1.0) THEN draw_ball(pos,80.0,depth,mycol,2); END;
        |nothing:;
      END;
     END;
    END;

END drawing_event;

(* Naar een nieuw level gaan *)
PROCEDURE goto_level(n:CARDINAL);

BEGIN
 IF current_level#0 THEN sprite_data(FALSE,current_level); dispose_obj_vars(0); END;
 current_level:=n;
 level_begin:=TRUE;
 GetLocalTime( time1 );
END goto_level;

(*==========================================================================================*)
(* LEVELS : Opbouw van de levels door bepaling van de parameters van de objecten per level. *)
(*==========================================================================================*)

(* Crert objecten en geeft ze waarden, volgens het level *)
(* !!! Twee vereisten: 1) camera moet altijd op OBJ[1] staan. 2) Er moeten minstens 3 objecten zijn per level (althans NOO >=3) . *)
PROCEDURE place_objects(level:CARDINAL);
VAR i:CARDINAL;
BEGIN

  CASE level OF
	
(*	WITH OBJ[n] DO
		kind := tafel;
		pos := MPT(500.0,80.0,20.0);
		mycol := MRGB(156,90,90);
	END;

        WITH OBJ[n] DO
		kind := kruk;
		pos := MPT(500.0,110.0,10.0);
		mycol := MRGB(170,98,98);
	END;

        WITH OBJ[n] DO
		kind := stoel;
		pos := MPT(500.0,50.0,12.0);
		mycol := MRGB(140,122,80);
	END;  *)

   |1: NOO := 80; (*aantal objecten *)
  	
	WITH OBJ[1] DO
		kind := camera;
		pos := MPT(320.0,950.0,32.0);
                placed_direction:=Right;
	END;
	
	
    FOR i := 0 TO 4 DO
	WITH OBJ[2*i+2] DO
		kind := wall;
		pos := MPT(32.0+FLOAT(2*i)*64.0,1000.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(134,75,51);
		wall_direction := Down;
	END;	
		
	WITH OBJ[2*i+3] DO
		kind := wall;
		pos := MPT(32.0+FLOAT(2*i+1)*64.0,1000.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(159,81,57);
		wall_direction := Down;
	END;
     END;

        WITH OBJ[12] DO
		kind := MainFloor;
		mycol := MRGB(0,128,0);
                veraf := FALSE;
	END;
	
    FOR i:= 0 TO 3 DO
        WITH OBJ[2*i+13] DO
		kind := wall;
		pos := MPT(0.0,968.0-FLOAT(2*i)*64,32.0);
                wall_height := 96.0;
		mycol := MRGB(159,81,57);
		wall_direction := Right;
	END;
	
	WITH OBJ[2*i+14] DO
		kind := wall;
		pos := MPT(0.0,968.0-FLOAT(2*i+1)*64,32.0);
                wall_height := 96.0;
		mycol := MRGB(134,75,51);
		wall_direction := Right;
	END;
     END;

    FOR i:= 0 TO 3 DO
        WITH OBJ[2*i+21] DO
		kind := wall;
		pos := MPT(640.0,968.0-FLOAT(2*i)*64,32.0);
                wall_height := 96.0;
		mycol := MRGB(134,75,51);
		wall_direction := Left;
	END;
	
	WITH OBJ[2*i+22] DO
		kind := wall;
		pos := MPT(640.0,968.0-FLOAT(2*i+1)*64,32.0);
                wall_height := 96.0;
		mycol := MRGB(159,81,57);
		wall_direction := Left;
	END;
     END;

    FOR i:= 0 TO 1 DO
       	WITH OBJ[2*i+29] DO
		kind := wall;
		pos := MPT(32.0+FLOAT(2*i)*64,488.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(159,81,57);
		wall_direction := Up;
	END;
	
	WITH OBJ[2*i+30] DO
		kind := wall;
		pos := MPT(32.0+FLOAT(2*i+1)*64,488.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(134,75,51);
   		wall_direction := Up;
	END;
    END;

    FOR i:= 0 TO 1 DO
       	WITH OBJ[2*i+33] DO
		kind := wall;
		pos := MPT(608.0-FLOAT(2*i)*64,488.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(134,75,51);
		wall_direction := Up;
	END;
	
	WITH OBJ[2*i+34] DO
		kind := wall;
		pos := MPT(608.0-FLOAT(2*i+1)*64,488.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(159,81,57);
   		wall_direction := Up;
	END;
    END;

   FOR i:= 0 TO 3 DO
     IF i#2 THEN
       	WITH OBJ[2*i+37] DO
		kind := wall;
		pos := MPT(256.0,456.0-FLOAT(2*i)*64,32.0);
                wall_height := 96.0;
		mycol := MRGB(127,127,127);
		wall_direction := Right;
	END;
	
	WITH OBJ[2*i+38] DO
		kind := wall;
		pos := MPT(256.0,456.0-FLOAT(2*i+1)*64,32.0);
                wall_height := 96.0;
		mycol := MRGB(114,114,114);
   		wall_direction := Right;
	END;
     END;    		
  END;

  FOR i:= 0 TO 3 DO
     IF i#2 THEN
       	WITH OBJ[2*i+45] DO
		kind := wall;
		pos := MPT(384.0,456.0-FLOAT(2*i)*64,32.0);
                wall_height := 96.0;
		mycol := MRGB(127,127,127);
		wall_direction := Left;
	END;
	
	WITH OBJ[2*i+46] DO
		kind := wall;
		pos := MPT(384.0,456.0-FLOAT(2*i+1)*64,32.0);
                wall_height := 96.0;
		mycol := MRGB(114,114,114);
   		wall_direction := Left;
	END;
     END;
  END;

        WITH OBJ[41] DO
		kind := schuifdeur;
		pos := MPT(320.0,488.0,32.0);
		mycol := MRGB(215,0,0);
        END;

	WITH OBJ[42] DO
		kind := deco;
		pos := MPT(200.0,800.0,32.0);
                deco_sprite := S_tree;
                deco_sprite_subimg := 0;
                deco_sprite_no := 6;
                calc_bb(42, pos.x-12.0, pos.y-12.0, pos.z, pos.x+12.0, pos.y+12.0, pos.z+32.0);
                solid := TRUE;
        END;

	WITH OBJ[49] DO
		kind := maan;
	END;

   FOR i:=0 TO 3 DO
        WITH OBJ[56+i] DO
		kind := spietsen;
		pos := MPT(300.0+FLOAT(i MOD 2)*56,296.0+FLOAT(i DIV 2)*128,0.0);
                mycol := MRGB(255,240,240);
	END;
   END;

        WITH OBJ[50] DO
		kind := valbal;
		pos := MPT(136.0,168.0,100.0);
                valbal_richting:=Right;
                valbal_maxtimer:=100;
                valbal_delay:=0;
                mycol:=MRGB(192,160,64);
	END;

        WITH OBJ[61] DO
		kind := valpijlen;
		pos := MPT(320.0,64.0,32.0);
                valpijlen_kant := TRUE;
                calc_bb(61, pos.x-64.0, pos.y-32.0, pos.z-32.0, pos.x+64.0, pos.y+32.0, pos.z+32.0);
	END;

        WITH OBJ[62] DO
		kind := tutorial;
		pos := MPT(320.0,900.0,0.0);
        END;

        WITH OBJ[63] DO
		kind := deco;
		pos := MPT(330.0,-60.0,32.0);
                deco_sprite := S_tree;
                deco_sprite_subimg := 1;
                deco_sprite_no := 6;
                calc_bb(63, pos.x-12.0, pos.y-12.0, pos.z, pos.x+12.0, pos.y+12.0, pos.z+32.0);
                solid := TRUE;
        END;

        WITH OBJ[64] DO
		kind := deco;
		pos := MPT(355.0,-90.0,32.0);
                deco_sprite := S_tree;
                deco_sprite_subimg := 0;
                deco_sprite_no := 6;
                calc_bb(64, pos.x-12.0, pos.y-12.0, pos.z, pos.x+12.0, pos.y+12.0, pos.z+32.0);
                solid := TRUE;
        END;

       	WITH OBJ[65] DO
		kind := wall;
		pos := MPT(128.0,136.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(127,127,127);
		wall_direction := Right;
	END;
	
	WITH OBJ[66] DO
		kind := wall;
		pos := MPT(128.0,200.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(114,114,114);
   		wall_direction := Right;
	END;

        WITH OBJ[67] DO
		kind := wall;
		pos := MPT(512.0,136.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(127,127,127);
		wall_direction := Left;
	END;
	
	WITH OBJ[68] DO
		kind := wall;
		pos := MPT(512.0,200.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(114,114,114);
   		wall_direction := Left;
	END;

        WITH OBJ[69] DO
		kind := wall;
		pos := MPT(160.0,104.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(127,127,127);
		wall_direction := Up;
	END;
	
	WITH OBJ[70] DO
		kind := wall;
		pos := MPT(224.0,104.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(114,114,114);
   		wall_direction := Up;
	END;

        WITH OBJ[71] DO
		kind := wall;
		pos := MPT(416.0,104.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(127,127,127);
		wall_direction := Up;
	END;
	
	WITH OBJ[72] DO
		kind := wall;
		pos := MPT(480.0,104.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(114,114,114);
   		wall_direction := Up;
	END;

        WITH OBJ[73] DO
		kind := wall;
		pos := MPT(160.0,232.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(127,127,127);
		wall_direction := Down;
	END;
	
	WITH OBJ[74] DO
		kind := wall;
		pos := MPT(224.0,232.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(114,114,114);
   		wall_direction := Down;
	END;

        WITH OBJ[75] DO
		kind := wall;
		pos := MPT(416.0,232.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(127,127,127);
		wall_direction := Down;
	END;
	
	WITH OBJ[76] DO
		kind := wall;
		pos := MPT(480.0,232.0,32.0);
                wall_height := 96.0;
		mycol := MRGB(114,114,114);
   		wall_direction := Down;
	END;

        WITH OBJ[77] DO
		kind := finish;
		pos := MPT(320.0,-16.0,0.0);
                calc_bb(77,pos.x-64.0,pos.y-16.0,pos.z,pos.x+64.0,pos.y+16.0,pos.z+32.0);
	END;

        WITH OBJ[78] DO
                kind := deco;
		pos := MPT(610.0,750.0,32.0);
                deco_sprite := S_tree;
                deco_sprite_subimg := 1;
                deco_sprite_no := 6;
                calc_bb(78, pos.x-12.0, pos.y-12.0, pos.z, pos.x+12.0, pos.y+12.0, pos.z+32.0);
                solid := TRUE;
        END;

        WITH OBJ[79] DO
		kind := healthbox;
		healthbox_size := FALSE;
		pos := MPT(320.0,454.0,32.0);
	END;

        WITH OBJ[80] DO
		kind := ammo;
		pos := MPT(448.0,160.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 1;
	END;


    |2:NOO:= 164;
        WITH OBJ[1] DO
		kind := camera;
		pos := MPT(256.0,2400.0,32.0);
                placed_direction:=Up;
	END;
	
	WITH OBJ[2] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(32.0,2560.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[3] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(96.0,2560.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Down;
	END;
	
	
	WITH OBJ[4] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(224.0,2560.0,32.0);
		mycol := MRGB(0,0,64);
		wall_direction := Down;
	END;	
		
        WITH OBJ[5] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(288.0,2560.0,32.0);
		mycol := MRGB(0,0,64);
		wall_direction := Down;
	END;
	
	WITH OBJ[6] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(352.0,2560.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Down;
	END;
	
	WITH OBJ[7] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(416.0,2560.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	
 FOR i := 0 TO 16 DO
	 WITH OBJ[2*i+8] DO
	 	 kind := wall;
		 wall_height := 96.0;
		 pos := MPT(512.0,2528.0-FLOAT(2*i)*64,32.0);
		 mycol := MRGB(134,75,51);
		 wall_direction := Left;
	 END;
	
	 WITH OBJ[2*i+9] DO
		 kind := wall;
		 wall_height := 96.0;
		 pos := MPT(512.0,2528.0-FLOAT(2*i+1)*64,32.0);
		 mycol := MRGB(159,81,57);
		 wall_direction := Left;
	 END;
 END;

 FOR i:= 0 TO 16 DO
        WITH OBJ[2*i+42] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(0.0,2528.0-FLOAT(2*i)*64,32.0);
		mycol := MRGB(134,75,51);
		wall_direction := Right;
	END;
	
	WITH OBJ[2*i+43] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(0.0,2528.0-FLOAT(2*i+1)*64,32.0);
		mycol := MRGB(159,81,57);
		wall_direction := Right;
	END;
 END;

        WITH OBJ[76] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(32.0,384.0,32.0);
		mycol := MRGB(134,75,51);
		wall_direction := Up;
	END;
	
	WITH OBJ[77] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(96.0,384.0,32.0);
		mycol := MRGB(159,81,57);
		wall_direction := Up;
	END;
	
	
	WITH OBJ[78] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(416.0,384.0,32.0);
		mycol := MRGB(159,81,57);
		wall_direction := Up;
	END;
	
	WITH OBJ[79] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(480.0,384.0,32.0);
		mycol := MRGB(134,75,51);
		wall_direction := Up;
	END;
	
 FOR i := 0 TO 2 DO
	 WITH OBJ[2*i+80] DO
	 	 kind := wall;
		 wall_height := 96.0;
		 pos := MPT(384.0,352.0-FLOAT(2*i)*64,32.0);
		 mycol := MRGB(134,75,51);
		 wall_direction := Left;
	 END;
	
	 WITH OBJ[2*i+81] DO
		 kind := wall;
		 wall_height := 96.0;
		 pos := MPT(384.0,352.0-FLOAT(2*i+1)*64,32.0);
		 mycol := MRGB(159,81,57);
		 wall_direction := Left;
	 END;
 END;

 FOR i:= 0 TO 2 DO
        WITH OBJ[2*i+86] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(128.0,352.0-FLOAT(2*i)*64,32.0);
		mycol := MRGB(134,75,51);
		wall_direction := Right;
	END;
	
	WITH OBJ[2*i+87] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(128.0,352.0-FLOAT(2*i+1)*64,32.0);
		mycol := MRGB(159,81,57);
		wall_direction := Right;
	END;
 END;
	
	WITH OBJ[92] DO
	        kind := deco;
		pos := MPT(480.0,2400.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(92,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[93] DO
	        kind := deco;
		pos := MPT(30.0,2450.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 1;
		deco_sprite_no := 6;
		calc_bb(93,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[94] DO
	        kind := deco;
		pos := MPT(440.0,2300.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 2;
		deco_sprite_no := 6;
		calc_bb(94,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[95] DO
	        kind := deco;
		pos := MPT(60.0,2200.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(95,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[96] DO
	        kind := deco;
		pos := MPT(400.0,2100.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(96,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[97] DO
	        kind := deco;
		pos := MPT(30.0,2050.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 1;
		deco_sprite_no := 6;
		calc_bb(97,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[98] DO
	        kind := deco;
		pos := MPT(180.0,1950.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 1;
		deco_sprite_no := 6;
		calc_bb(98,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[99] DO
	        kind := deco;
		pos := MPT(350.0,1800.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 2;
		deco_sprite_no := 6;
		calc_bb(99,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[100] DO
	        kind := deco;
		pos := MPT(380.0,1700.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(100,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[101] DO
	        kind := deco;
		pos := MPT(50.0,1650.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 2;
		deco_sprite_no := 6;
		calc_bb(101,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[102] DO
	        kind := deco;
		pos := MPT(150.0,1550.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(102,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[103] DO
	        kind := deco;
		pos := MPT(250.0,1450.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 1;
		deco_sprite_no := 6;
		calc_bb(103,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[104] DO
	        kind := deco;
		pos := MPT(50.0,1350.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 2;
		deco_sprite_no := 6;
		calc_bb(104,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[105] DO
	        kind := deco;
		pos := MPT(270.0,1250.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(105,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[106] DO
	        kind := deco;
		pos := MPT(450.0,1000.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(106,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[107] DO
	        kind := deco;
		pos := MPT(300.0,850.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 1;
		deco_sprite_no := 6;
		calc_bb(107,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[108] DO
	        kind := deco;
		pos := MPT(150.0,600.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(108,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[109] DO
	        kind := deco;
		pos := MPT(350.0,500.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(109,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[110] DO
	        kind := deco;
		pos := MPT(80.0,450.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 2;
		deco_sprite_no := 6;
		calc_bb(110,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[111] DO
	        kind := deco;
		pos := MPT(336.0,450.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 1;
		deco_sprite_no := 6;
		calc_bb(111,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[112] DO
	        kind := deco;
		pos := MPT(69.0,69.0,32.0);
		deco_sprite := S_tree;
		deco_sprite_subimg := 0;
		deco_sprite_no := 6;
		calc_bb(112,pos.x-6.0, pos.y-6.0, pos.z, pos.x+6.0, pos.y+6.0, pos.z+32.0);
		solid:= TRUE;
        END;
	
	WITH OBJ[113] DO
		kind := maan;
	END;
	
	WITH OBJ[114] DO
		kind := MainFloor;
		mycol := MRGB(0,96,0);
                veraf := FALSE;
	END;
	
	WITH OBJ[115] DO
		kind := tower;
		pos := MPT(256.0,-464.0,0.0);
		mycol := MRGB(96,96,96);
        END;
	
	WITH OBJ[116] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(160.0,2560.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Down;
	END;
	
	WITH OBJ[117] DO
		kind := wall;
		wall_height := 96.0;
		pos := MPT(480.0,2560.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[118] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(150.0,2100.0,24.0);
	END;
	
	WITH OBJ[119] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(350.0,2100.0,24.0);
	END;
	
	WITH OBJ[120] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(250.0,1975.0,24.0);
	END;
	
	WITH OBJ[121] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(450.0,1825.0,24.0);
	END;
	
	WITH OBJ[122] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(85.0,1800.0,24.0);
	END;
	
	WITH OBJ[123] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(275.0,1800.0,24.0);
	END;
	
	WITH OBJ[124] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(175.0,1750.0,24.0);
	END;
	
	WITH OBJ[125] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(300.0,1720.0,24.0);
	END;
	
	WITH OBJ[126] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(95.0,1680.0,24.0);
	END;
	
	WITH OBJ[127] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(210.0,1650.0,24.0);
	END;
	
	WITH OBJ[128] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(320.0,1600.0,24.0);
	END;
	
	WITH OBJ[129] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(150.0,1500.0,24.0);
	END;
	
	WITH OBJ[130] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(60.0,1450.0,24.0);
	END;
	
	WITH OBJ[131] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(150.0,1450.0,24.0);
	END;
	
	WITH OBJ[132] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(400.0,1375.0,24.0);
	END;
	
	WITH OBJ[133] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(175.0,1300.0,24.0);
	END;
	
	WITH OBJ[134] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(365.0,1200.0,24.0);
	END;
	
	WITH OBJ[135] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(126.0,1150.0,24.0);
	END;
	
	WITH OBJ[136] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(188.0,1100.0,24.0);
	END;
	
	WITH OBJ[137] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(350.0,1100.0,24.0);
	END;
	
	WITH OBJ[138] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(185.0,1050.0,24.0);
	END;
	
	WITH OBJ[139] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(110.0,1000.0,24.0);
	END;
	
	WITH OBJ[140] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(310.0,900.0,24.0);
	END;
	
	WITH OBJ[141] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(150.0,950.0,24.0);
	END;
	
	WITH OBJ[142] DO
		kind := monster;
                monster_kind := Rode_Zombie;
		pos := MPT(200.0,500.0,24.0);
	END;
	
	WITH OBJ[143] DO
		kind := monster;
                monster_kind := Rode_Zombie;
		pos := MPT(250.0,500.0,24.0);
	END;
	
	WITH OBJ[144] DO
		kind := monster;
                monster_kind := Rode_Zombie;
		pos := MPT(300.0,500.0,24.0);
	END;
	
	WITH OBJ[145] DO
		kind := monster;
                monster_kind := Rode_Zombie;
		pos := MPT(275.0,400.0,24.0);
	END;
	
	WITH OBJ[146] DO
		kind := monster;
                monster_kind := Rode_Zombie;
		pos := MPT(225.0,400.0,24.0);
	END;
	
	
	WITH OBJ[147] DO
		kind := ammo;
		pos := MPT(50.0,1925.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 2;
	END;
		
	WITH OBJ[148] DO
		kind := ammo;
		pos := MPT(35.0,1900.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 2;
	END;
		
	WITH OBJ[149] DO
		kind := healthbox;
		healthbox_size := FALSE;
		pos := MPT(65.0,1890.0,32.0);
	END;
	
	
	WITH OBJ[150] DO
		kind := ammo;
		pos := MPT(450.0,1600.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 2;
	END;
		
	WITH OBJ[151] DO
		kind := wapenitem;
		pos := MPT(450.0,900.0,20.0);
		wapen_type := W_shotgun;
	END;
		
        WITH OBJ[152] DO
		kind := ammo;
		pos := MPT(475.0,875.0,24.0);
                ammo_type := W_shotgun;
                ammo_size := 3;
	END;
		
	WITH OBJ[153] DO
		kind := healthbox;
		healthbox_size := TRUE;
		pos := MPT(425.0,850.0,32.0);
	END;
	
	WITH OBJ[154] DO
		kind := blok;
		pos := MPT(50.0,1990.0,16.0);
		mycol := MRGB(142,132,89);
	END;
	
	WITH OBJ[155] DO
		kind := blok;
		pos := MPT(98.0,1985.0,16.0);
		mycol := MRGB(142,132,89);
	END;
	
	WITH OBJ[156] DO
		kind := blok;
		pos := MPT(55.0,1860.0,16.0);
		mycol := MRGB(142,132,89);
	END;
	
	WITH OBJ[157] DO
		kind := blok;
		pos := MPT(103.0,1855.0,16.0);
		mycol := MRGB(142,132,89);
	END;
	
	WITH OBJ[158] DO
		kind := blok;
		pos := MPT(430.0,800.0,16.0);
		mycol := MRGB(142,132,89);
	END;
	
	WITH OBJ[159] DO
		kind := blok;
		pos := MPT(478.0,800.0,16.0);
		mycol := MRGB(142,132,89);
	END;
	
	WITH OBJ[160] DO
		kind := blok;
		pos := MPT(454.0,800.0,48.0);
		mycol := MRGB(142,132,89);
	END;
	
	WITH OBJ[161] DO
		kind := blok;
		pos := MPT(430.0,950.0,16.0);
		mycol := MRGB(142,132,89);
	END;
	
	WITH OBJ[162] DO
		kind := blok;
		pos := MPT(478.0,950.0,16.0);
		mycol := MRGB(142,132,89);
	END;

        WITH OBJ[163] DO
		kind := finish;
		pos := MPT(256.0,-16.0,0.0);
                calc_bb(163,pos.x-64.0,pos.y-16.0,pos.z,pos.x+64.0,pos.y+16.0,pos.z+32.0);
	END;

        WITH OBJ[164] DO
		kind := ammo;
		pos := MPT(50.0,800.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 3;
	END;
	
	
   |3: NOO := 158;

	WITH OBJ[1] DO
		kind := camera;
		pos := MPT(320.0,1180.0,32.0);
                placed_direction:=Up;
	END;
	
	WITH OBJ[2] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(32.0,1216.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[3] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(96.0,1216.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Down;
	END;
	
	WITH OBJ[4] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(160.0,1216.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Down;
	END;
	
	WITH OBJ[5] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(224.0,1216.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;	
	
	
	WITH OBJ[6] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(288.0,1280.0,32.0);
		mycol := MRGB(0,0,64);
		wall_direction := Down;
	END;	
		
        WITH OBJ[7] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(352.0,1280.0,32.0);
		mycol := MRGB(0,0,64);
		wall_direction := Down;
	END;
	
	WITH OBJ[8] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(416.0,1216.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;	
	
	WITH OBJ[9] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(480.0,1216.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Down;
	END;
	
	WITH OBJ[10] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(544.0,1216.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[11] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(608.0,1216.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[12] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(256.0,1248.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[13] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(384.0,1248.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[14] DO
		kind := MainFloor;
		mycol := MRGB(150,136,41);
                veraf := FALSE;
	END;
	
	WITH OBJ[15] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(192.0,1184.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[16] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(192.0,1120.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[17] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(192.0,1056.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[18] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(128.0,1184.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[19] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(128.0,1120.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[20] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(128.0,1056.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[21] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(160.0,1024.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[22] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(96.0,1024.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[23] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(64.0,1056.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[24] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(96.0,1088.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
    FOR i:= 0 TO 4 DO
        WITH OBJ[2*i+25] DO
		kind := wall;
		pos := MPT(0.0,1184.0-FLOAT(2*i)*64,32.0);
                wall_height := 128.0;
		mycol := MRGB(159,81,57);
		wall_direction := Right;
	END;
	
	WITH OBJ[2*i+26] DO
		kind := wall;
		pos := MPT(0.0,1184.0-FLOAT(2*i+1)*64,32.0);
                wall_height := 128.0;
		mycol := MRGB(134,75,51);
		wall_direction := Right;
	END;
     END;

     FOR i:= 0 TO 4 DO
        WITH OBJ[2*i+35] DO
		kind := wall;
		pos := MPT(640.0,1184.0-FLOAT(2*i)*64,32.0);
                wall_height := 128.0;
		mycol := MRGB(134,75,51);
		wall_direction := Left;
	END;
	
	WITH OBJ[2*i+36] DO
		kind := wall;
		pos := MPT(640.0,1184.0-FLOAT(2*i+1)*64,32.0);
                wall_height := 128.0;
		mycol := MRGB(159,81,57);
		wall_direction := Left;
	END;
     END;

        WITH OBJ[45] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(512.0,1184.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[46] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(512.0,1120.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[47] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(512.0,1056.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[48] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(448.0,1184.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[49] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(448.0,1120.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[50] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(448.0,1056.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[51] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(480.0,1024.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[52] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(544.0,1024.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[53] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(576.0,1056.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[54] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(544.0,1088.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[55] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(32.0,640.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[56] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(96.0,640.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Up;
	END;
	
	WITH OBJ[57] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(160.0,640.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Up;
	END;
	
	WITH OBJ[58] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(224.0,640.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[59] DO
		kind := schuifdeur;
		pos := MPT(320.0,640.0,32.0);
		mycol := MRGB(153,2,6);
        END;

	
			
        WITH OBJ[60] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(416.0,640.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;	
	
	WITH OBJ[61] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(480.0,640.0,32.0);
		mycol := MRGB(110,110,110);
		wall_direction := Up;
	END;
	
	WITH OBJ[62] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(544.0,640.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[63] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(608.0,640.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[64] DO
		kind := healthbox;
		healthbox_size := TRUE;
		pos := MPT(576.0,1152.0,32.0);
	END;
	
	WITH OBJ[65] DO
		kind := ammo;
		pos := MPT(64.0,1152.0,24.0);
                ammo_type := W_shotgun;
                ammo_size := 2;
	END;
	
	WITH OBJ[66] DO
		kind := ammo;
		pos := MPT(64.0,1122.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 2;
	END;
	
	WITH OBJ[67] DO
		kind := ammo;
		pos := MPT(320.0,600.0,24.0);
                ammo_type := W_uzi;
                ammo_size := 3;
	END;
	
	WITH OBJ[68] DO
		kind := wapenitem;
		pos := MPT(320.0,550.0,20.0);
		wapen_type := W_uzi;
	END;
	
        WITH OBJ[69] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(64.0,704.0,24.0);
	END;	
	
	WITH OBJ[70] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(256.0,608.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[71] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(256.0,544.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
		END;
		
	WITH OBJ[72] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(256.0,480.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[73] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(256.0,416.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Right;
	END;
	
	WITH OBJ[74] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(384.0,608.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[75] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(384.0,544.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Left;
	END;
	
	WITH OBJ[76] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(288.0,384.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[77] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(352.0,384.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[78] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(416.0,384.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[79] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(416.0,512.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[80] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(480.0,512.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[81] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(544.0,512.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[82] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(608.0,512.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
    FOR i := 0 TO 3 DO
	 WITH OBJ[2*i+83] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(640.0,480.0-FLOAT(2*i)*64,32.0);
		 mycol := MRGB(134,75,51);
		 wall_direction := Left;
	 END;
	
	 WITH OBJ[2*i+84] DO
		 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(640.0,480.0-FLOAT(2*i+1)*64,32.0);
		 mycol := MRGB(159,81,57);
		 wall_direction := Left;
	 END;
    END;

    FOR i:= 0 TO 1 DO
        WITH OBJ[2*i+91] DO
		kind := wall;
		pos := MPT(448.0,352.0-FLOAT(2*i)*64,32.0);
                wall_height := 128.0;
		mycol := MRGB(159,81,57);
		wall_direction := Right;
	END;
	
	WITH OBJ[2*i+92] DO
		kind := wall;
		pos := MPT(448.0,352.0-FLOAT(2*i+1)*64,32.0);
                wall_height := 128.0;
		mycol := MRGB(134,75,51);
		wall_direction := Right;
	END;
     END;

     FOR i := 0 TO 4 DO
	 WITH OBJ[2*i+95] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(608.0-FLOAT(2*i)*64,0.0,32.0);
		 mycol := MRGB(134,75,51);
		 wall_direction := Up;
	 END;
	
	 WITH OBJ[2*i+96] DO
		 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(608.0-FLOAT(2*i+1)*64,0.0,32.0);
		 mycol := MRGB(159,81,57);
		 wall_direction := Up;
	 END;
    END;


    FOR i := 0 TO 2 DO
	 WITH OBJ[2*i+105] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(480.0-FLOAT(2*i)*64,128.0,32.0);
		 mycol := MRGB(134,75,51);
		 wall_direction := Down;
	 END;
	
	 WITH OBJ[2*i+106] DO
		 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(480.0-FLOAT(2*i+1)*64,128.0,32.0);
		 mycol := MRGB(159,81,57);
		 wall_direction := Down;
	 END;
    END;

    FOR i := 0 TO 3 DO
	 WITH OBJ[2*i+111] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(0.0,480.0-FLOAT(2*i)*64,32.0);
		 mycol := MRGB(134,75,51);
		 wall_direction := Right;
	 END;
	
	 WITH OBJ[2*i+112] DO
		 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(0.0,480.0-FLOAT(2*i+1)*64,32.0);
		 mycol := MRGB(159,81,57);
		 wall_direction := Right;
	 END;
    END;

    FOR i := 0 TO 2 DO
	 WITH OBJ[2*i+119] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(128.0,480.0-FLOAT(2*i)*64,32.0);
		 mycol := MRGB(134,75,51);
		 wall_direction := Left;
	 END;
	
	 WITH OBJ[2*i+120] DO
		 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(128.0,480.0-FLOAT(2*i+1)*64,32.0);
		 mycol := MRGB(159,81,57);
		 wall_direction := Left;
	 END;
    END;

         WITH OBJ[125] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(32.0,512.0,32.0);
		 mycol := MRGB(0,20,40);
		 wall_direction := Down;
	 END;
								
	 WITH OBJ[126] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(96.0,512.0,32.0);
		 mycol := MRGB(0,20,40);
		 wall_direction := Down;
	 END;

         WITH OBJ[127] DO
                 kind := lamp;
                 pos := MPT(64.0,1132.0,100.0);
                 kapot:=FALSE;
                 mijnlampno := 1;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[128] DO
                 kind := lamp;
                 pos := MPT(64.0,704.0,100.0);
                 kapot:=FALSE;
                 mijnlampno := 2;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[129] DO
                 kind := lamp;
                 pos := MPT(574.0,704.0,100.0);
                 kapot:=TRUE;
                 mijnlampno := 3;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[130] DO
                 kind := lamp;
                 pos := MPT(320.0,1132.0,100.0);
                 kapot:=FALSE;
                 mijnlampno := 4;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[131] DO
                 kind := lamp;
                 pos := MPT(576.0,1132.0,100.0);
                 kapot:=FALSE;
                 mijnlampno := 5;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[132] DO
                 kind := lamp;
                 pos := MPT(320.0,608.0,100.0);
                 kapot:=FALSE;
                 mijnlampno := 6;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[133] DO
                 kind := lamp;
                 pos := MPT(576.0,480.0,100.0);
                 kapot:=FALSE;
                 mijnlampno := 7;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[134] DO
                 kind := lamp;
                 pos := MPT(576.0,32.0,100.0);
                 kapot:=FALSE;
                 mijnlampno := 8;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[135] DO
                 kind := lamp;
                 pos := MPT(64.0,470.0,100.0);
                 kapot:=FALSE;
                 mijnlampno := 9;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[136] DO
                 kind := lamp;
                 pos := MPT(64.0,32.0,100.0);
                 kapot:=TRUE;
                 mijnlampno := 10;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;

         WITH OBJ[137] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(600.0,50.0,24.0);
	 END;
	
	 WITH OBJ[138] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(560.0,100.0,24.0);
	 END;
	
	 WITH OBJ[139] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(510.0,150.0,24.0);
	END;
	
	WITH OBJ[140] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(560.0,200.0,24.0);
	END;
        	
	 WITH OBJ[141] DO
		kind := valpijlen;
		pos := MPT(435.0,430.0,32.0);
                valpijlen_kant := FALSE;
                calc_bb(141, pos.x-48.0, pos.y-64.0, pos.z-32.0, pos.x+48.0, pos.y+64.0, pos.z+32.0);
	 END;
	
	 WITH OBJ[142] DO
		kind := valpijlen;
		pos := MPT(435.0,50.0,32.0);
                valpijlen_kant := FALSE;
                calc_bb(142, pos.x-64.0, pos.y-64.0, pos.z-32.0, pos.x+64.0, pos.y+64.0, pos.z+32.0);
	 END;
	
	 WITH OBJ[143] DO
		kind := valpijlen;
		pos := MPT(235.0,50.0,32.0);
                valpijlen_kant := FALSE;
                calc_bb(143, pos.x-64.0, pos.y-64.0, pos.z-32.0, pos.x+64.0, pos.y+64.0, pos.z+32.0);
	 END;
	
	 WITH OBJ[144] DO
		kind := wapenitem;
		pos := MPT(64.0,350.0,20.0);
		wapen_type := W_bazooka;
	 END;
	
	 WITH OBJ[145] DO
		kind := healthbox;
		healthbox_size := FALSE;
		pos := MPT(64.0,250.0,32.0);
	 END;
	
	 WITH OBJ[146] DO
		kind := ammo;
		pos := MPT(64.0,450.0,24.0);
                ammo_type := W_uzi;
                ammo_size := 3;
	 END;
	
	 WITH OBJ[147] DO
		kind := ammo;
		pos := MPT(64.0,150.0,24.0);
                ammo_type := W_shotgun;
                ammo_size := 3;
	 END;

         WITH OBJ[148] DO
		kind := monster;
                monster_kind := Rode_Zombie;
		pos := MPT(600.0,704.0,24.0);
	 END;

         WITH OBJ[149] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(610.0,920.0,24.0);
	 END;

         WITH OBJ[150] DO
		kind := monster;
                monster_kind := Groene_Zombie;
		pos := MPT(220.0,800.0,24.0);
	 END;

         WITH OBJ[151] DO
		kind := ammo;
		pos := MPT(620.0,1128.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 3;
	 END;

         WITH OBJ[152] DO
		kind := ammo;
		pos := MPT(320.0,1000.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 1;
	 END;

         WITH OBJ[153] DO
		kind := finish;
		pos := MPT(64.0,486.0,0.0);
                calc_bb(153,pos.x-30.0,pos.y-16.0,pos.z,pos.x+30.0,pos.y+16.0,pos.z+32.0);
	 END;

	WITH OBJ[154] DO
		kind := tafel;
		pos := MPT(540.0,690.0,20.0);
		mycol := MRGB(156,90,90);
	END;

        WITH OBJ[155] DO
		kind := stoel;
		pos := MPT(490.0,690.0,12.0);
		mycol := MRGB(140,122,80);
	END;

	WITH OBJ[156] DO
		kind := tafel;
		pos := MPT(120.0,690.0,20.0);
		mycol := MRGB(156,90,90);
	END;

	WITH OBJ[157] DO
		kind := kruk;
		pos := MPT(120.0,730.0,10.0);
		mycol := MRGB(156,90,90);
	END;

	WITH OBJ[158] DO
		kind := kruk;
		pos := MPT(576.0,1152.0,10.0);
		mycol := MRGB(156,90,90);
	END;


     |4: NOO := 184;

        WITH OBJ[1] DO
		kind := camera;
		pos := MPT(72.0,2450.0,32.0);
                placed_direction:= Up;
	END;
	
	WITH OBJ[2] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(32.0,2560.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[3] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(96.0,2560.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
	WITH OBJ[4] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(160.0,2560.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Down;
	END;
	
     FOR i := 0 TO 23 DO
	WITH OBJ[2*i+5] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(0.0,2528.0-FLOAT(2*i)*64,32.0);
		 IF i<9 THEN mycol := MRGB(79,107,12);
                 ELSIF i<17 THEN mycol := MRGB(4,94,136);
                 ELSE mycol := MRGB(230,36,80); END;
		 wall_direction := Right;
	END;
	
	WITH OBJ[2*i+6] DO
		 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(0.0,2528.0-FLOAT(2*i+1)*64,32.0);
                 IF i<9 THEN mycol := MRGB(46,63,7);
                 ELSIF i<17 THEN mycol := MRGB(5,123,180);
                 ELSE mycol := MRGB(189,21,60); END;
		 wall_direction := Right;
        END;
     END;

     FOR i := 0 TO 23 DO
	 WITH OBJ[2*i+53] DO
	 	 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(192.0,2528.0-FLOAT(2*i)*64,32.0);
		 IF i<9 THEN mycol := MRGB(79,107,12);
                 ELSIF i<17 THEN mycol := MRGB(4,94,136);
                 ELSE mycol := MRGB(230,36,80); END;
		 wall_direction := Left;
	 END;
	
	 WITH OBJ[2*i+54] DO
		 kind := wall;
		 wall_height := 128.0;
		 pos := MPT(192.0,2528.0-FLOAT(2*i+1)*64,32.0);
                 IF i<9 THEN mycol := MRGB(46,63,7);
                 ELSIF i<17 THEN mycol := MRGB(5,123,180);
                 ELSE mycol := MRGB(189,21,60); END;
		 wall_direction := Left;
	 END;
     END;

         WITH OBJ[101] DO
		kind := MainFloor;
		mycol := MRGB(120,30,50);
                veraf := FALSE;
	 END;
	
      FOR i:=0 TO 25 DO
        WITH OBJ[102+i] DO
		kind := spietsen;
		pos := MPT(30.0+FLOAT(i MOD 2)*56,750.0+FLOAT(i DIV 2)*128,0.0);
                mycol := MRGB(154,5,28);
	END;
     END;

     FOR i:=0 TO 25 DO
        WITH OBJ[128+i] DO
		kind := spietsen;
		pos := MPT(90.0+FLOAT(i MOD 2)*56,800.0+FLOAT(i DIV 2)*128,0.0);
                mycol := MRGB(154,5,10);
	END;
     END;

        WITH OBJ[154] DO
		kind := valbal;
		pos := MPT(48.0,500.0,100.0);
                valbal_richting:=Down;
                valbal_maxtimer:=390;
                valbal_delay:=0;
                mycol:=MRGB(192,160,64);
	END;
	
	WITH OBJ[155] DO
		kind := valbal;
		pos := MPT(90.0,650.0,100.0);
                valbal_richting:=Down;
                valbal_maxtimer:=390;
                valbal_delay:=100;
                mycol:=MRGB(192,160,64);
		
	END;
	
	WITH OBJ[156] DO
		kind := valbal;
		pos := MPT(140.0,600.0,100.0);
                valbal_richting:=Down;
                valbal_maxtimer:=390;
                valbal_delay:=50;
                mycol:=MRGB(192,160,64);
		
	END;

        WITH OBJ[157] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(60.0,250.0,24.0);
	END;
	
	WITH OBJ[158] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(140.0,300.0,24.0);
	END;
	
	WITH OBJ[159] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(110.0,370.0,24.0);
	END;
	
	WITH OBJ[160] DO
		kind := monster;
                monster_kind := Troll;
		pos := MPT(60.0,60.0,24.0);
	END;
	
	WITH OBJ[161] DO
		kind := monster;
                monster_kind := Mummy;
		pos := MPT(120.0,180.0,24.0);
	END;

        WITH OBJ[162] DO
		kind := finish;
		pos := MPT(320.0,-512.0,0.0);
                calc_bb(162,pos.x-320.0,pos.y-28.0,pos.z,pos.x+320.0,pos.y+28.0,pos.z+32.0);
	END;

	WITH OBJ[163] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(32.0,-512.0,32.0);
		mycol := MRGB(102,102,102);
		wall_direction := Up;
	END;
	
	WITH OBJ[164] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(96.0,-512.0,32.0);
		mycol := MRGB(24,24,24);
		wall_direction := Up;
	END;
	
	WITH OBJ[165] DO
		kind := wall;
		wall_height := 128.0;
		pos := MPT(160.0,-512.0,32.0);
		mycol := MRGB(24,24,24);
		wall_direction := Up;
	END;

    FOR i:=0 TO 12 DO
        WITH OBJ[166+i] DO
                 kind := lamp;
                 pos := MPT(96.0,2496.0-FLOAT(i)*246.0,100.0);
                 IF (i=3) OR (i=7) OR (i=9) THEN kapot:=TRUE ELSE kapot:=FALSE; END;
                 mijnlampno := i+1;
                 LIGHTARR[mijnlampno].lpos:=pos;
         END;
    END;

         WITH OBJ[179] DO
		kind := ammo;
		pos := MPT(64.0,-280.0,24.0);
                ammo_type := W_pistool;
                ammo_size := 3;
	 END;

         WITH OBJ[180] DO
		kind := ammo;
		pos := MPT(128.0,-280.0,24.0);
                ammo_type := W_uzi;
                ammo_size := 3;
	 END;

         WITH OBJ[181] DO
		kind := ammo;
		pos := MPT(64.0,-340.0,24.0);
                ammo_type := W_bazooka;
                ammo_size := 3;
	 END;

         WITH OBJ[182] DO
		kind := ammo;
		pos := MPT(128.0,-340.0,24.0);
                ammo_type := W_shotgun;
                ammo_size := 3;
	 END;

         WITH OBJ[183] DO
		kind := healthbox;
		healthbox_size := TRUE;
		pos := MPT(64.0,-310.0,24.0);
	 END;

         WITH OBJ[184] DO
		kind := healthbox;
		healthbox_size := TRUE;
		pos := MPT(128.0,-310.0,24.0);
	 END;
    		
    		
   |5: NOO := 6; (*aantal objecten *)
  	
	WITH OBJ[1] DO
		kind := camera;
		pos := MPT(100.0,384.0,32.0);
                placed_direction:=Right;
	END;

        WITH OBJ[2] DO
		kind := towertop;
                mycol := MRGB(96,96,96);
	END;

        WITH OBJ[3] DO
		kind := maan;
	END;
	
        WITH OBJ[4] DO
		kind := MainFloor;
                mycol := MRGB(16,96,16);
                veraf := TRUE;
	END;

        WITH OBJ[5] DO
		kind := weer;
	END;

        WITH OBJ[6] DO
		kind := draak;
		pos := MPT(868.0,384.0,-80.0);
        END;
	

 END;  (* CASE *)
END place_objects;

(* Standaard object beheerdeer *)
PROCEDURE object_monitor;

BEGIN
 IF level_begin THEN
  ClearScreen;
  SetFont(0, RgbColor(255,255,255));
  Text("LOADING... Please Wait.",SCREEN_WIDTH/2-50,SCREEN_HEIGHT/2-8);
  UpdateWindow;
  Lighteffects:=LED[current_level];
  place_objects(current_level);
  IF net_game_over THEN net_game_over:=FALSE;
  ELSE sprite_data(TRUE,current_level); END;
  level_begin:=FALSE;
  creation_event(0);
  OBJ[cam_pos_obj].weaponcarrying:=W_vuist;
 END;

 continuous_event(0);
 Sort(25);
 drawing_event(0);
 show_message;

END object_monitor;

(*=======================================*)
(* MISC : Nog Andere Nuttige Procedures  *)
(*=======================================*)

(* "Slimme Delay". Verkort de delay wanneer nodig om lag te vermijden. *)
PROCEDURE SmartDelay(x:CARDINAL);
BEGIN
  GetLocalTime( time2 );
  IF time1.wSecond=time2.wSecond THEN
   mydelay:=time2.wMilliseconds-time1.wMilliseconds;
  ELSE
   mydelay:=time2.wMilliseconds+1000-time1.wMilliseconds;
  END;
  IF mydelay<x THEN Delay(x-mydelay); END;
  GetLocalTime( time1 );
  general_timer := general_timer+1; IF general_timer = 60 THEN general_timer := 0; END;
  (* WrCard(mydelay,0);WrLn; *)  (* fps test *)
END SmartDelay;

PROCEDURE ini_parameters;
 BEGIN

  NOO:=0;
  BPUNT:=MPT(1.0E20,1.0E20,1.0E20);
  LIGHTARR[0].lpos:=MPT(0.0,0.0,0.0);
  LIGHTARR[0].on:=FALSE;
  Lighteffects:=FALSE;
  net_game_over:=FALSE;

  LED[0]:=FALSE;
  LED[1]:=FALSE;
  LED[2]:=FALSE;
  LED[3]:=TRUE; NOL[3]:=10;
  LED[4]:=TRUE; NOL[4]:=13;
  LED[5]:=FALSE;

  weaponposessing[W_shotgun]:=FALSE;
  weaponposessing[W_uzi]:=FALSE;
  weaponposessing[W_bazooka]:=FALSE;

  no_of_bullets[W_pistool]:=0;
  no_of_bullets[W_shotgun]:=0;
  no_of_bullets[W_uzi]:=0;
  no_of_bullets[W_bazooka]:=0;
  no_of_sleutels:=0;

  weapondelays[W_vuist]:=20;
  weapondelays[W_pistool]:=6;
  weapondelays[W_shotgun]:=18;
  weapondelays[W_uzi]:=2;
  weapondelays[W_bazooka]:=100;

  bullets_in_new_weapon[W_pistool]:=24;
  bullets_in_new_weapon[W_shotgun]:=12;
  bullets_in_new_weapon[W_uzi]:=60;
  bullets_in_new_weapon[W_bazooka]:=3;

  bullets_in_mun_box[1,W_pistool] := 12;
  bullets_in_mun_box[1,W_shotgun] := 6;
  bullets_in_mun_box[1,W_uzi]     := 30;
  bullets_in_mun_box[1,W_bazooka] := 1;
  bullets_in_mun_box[2,W_pistool] := 24;
  bullets_in_mun_box[2,W_shotgun] := 14;
  bullets_in_mun_box[2,W_uzi]     := 70;
  bullets_in_mun_box[2,W_bazooka] := 2;
  bullets_in_mun_box[3,W_pistool] := 50;
  bullets_in_mun_box[3,W_shotgun] := 30;
  bullets_in_mun_box[3,W_uzi]     := 150;
  bullets_in_mun_box[3,W_bazooka] := 5;

  level_limitsE[X,1] := 640.0;  level_limitsB[X,1] := 0.0;
  level_limitsE[Y,1] := 1024.0; level_limitsB[Y,1] := 0.0;
  level_limitsE[X,2] := 512.0;  level_limitsB[X,2] := 0.0;
  level_limitsE[Y,2] := 2560.0; level_limitsB[Y,2] := 0.0;
  level_limitsE[X,3] := 640.0;  level_limitsB[X,3] := 0.0;
  level_limitsE[Y,3] := 1280.0; level_limitsB[Y,3] := 0.0;
  level_limitsE[X,4] := 640.0;  level_limitsB[X,4] := 0.0;
  level_limitsE[Y,4] := 2560.0; level_limitsB[Y,4] := -512.0;
  level_limitsE[X,5] := 800.0;  level_limitsB[X,5] := -400.0;
  level_limitsE[Y,5] := 800.0;  level_limitsB[Y,5] := -400.0;

  sterren_array[0]:= MPT( 800.0,  400.0, 400.0);
  sterren_array[1]:= MPT(-600.0,  700.0, 200.0);
  sterren_array[2]:= MPT( 700.0,-1100.0, 900.0);
  sterren_array[3]:= MPT( 900.0,  300.0, 800.0);
  sterren_array[4]:= MPT( 200.0, -800.0, 700.0);
  sterren_array[5]:= MPT(-400.0, 1100.0, 600.0);
  sterren_array[6]:= MPT(1100.0,  400.0, 500.0);
  sterren_array[7]:= MPT(-900.0,  600.0, 400.0);
  sterren_array[8]:= MPT( 400.0, -200.0, 800.0);
  sterren_array[9]:= MPT(-100.0,  700.0, 700.0);
  sterren_array[10]:=MPT(-700.0, -600.0, 100.0);
  sterren_array[11]:=MPT( 400.0,  900.0, 900.0);
  sterren_array[12]:=MPT( 800.0, -500.0, 100.0);
  sterren_array[13]:=MPT( 500.0,  200.0, 600.0);
  sterren_array[14]:=MPT(-500.0, -400.0, 700.0);
  sterren_array[15]:=MPT( 700.0, -900.0, 700.0);
  sterren_array[16]:=MPT(-800.0,  400.0, 400.0);
  sterren_array[17]:=MPT( 600.0,  700.0, 100.0);
  sterren_array[18]:=MPT(-700.0,-1100.0, 900.0);
  sterren_array[19]:=MPT( 600.0, -300.0, 400.0);
  sterren_array[20]:=MPT(-200.0,  700.0, 700.0);
  sterren_array[21]:=MPT( 400.0,-1100.0, 600.0);
  sterren_array[22]:=MPT( 700.0,  500.0, 500.0);
  sterren_array[23]:=MPT(-900.0, -600.0, 400.0);
  sterren_array[24]:=MPT( 400.0,  300.0, 800.0);
  sterren_array[25]:=MPT(-100.0, -700.0, 200.0);
  sterren_array[26]:=MPT( 700.0, -600.0, 700.0);
  sterren_array[27]:=MPT(-400.0,  900.0, 300.0);
  sterren_array[28]:=MPT( 700.0, -500.0, 700.0);
  sterren_array[29]:=MPT( 600.0,  200.0, 600.0);
  sterren_array[30]:=MPT(-500.0,  600.0, 200.0);
  sterren_array[31]:=MPT( 900.0,  900.0, 700.0);

  monster_data[Groene_Zombie].Mmaxhp := 150;
  monster_data[Groene_Zombie].Msight := 250.0;
  monster_data[Groene_Zombie].Mwalkspeed := 2.5;
  monster_data[Groene_Zombie].Mpower := 10;
  monster_data[Groene_Zombie].Msubimg := 0;
  monster_data[Groene_Zombie].Msprite := S_zombie;
  monster_data[Groene_Zombie].Minvsprite := S_I_zombie;

  monster_data[Rode_Zombie].Mmaxhp := 250;
  monster_data[Rode_Zombie].Msight := 350.0;
  monster_data[Rode_Zombie].Mwalkspeed := 4.0;
  monster_data[Rode_Zombie].Mpower := 16;
  monster_data[Rode_Zombie].Msubimg := 1;
  monster_data[Rode_Zombie].Msprite := S_zombie;
  monster_data[Rode_Zombie].Minvsprite := S_I_zombie;

  monster_data[Tutorial_Zombie].Mmaxhp := 100;
  monster_data[Tutorial_Zombie].Msight := 200.0;
  monster_data[Tutorial_Zombie].Mwalkspeed := 1.0;
  monster_data[Tutorial_Zombie].Mpower :=  4;
  monster_data[Tutorial_Zombie].Msubimg := 2;
  monster_data[Tutorial_Zombie].Msprite := S_zombie;
  monster_data[Tutorial_Zombie].Minvsprite := S_I_zombie;

  monster_data[Mummy].Mmaxhp := 120;
  monster_data[Mummy].Msight := 400.0;
  monster_data[Mummy].Mwalkspeed := 5.0;
  monster_data[Mummy].Mpower := 5;
  monster_data[Mummy].Msubimg := 0;
  monster_data[Mummy].Msprite := S_mummy;
  monster_data[Mummy].Minvsprite := S_I_mummy;

  monster_data[Troll].Mmaxhp := 400;
  monster_data[Troll].Msight := 200.0;
  monster_data[Troll].Mwalkspeed := 1.5;
  monster_data[Troll].Mpower := 25;
  monster_data[Troll].Msubimg := 0;
  monster_data[Troll].Msprite := S_troll;
  monster_data[Troll].Minvsprite := S_I_troll;

  mountains_array[0][0]:=0;     mountains_array[2][0]:=0;       mountains_array[4][0]:=0;
  mountains_array[1][0]:=0;     mountains_array[3][0]:=0;       mountains_array[5][0]:=0;
  mountains_array[0][1]:=50;    mountains_array[2][1]:=60;      mountains_array[4][1]:=24;
  mountains_array[1][1]:=-60;   mountains_array[3][1]:=-132;    mountains_array[5][1]:=-101;
  mountains_array[0][2]:=90;    mountains_array[2][2]:=114;     mountains_array[4][2]:=44;
  mountains_array[1][2]:=-35;   mountains_array[3][2]:=-12;     mountains_array[5][2]:=-55;
  mountains_array[0][3]:=135;   mountains_array[2][3]:=145;     mountains_array[4][3]:=78;
  mountains_array[1][3]:=-94;   mountains_array[3][3]:=-43;     mountains_array[5][3]:=-84;
  mountains_array[0][4]:=160;   mountains_array[2][4]:=186;     mountains_array[4][4]:=100;
  mountains_array[1][4]:=-22;   mountains_array[3][4]:=-9;      mountains_array[5][4]:=-46;
  mountains_array[0][5]:=188;   mountains_array[2][5]:=211;     mountains_array[4][5]:=121;
  mountains_array[1][5]:=-38;   mountains_array[3][5]:=-41;     mountains_array[5][5]:=-99;
  mountains_array[0][6]:=225;   mountains_array[2][6]:=244;     mountains_array[4][6]:=147;
  mountains_array[1][6]:=0;     mountains_array[3][6]:=0;       mountains_array[5][6]:=0;
  mountains_array[0][7]:=0;     mountains_array[2][7]:=0;       mountains_array[4][7]:=0;
  mountains_array[1][7]:=0;     mountains_array[3][7]:=0;       mountains_array[5][7]:=0;


END ini_parameters;

(*====================================*)
(* INTRO : Introducties, menu's, e.d. *)
(*====================================*)

 PROCEDURE clicked(x,y:INTEGER);
 BEGIN
   IF (situatie=7) AND (x>=412) AND (x<=624) AND (y>=437) AND (y<=473) THEN
    situatie:=0; DrawBitmap(SPR1,0,0); DestroyBitmap(SPR2);
  ELSE
   IF    (x>=22) AND (x<=256) AND (y>=104) AND (y<=135) THEN situatie:=2; notquitted:=TRUE; parameter:=FALSE; weaponposessing[W_pistool]:=TRUE;
   ELSIF (x>=18) AND (x<=247) AND (y>=175) AND (y<=240) THEN situatie:=1; notquitted:=TRUE; parameter:=FALSE; weaponposessing[W_pistool]:=FALSE;
   ELSIF (x>=72) AND (x<=247) AND (y>=271) AND (y<=306) THEN situatie:=7; SPR2:=LoadBitmap("images\HELP_img.bmp",SCREEN_WIDTH,SCREEN_HEIGHT); DrawBitmap(SPR2,0,0);
   ELSIF (x>=67) AND (x<=180) AND (y>=342) AND (y<=390) THEN parameter:=FALSE; notquitted:=FALSE;
   END;
  END;
 END clicked;

PROCEDURE introductie;
BEGIN
 parameter:=TRUE; situatie:=0;
 SPR1:=LoadBitmap("images\START_img.bmp",SCREEN_WIDTH,SCREEN_HEIGHT);
 DrawBitmap(SPR1,0,0);

 OnMouseLeft(clicked);

 WHILE parameter DO END;

 DestroyBitmap(SPR1);
 StopOnMouseLeft;

END introductie;

(*===============================================================================*)
(* SPEL : Einde van de procedures. Begin van de uitvoeringen voor het programma. *)
(*===============================================================================*)


BEGIN
 Window("Dragon Hunter",SCREEN_WIDTH,SCREEN_HEIGHT);

introductie;
IF notquitted THEN
 ini_parameters;
 SetBuffering( TRUE );
 save_and_load(TRUE);
 goto_level(situatie); (* BIJ WELK LEVEL BEGONNEN MOET WORDEN *)

 LOOP
  ClearScreen;
  IF KeyDown( VK_ESCAPE ) OR NOT notquitted THEN EXIT END;
  object_monitor;
  UpdateWindow;
  SmartDelay(40);
 END;

 sprite_data(FALSE,current_level);
 dispose_obj_vars(0);
END;
 TextBox( "Bedankt voor het spelen !", "Tot ziens !" );

END Dragon_Hunter.